/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateCombine, enumGetBox, delegateRemove, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ButtonGroupOrientation_$type } from "./ButtonGroupOrientation";
import { ButtonGroupDisplayStyle_$type } from "./ButtonGroupDisplayStyle";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { ButtonGroupButtonCollection } from "./ButtonGroupButtonCollection";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonGroupSelectionChangedEventArgs } from "./ButtonGroupSelectionChangedEventArgs";
import { CornerRadius } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let ButtonGroupView = /*@__PURE__*/ (() => {
    class ButtonGroupView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.f = new List$1(Delegate_$type, 0);
            this.m = null;
            this.c = true;
            this.h = null;
            this.i = null;
            this.j = null;
            this.k = null;
        }
        s() {
        }
        d() {
            return true;
        }
        get l() {
            return this.h;
        }
        get y() {
            return null;
        }
        get e() {
            return true;
        }
        q(a) {
            if (a == null) {
                for (let b of fromEnum(this.f)) {
                    b();
                }
                this.f.clear();
            }
            this.g = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            let c = this.g.createElement("div");
            c.addClass("ig-button-content");
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("display", "flex");
            c.setStyleProperty("flex-direction", "row");
            c.setStyleProperty("flex-wrap", "no-wrap");
            c.setStyleProperty("align-items", "center");
            this.j = c;
            this.f.add(c.listen("click", runOn(this, this.n)));
            this.g.append(c);
            this.g.getPortal(c, "ChildContent", (d) => {
                let comp_ = d.componentRef;
                this.k = comp_;
                if (this.a.q == 0) {
                    this.j.setStyleProperty("flex-direction", "row");
                    comp_.display = 'flex';
                    comp_.flexDirection = 'row';
                }
                else {
                    this.j.setStyleProperty("flex-direction", "column");
                    comp_.display = 'flex';
                    comp_.flexDirection = 'column';
                }
            }, true);
            this.a.c8();
        }
        w(a) {
            if (this.m != a) {
                this.m = a;
                if (this.i != null) {
                    this.i.setAttribute("d", this.m);
                }
            }
        }
        v() {
            let comp_ = this.k;
            if (comp_ != null) {
                if (this.a.q == 0) {
                    this.j.setStyleProperty("flex-direction", "row");
                    comp_.display = 'flex';
                    comp_.flexDirection = 'row';
                }
                else {
                    this.j.setStyleProperty("flex-direction", "column");
                    comp_.display = 'flex';
                    comp_.flexDirection = 'column';
                }
            }
        }
        n(a) {
        }
        t() {
            if (this.d()) {
            }
        }
        p() {
            this.c = true;
        }
        r() {
            this.c = false;
            for (let a of fromEnum(this.f)) {
                a();
            }
            this.f.clear();
        }
        x(a) {
            if (a != null) {
                this.g.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        u(a) {
            if (this.a.q == 0) {
                a.f5 = "flex";
                a.g6 = "row";
                a.fp = "center";
            }
            else {
                a.f5 = "flex";
                a.g6 = "column";
                a.fp = "stretch";
            }
        }
        o(a) {
            this.j.append(a);
        }
    }
    ButtonGroupView.$t = /*@__PURE__*/ markType(ButtonGroupView, 'ButtonGroupView');
    return ButtonGroupView;
})();
/**
 * @hidden
 */
export let ButtonGroup = /*@__PURE__*/ (() => {
    class ButtonGroup extends Base {
        constructor() {
            super();
            this.n = 1;
            this.e = 0;
            this.i = 1;
            this.h = 1;
            this.a = new Array(0);
            this.t = false;
            this._view = null;
            this.aw = ThemeResolver.b(ButtonGroup.f, ButtonGroup.au, ButtonGroup.ao);
            this.gw = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gk, ButtonGroup.fk);
            this.gy = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gm, ButtonGroup.fm);
            this.gx = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gl, ButtonGroup.fl);
            this.gz = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gn, ButtonGroup.fn);
            this.av = ThemeResolver.b(ButtonGroup.f, ButtonGroup.at, ButtonGroup.an);
            this.g3 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gr, ButtonGroup.fr);
            this.g0 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.go, ButtonGroup.fo);
            this.g4 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gs, ButtonGroup.fs);
            this.g7 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gv, ButtonGroup.fv);
            this.g1 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gp, ButtonGroup.fp);
            this.g2 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gq, ButtonGroup.fq);
            this.g5 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gt, ButtonGroup.ft);
            this.g6 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gu, ButtonGroup.fu);
            this.aq = ThemeResolver.b(ButtonGroup.f, ButtonGroup.as, ButtonGroup.am);
            this.fw = ThemeResolver.e(ButtonGroup.f, ButtonGroup.f8, ButtonGroup.e8);
            this.fy = ThemeResolver.e(ButtonGroup.f, ButtonGroup.ga, ButtonGroup.fa);
            this.fx = ThemeResolver.e(ButtonGroup.f, ButtonGroup.f9, ButtonGroup.e9);
            this.fz = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gb, ButtonGroup.fb);
            this.ap = ThemeResolver.b(ButtonGroup.f, ButtonGroup.ar, ButtonGroup.al);
            this.f3 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gf, ButtonGroup.ff);
            this.f0 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gc, ButtonGroup.fc);
            this.f4 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gg, ButtonGroup.fg);
            this.f7 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gj, ButtonGroup.fj);
            this.f1 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gd, ButtonGroup.fd);
            this.f2 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.ge, ButtonGroup.fe);
            this.f5 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gh, ButtonGroup.fh);
            this.f6 = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gi, ButtonGroup.fi);
            this.ac = ThemeResolver.b(ButtonGroup.f, ButtonGroup.au, ButtonGroup.ao);
            this.dj = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gk, ButtonGroup.fk);
            this.dl = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gm, ButtonGroup.fm);
            this.dr = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gr, ButtonGroup.fr);
            this.dn = ThemeResolver.e(ButtonGroup.f, ButtonGroup.go, ButtonGroup.fo);
            this.dk = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gl, ButtonGroup.fl);
            this.dm = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gn, ButtonGroup.fn);
            this.ab = ThemeResolver.b(ButtonGroup.f, ButtonGroup.at, ButtonGroup.an);
            this.ds = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gs, ButtonGroup.fs);
            this.dv = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gv, ButtonGroup.fv);
            this.dp = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gp, ButtonGroup.fp);
            this.dq = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gq, ButtonGroup.fq);
            this.dt = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gt, ButtonGroup.ft);
            this.du = ThemeResolver.e(ButtonGroup.f, ButtonGroup.gu, ButtonGroup.fu);
            this.ag = NaN;
            this.d4 = null;
            this.d6 = null;
            this.eb = null;
            this.d8 = null;
            this.d9 = null;
            this.d5 = null;
            this.d7 = null;
            this.af = NaN;
            this.ea = null;
            this.es = null;
            this.ev = null;
            this.et = null;
            this.eu = null;
            this.ai = NaN;
            this.ec = null;
            this.ee = null;
            this.ej = null;
            this.eg = null;
            this.eh = null;
            this.ed = null;
            this.ef = null;
            this.ah = NaN;
            this.ei = null;
            this.eo = null;
            this.er = null;
            this.ep = null;
            this.eq = null;
            this.ae = NaN;
            this.dw = null;
            this.dy = null;
            this.d3 = null;
            this.d0 = null;
            this.d1 = null;
            this.dx = null;
            this.dz = null;
            this.ad = NaN;
            this.d2 = null;
            this.ek = null;
            this.en = null;
            this.el = null;
            this.em = null;
            this.p = 0;
            this.a4 = "ig-buttongroup-" + ButtonGroup.a3++;
            this.v = false;
            this.u = false;
            this.w = false;
            this.propertyChanged = null;
            this.l = new ButtonGroupButtonCollection();
            this.selectionChanged = null;
            let a = new ButtonGroupView();
            a.a = this;
            this.view = a;
            this.view.s();
            let b = this.l;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.c0));
            let c = this.l;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.c1));
        }
        get o() {
            return this.n;
        }
        set o(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.c7("Type", enumGetBox(ButtonGroupDisplayStyle_$type, b), enumGetBox(ButtonGroupDisplayStyle_$type, a));
            }
        }
        get g() {
            return this.e;
        }
        set g(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.c7("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        c1(a, b) {
            for (let c of fromEnum(this.buttons)) {
                c.clicked = delegateRemove(c.clicked, runOn(this, this.c3));
            }
            this.dc();
        }
        appendContentChild(a) {
            this.view.o(a);
        }
        c0(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    let d = c;
                    if (d != null) {
                        d.clicked = delegateRemove(d.clicked, runOn(this, this.c3));
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    let f = e;
                    if (f != null) {
                        f.clicked = delegateCombine(f.clicked, runOn(this, this.c3));
                    }
                }
            }
            this.dc();
        }
        c3(a, b) {
            let c = a;
            let d = this.buttons.indexOf(c);
            this.db(c, d);
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.c7("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get j() {
            return this.h;
        }
        set j(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.c7("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get d() {
            return this.a;
        }
        set d(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.c7("SelectedIndices", b, a);
            }
        }
        db(a, b) {
            this.t = true;
            if (this.z(a)) {
                this.d = this.b(this.d, a, b);
            }
            else {
                if (!this.y) {
                    this.d = new Array(0);
                }
                this.d = this.c(this.d, a, b);
            }
            this.dc();
            if (this.selectionChanged != null) {
                this.selectionChanged(this, new ButtonGroupSelectionChangedEventArgs());
            }
            this.t = false;
        }
        c(a, b, c) {
            let d = new Array(Math.max(0, this.a.length + 1));
            let e = 0;
            for (let f = 0; f < this.a.length; f++) {
                if (this.a[f] != c) {
                    d[e] = this.a[f];
                    e++;
                }
            }
            d[e] = c;
            return d;
        }
        b(a, b, c) {
            let d = new Array(Math.max(0, this.a.length - 1));
            let e = 0;
            for (let f = 0; f < this.a.length; f++) {
                if (this.a[f] != c) {
                    d[e] = this.a[f];
                    e++;
                }
            }
            return d;
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        c7(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.c9(a, b, c);
        }
        c9(a, b, c) {
            switch (a) {
                case "BaseTheme":
                    this.de(this.g);
                    this.dd();
                    break;
                case "Type":
                case "ItemBorderColor":
                case "ItemDisabledBorderColor":
                case "ItemBackgroundColor":
                case "ItemDisabledBackgroundColor":
                case "SelectedItemBackgroundColor":
                case "ItemTextColor":
                case "ItemDisabledTextColor":
                case "SelectedItemTextColor":
                case "ItemHoverBackgroundColor":
                case "SelectedItemHoverBackgroundColor":
                case "ItemHoverTextColor":
                case "SelectedItemHoverTextColor":
                case "OutlinedItemBorderColor":
                case "OutlinedItemDisabledBorderColor":
                case "OutlinedItemBackgroundColor":
                case "OutlinedItemDisabledBackgroundColor":
                case "OutlinedSelectedItemBackgroundColor":
                case "OutlinedItemTextColor":
                case "OutlinedItemDisabledTextColor":
                case "OutlinedSelectedItemTextColor":
                case "OutlinedItemHoverBackgroundColor":
                case ButtonGroup.cr:
                case "OutlinedItemHoverTextColor":
                case "OutlinedSelectedItemHoverTextColor":
                case "FlatItemBorderColor":
                case "FlatItemDisabledBorderColor":
                case "FlatItemBackgroundColor":
                case "FlatItemDisabledBackgroundColor":
                case "FlatSelectedItemBackgroundColor":
                case "FlatItemTextColor":
                case "FlatItemDisabledTextColor":
                case "FlatSelectedItemTextColor":
                case "FlatItemHoverBackgroundColor":
                case "FlatSelectedItemHoverBackgroundColor":
                case "FlatItemHoverTextColor":
                case "FlatSelectedItemHoverTextColor":
                    this.dd();
                    break;
                case "ActualItemBorderColor":
                case "ActualItemDisabledBorderColor":
                case "ActualItemDisabledBackgroundColor":
                case "ActualItemBackgroundColor":
                case "ActualItemTextColor":
                case "ActualItemDisabledTextColor":
                case "ActualSelectedItemTextColor":
                case "ActualSelectedItemBackgroundColor":
                    this.dc();
                    break;
                case "Orientation":
                    this.view.v();
                    this.dc();
                    break;
                case "Density":
                    this.j = this.k == 0 ? 1 : this.k;
                    break;
                case "ActualDensity":
                    for (let d = 0; d < this.buttons.count; d++) {
                        this.buttons._inner[d].h = this.j;
                    }
                    break;
                case "IsDisabled":
                    for (let e = 0; e < this.buttons.count; e++) {
                        this.buttons._inner[e].disabled = this.disabled;
                    }
                    break;
                case "SelectedIndices":
                    if (!this.t) {
                        this.dc();
                    }
                    break;
            }
        }
        di(a, b) {
            return new CornerRadius(1, !isNaN_(a.topLeft) ? a.topLeft : b.topLeft, !isNaN_(a.topRight) ? a.topRight : b.topRight, !isNaN_(a.bottomRight) ? a.bottomRight : b.bottomRight, !isNaN_(a.bottomLeft) ? a.bottomLeft : b.bottomLeft);
        }
        dd() {
            switch (this.o) {
                case 1:
                    this.ak = !isNaN_(this.a0) ? this.a0 : this.aw;
                    this.ew = this.hk != null ? this.hk : this.gw;
                    this.ey = this.hm != null ? this.hm : this.gy;
                    this.e3 = this.hr != null ? this.hr : this.g3;
                    this.e0 = this.ho != null ? this.ho : this.g0;
                    this.ex = this.hl != null ? this.hl : this.gx;
                    this.ez = this.hn != null ? this.hn : this.gz;
                    this.aj = !isNaN_(this.az) ? this.az : this.av;
                    this.e4 = this.h4 != null ? this.h4 : this.g4;
                    this.e7 = this.h7 != null ? this.h7 : this.g7;
                    this.e1 = this.hp != null ? this.hp : this.g1;
                    this.e2 = this.hq != null ? this.hq : this.g2;
                    this.e5 = this.h5 != null ? this.h5 : this.g5;
                    this.e6 = this.h6 != null ? this.h6 : this.g6;
                    break;
                case 0:
                    this.ak = !isNaN_(this.a0) ? this.a0 : this.aq;
                    this.ew = this.hk != null ? this.hk : this.fw;
                    this.ey = this.hm != null ? this.hm : this.fy;
                    this.e3 = this.hr != null ? this.hr : this.f3;
                    this.e0 = this.ho != null ? this.ho : this.f0;
                    this.ex = this.hl != null ? this.hl : this.fx;
                    this.ez = this.hn != null ? this.hn : this.fz;
                    this.aj = !isNaN_(this.az) ? this.az : this.ap;
                    this.e4 = this.h4 != null ? this.h4 : this.f4;
                    this.e7 = this.h7 != null ? this.h7 : this.f7;
                    this.e1 = this.hp != null ? this.hp : this.f1;
                    this.e2 = this.hq != null ? this.hq : this.f2;
                    this.e5 = this.h5 != null ? this.h5 : this.f5;
                    this.e6 = this.h6 != null ? this.h6 : this.f6;
                    break;
            }
        }
        dc() {
            for (let a = 0; a < this.buttons.count; a++) {
                let b = this.buttons._inner[a];
                b.h = this.j;
                if (a == 0) {
                    this.df(b);
                }
                else if (a == this.buttons.count - 1) {
                    this.dg(b);
                }
                else {
                    this.dh(b);
                }
                b.r = 1;
                b.aj = false;
                if (this.u) {
                    b.disabled = this.disabled;
                }
                b.nc = this.ex;
                b.au = this.aj;
                b.r8 = this.ez;
                b.r7 = this.ey;
                b.r9 = this.e0;
                this.view.u(b);
                if (this.z(b)) {
                    b.nb = this.e4;
                    b.ty = this.e7;
                    b.sy = this.e5;
                    b.sz = this.e6;
                }
                else {
                    b.nb = this.ew;
                    b.ty = this.e3;
                    b.sy = this.e1;
                    b.sz = this.e2;
                }
            }
        }
        z(a) {
            let b = this.buttons.indexOf(a);
            for (let c = 0; c < this.d.length; c++) {
                if (this.d[c] == b) {
                    return true;
                }
            }
            return false;
        }
        dh(a) {
            a.j4 = new CornerRadius(1, 0, 0, 0, 0);
        }
        dg(a) {
            if (this.q == 1) {
                a.j4 = new CornerRadius(1, 0, 0, this.ak, this.ak);
            }
            else {
                a.j4 = new CornerRadius(1, 0, this.ak, this.ak, 0);
            }
        }
        df(a) {
            if (this.q == 1) {
                a.j4 = new CornerRadius(1, this.ak, this.ak, 0, 0);
            }
            else {
                a.j4 = new CornerRadius(1, this.ak, 0, 0, this.ak);
            }
        }
        de(a) {
            this.aw = ThemeResolver.b(a, ButtonGroup.au, ButtonGroup.ao);
            this.gw = ThemeResolver.e(a, ButtonGroup.gk, ButtonGroup.fk);
            this.gy = ThemeResolver.e(a, ButtonGroup.gm, ButtonGroup.fm);
            this.gx = ThemeResolver.e(a, ButtonGroup.gl, ButtonGroup.fl);
            this.gz = ThemeResolver.e(a, ButtonGroup.gn, ButtonGroup.fn);
            this.av = ThemeResolver.b(a, ButtonGroup.at, ButtonGroup.an);
            this.g3 = ThemeResolver.e(a, ButtonGroup.gr, ButtonGroup.fr);
            this.g0 = ThemeResolver.e(a, ButtonGroup.go, ButtonGroup.fo);
            this.g4 = ThemeResolver.e(a, ButtonGroup.gs, ButtonGroup.fs);
            this.g7 = ThemeResolver.e(a, ButtonGroup.gv, ButtonGroup.fv);
            this.g1 = ThemeResolver.e(a, ButtonGroup.gp, ButtonGroup.fp);
            this.g2 = ThemeResolver.e(a, ButtonGroup.gq, ButtonGroup.fq);
            this.g5 = ThemeResolver.e(a, ButtonGroup.gt, ButtonGroup.ft);
            this.g6 = ThemeResolver.e(a, ButtonGroup.gu, ButtonGroup.fu);
            this.aq = ThemeResolver.b(a, ButtonGroup.as, ButtonGroup.am);
            this.fw = ThemeResolver.e(a, ButtonGroup.f8, ButtonGroup.e8);
            this.fy = ThemeResolver.e(a, ButtonGroup.ga, ButtonGroup.fa);
            this.fx = ThemeResolver.e(a, ButtonGroup.f9, ButtonGroup.e9);
            this.fz = ThemeResolver.e(a, ButtonGroup.gb, ButtonGroup.fb);
            this.ap = ThemeResolver.b(a, ButtonGroup.ar, ButtonGroup.al);
            this.f3 = ThemeResolver.e(a, ButtonGroup.gf, ButtonGroup.ff);
            this.f0 = ThemeResolver.e(a, ButtonGroup.gc, ButtonGroup.fc);
            this.f4 = ThemeResolver.e(a, ButtonGroup.gg, ButtonGroup.fg);
            this.f7 = ThemeResolver.e(a, ButtonGroup.gj, ButtonGroup.fj);
            this.f1 = ThemeResolver.e(a, ButtonGroup.gd, ButtonGroup.fd);
            this.f2 = ThemeResolver.e(a, ButtonGroup.ge, ButtonGroup.fe);
            this.f5 = ThemeResolver.e(a, ButtonGroup.gh, ButtonGroup.fh);
            this.f6 = ThemeResolver.e(a, ButtonGroup.gi, ButtonGroup.fi);
        }
        get ak() {
            return this.ac;
        }
        set ak(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.c7("ActualItemCornerRadius", b, a);
            }
        }
        get ew() {
            return this.dj;
        }
        set ew(a) {
            let b = this.dj;
            this.dj = a;
            if (b != this.dj) {
                this.c7("ActualItemBackgroundColor", b, a);
            }
        }
        get ey() {
            return this.dl;
        }
        set ey(a) {
            let b = this.dl;
            this.dl = a;
            if (b != this.dl) {
                this.c7("ActualItemDisabledBackgroundColor", b, a);
            }
        }
        get e3() {
            return this.dr;
        }
        set e3(a) {
            let b = this.dr;
            this.dr = a;
            if (b != this.dr) {
                this.c7("ActualItemTextColor", b, a);
            }
        }
        get e0() {
            return this.dn;
        }
        set e0(a) {
            let b = this.dn;
            this.dn = a;
            if (b != this.dn) {
                this.c7("ActualItemDisabledTextColor", b, a);
            }
        }
        get ex() {
            return this.dk;
        }
        set ex(a) {
            let b = this.dk;
            this.dk = a;
            if (b != this.dk) {
                this.c7("ActualItemBorderColor", b, a);
            }
        }
        get ez() {
            return this.dm;
        }
        set ez(a) {
            let b = this.dm;
            this.dm = a;
            if (b != this.dm) {
                this.c7("ActualItemDisabledBorderColor", b, a);
            }
        }
        get aj() {
            return this.ab;
        }
        set aj(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.c7("ActualItemBorderWidth", b, a);
            }
        }
        get e4() {
            return this.ds;
        }
        set e4(a) {
            let b = this.ds;
            this.ds = a;
            if (b != this.ds) {
                this.c7("ActualSelectedItemBackgroundColor", b, a);
            }
        }
        get e7() {
            return this.dv;
        }
        set e7(a) {
            let b = this.dv;
            this.dv = a;
            if (b != this.dv) {
                this.c7("ActualSelectedItemTextColor", b, a);
            }
        }
        get e1() {
            return this.dp;
        }
        set e1(a) {
            let b = this.dp;
            this.dp = a;
            if (b != this.dp) {
                this.c7("ActualItemHoverBackgroundColor", b, a);
            }
        }
        get e2() {
            return this.dq;
        }
        set e2(a) {
            let b = this.dq;
            this.dq = a;
            if (b != this.dq) {
                this.c7("ActualItemHoverTextColor", b, a);
            }
        }
        get e5() {
            return this.dt;
        }
        set e5(a) {
            let b = this.dt;
            this.dt = a;
            if (b != this.dt) {
                this.c7("ActualSelectedItemHoverBackgroundColor", b, a);
            }
        }
        get e6() {
            return this.du;
        }
        set e6(a) {
            let b = this.du;
            this.du = a;
            if (b != this.du) {
                this.c7("ActualSelectedItemHoverTextColor", b, a);
            }
        }
        get a0() {
            return this.ag;
        }
        set a0(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.c7("ItemCornerRadius", b, a);
            }
        }
        get hk() {
            return this.d4;
        }
        set hk(a) {
            let b = this.d4;
            this.d4 = a;
            if (b != this.d4) {
                this.c7("ItemBackgroundColor", b, a);
            }
        }
        get hm() {
            return this.d6;
        }
        set hm(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.c7("ItemDisabledBackgroundColor", b, a);
            }
        }
        get hr() {
            return this.eb;
        }
        set hr(a) {
            let b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.c7("ItemTextColor", b, a);
            }
        }
        get ho() {
            return this.d8;
        }
        set ho(a) {
            let b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.c7("ItemDisabledTextColor", b, a);
            }
        }
        get hp() {
            return this.d9;
        }
        set hp(a) {
            let b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.c7("ItemHoverBackgroundColor", b, a);
            }
        }
        get hl() {
            return this.d5;
        }
        set hl(a) {
            let b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.c7("ItemBorderColor", b, a);
            }
        }
        get hn() {
            return this.d7;
        }
        set hn(a) {
            let b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.c7("ItemDisabledBorderColor", b, a);
            }
        }
        get az() {
            return this.af;
        }
        set az(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.c7("ItemBorderWidth", b, a);
            }
        }
        get hq() {
            return this.ea;
        }
        set hq(a) {
            let b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.c7("ItemHoverTextColor", b, a);
            }
        }
        get h4() {
            return this.es;
        }
        set h4(a) {
            let b = this.es;
            this.es = a;
            if (b != this.es) {
                this.c7("SelectedItemBackgroundColor", b, a);
            }
        }
        get h7() {
            return this.ev;
        }
        set h7(a) {
            let b = this.ev;
            this.ev = a;
            if (b != this.ev) {
                this.c7("SelectedItemTextColor", b, a);
            }
        }
        get h5() {
            return this.et;
        }
        set h5(a) {
            let b = this.et;
            this.et = a;
            if (b != this.et) {
                this.c7("SelectedItemHoverBackgroundColor", b, a);
            }
        }
        get h6() {
            return this.eu;
        }
        set h6(a) {
            let b = this.eu;
            this.eu = a;
            if (b != this.eu) {
                this.c7("SelectedItemHoverTextColor", b, a);
            }
        }
        get a2() {
            return this.ai;
        }
        set a2(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.c7("OutlinedItemCornerRadius", b, a);
            }
        }
        get hs() {
            return this.ec;
        }
        set hs(a) {
            let b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.c7("OutlinedItemBackgroundColor", b, a);
            }
        }
        get hu() {
            return this.ee;
        }
        set hu(a) {
            let b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.c7("OutlinedItemDisabledBackgroundColor", b, a);
            }
        }
        get hz() {
            return this.ej;
        }
        set hz(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.c7("OutlinedItemTextColor", b, a);
            }
        }
        get hw() {
            return this.eg;
        }
        set hw(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.c7("OutlinedItemDisabledTextColor", b, a);
            }
        }
        get hx() {
            return this.eh;
        }
        set hx(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.c7("OutlinedItemHoverBackgroundColor", b, a);
            }
        }
        get ht() {
            return this.ed;
        }
        set ht(a) {
            let b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.c7("OutlinedItemBorderColor", b, a);
            }
        }
        get hv() {
            return this.ef;
        }
        set hv(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.c7("OutlinedItemDisabledBorderColor", b, a);
            }
        }
        get a1() {
            return this.ah;
        }
        set a1(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.c7("OutlinedItemBorderWidth", b, a);
            }
        }
        get hy() {
            return this.ei;
        }
        set hy(a) {
            let b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.c7("OutlinedItemHoverTextColor", b, a);
            }
        }
        get h0() {
            return this.eo;
        }
        set h0(a) {
            let b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.c7("OutlinedSelectedItemBackgroundColor", b, a);
            }
        }
        get h3() {
            return this.er;
        }
        set h3(a) {
            let b = this.er;
            this.er = a;
            if (b != this.er) {
                this.c7("OutlinedSelectedItemTextColor", b, a);
            }
        }
        get h1() {
            return this.ep;
        }
        set h1(a) {
            let b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.c7(ButtonGroup.cr, b, a);
            }
        }
        get h2() {
            return this.eq;
        }
        set h2(a) {
            let b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.c7("OutlinedSelectedItemHoverTextColor", b, a);
            }
        }
        get ay() {
            return this.ae;
        }
        set ay(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.c7("FlatItemCornerRadius", b, a);
            }
        }
        get g8() {
            return this.dw;
        }
        set g8(a) {
            let b = this.dw;
            this.dw = a;
            if (b != this.dw) {
                this.c7("FlatItemBackgroundColor", b, a);
            }
        }
        get ha() {
            return this.dy;
        }
        set ha(a) {
            let b = this.dy;
            this.dy = a;
            if (b != this.dy) {
                this.c7("FlatItemDisabledBackgroundColor", b, a);
            }
        }
        get hf() {
            return this.d3;
        }
        set hf(a) {
            let b = this.d3;
            this.d3 = a;
            if (b != this.d3) {
                this.c7("FlatItemTextColor", b, a);
            }
        }
        get hc() {
            return this.d0;
        }
        set hc(a) {
            let b = this.d0;
            this.d0 = a;
            if (b != this.d0) {
                this.c7("FlatItemDisabledTextColor", b, a);
            }
        }
        get hd() {
            return this.d1;
        }
        set hd(a) {
            let b = this.d1;
            this.d1 = a;
            if (b != this.d1) {
                this.c7("FlatItemHoverBackgroundColor", b, a);
            }
        }
        get g9() {
            return this.dx;
        }
        set g9(a) {
            let b = this.dx;
            this.dx = a;
            if (b != this.dx) {
                this.c7("FlatItemBorderColor", b, a);
            }
        }
        get hb() {
            return this.dz;
        }
        set hb(a) {
            let b = this.dz;
            this.dz = a;
            if (b != this.dz) {
                this.c7("FlatItemDisabledBorderColor", b, a);
            }
        }
        get ax() {
            return this.ad;
        }
        set ax(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.c7("FlatItemBorderWidth", b, a);
            }
        }
        get he() {
            return this.d2;
        }
        set he(a) {
            let b = this.d2;
            this.d2 = a;
            if (b != this.d2) {
                this.c7("FlatItemHoverTextColor", b, a);
            }
        }
        get hg() {
            return this.ek;
        }
        set hg(a) {
            let b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.c7("FlatSelectedItemBackgroundColor", b, a);
            }
        }
        get hj() {
            return this.en;
        }
        set hj(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.c7("FlatSelectedItemTextColor", b, a);
            }
        }
        get hh() {
            return this.el;
        }
        set hh(a) {
            let b = this.el;
            this.el = a;
            if (b != this.el) {
                this.c7("FlatSelectedItemHoverBackgroundColor", b, a);
            }
        }
        get hi() {
            return this.em;
        }
        set hi(a) {
            let b = this.em;
            this.em = a;
            if (b != this.em) {
                this.c7("FlatSelectedItemHoverTextColor", b, a);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.c7("Orientation", enumGetBox(ButtonGroupOrientation_$type, b), enumGetBox(ButtonGroupOrientation_$type, a));
            }
        }
        get b1() {
            return this.a4;
        }
        set b1(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.c7("Id", b, a);
            }
        }
        get disabled() {
            return this.v;
        }
        set disabled(a) {
            let b = this.v;
            this.v = a;
            this.u = true;
            if (b != this.v) {
                this.c7("IsDisabled", b, a);
            }
        }
        get y() {
            return this.w;
        }
        set y(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.c7("IsMultiSelect", b, a);
            }
        }
        c8() {
        }
        onDetachedFromUI() {
            this.view.r();
        }
        onAttachedToUI() {
            this.view.p();
        }
        aa() {
            return this.view.d();
        }
        provideContainer(a) {
            this.view.q(a);
        }
        get buttons() {
            return this.l;
        }
    }
    ButtonGroup.$t = /*@__PURE__*/ markType(ButtonGroup, 'ButtonGroup', Base.$, [INotifyPropertyChanged_$type]);
    ButtonGroup.f = 2;
    ButtonGroup.au = 4;
    ButtonGroup.gk = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    ButtonGroup.gm = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    ButtonGroup.gl = /*@__PURE__*/ BrushUtil.g(255, 199, 199, 199);
    ButtonGroup.gn = /*@__PURE__*/ BrushUtil.g(255, 199, 199, 199);
    ButtonGroup.at = 1;
    ButtonGroup.gr = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    ButtonGroup.go = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    ButtonGroup.gs = /*@__PURE__*/ BrushUtil.g(60, 0, 0, 0);
    ButtonGroup.gv = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    ButtonGroup.gp = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    ButtonGroup.gq = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    ButtonGroup.gt = /*@__PURE__*/ BrushUtil.g(96, 0, 0, 0);
    ButtonGroup.gu = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    ButtonGroup.ao = 3;
    ButtonGroup.fk = /*@__PURE__*/ BrushUtil.g(0, 255, 255, 255);
    ButtonGroup.fm = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    ButtonGroup.fl = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.fn = /*@__PURE__*/ BrushUtil.g(255, 199, 199, 199);
    ButtonGroup.an = 1;
    ButtonGroup.fr = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.fo = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    ButtonGroup.fs = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.fv = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    ButtonGroup.fp = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    ButtonGroup.fq = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.ft = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.fu = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    ButtonGroup.as = 4;
    ButtonGroup.f8 = /*@__PURE__*/ BrushUtil.g(0, 255, 255, 255);
    ButtonGroup.ga = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    ButtonGroup.f9 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    ButtonGroup.gb = /*@__PURE__*/ BrushUtil.g(255, 199, 199, 199);
    ButtonGroup.ar = 0;
    ButtonGroup.gf = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    ButtonGroup.gc = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    ButtonGroup.gg = /*@__PURE__*/ BrushUtil.g(30, 228, 28, 119);
    ButtonGroup.gj = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    ButtonGroup.gd = /*@__PURE__*/ BrushUtil.g(13, 228, 28, 119);
    ButtonGroup.ge = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    ButtonGroup.gh = /*@__PURE__*/ BrushUtil.g(30, 228, 28, 119);
    ButtonGroup.gi = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    ButtonGroup.am = 0;
    ButtonGroup.e8 = /*@__PURE__*/ BrushUtil.g(0, 255, 255, 255);
    ButtonGroup.fa = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    ButtonGroup.e9 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    ButtonGroup.fb = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    ButtonGroup.al = 0;
    ButtonGroup.ff = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    ButtonGroup.fc = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    ButtonGroup.fg = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    ButtonGroup.fj = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.fd = /*@__PURE__*/ BrushUtil.g(10, 33, 150, 243);
    ButtonGroup.fe = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    ButtonGroup.fh = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    ButtonGroup.fi = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ButtonGroup.cr = "OutlinedSelectedItemHoverBackgroundColor";
    ButtonGroup.a3 = 0;
    return ButtonGroup;
})();
//# sourceMappingURL=ButtonGroupView_combined.js.map
