/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Ripple } from "./Ripple";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { ElevationHelper } from "./ElevationHelper";
import { ButtonDisplayStyle_$type } from "./ButtonDisplayStyle";
import { isNaN_ } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { Thickness } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let ButtonView = /*@__PURE__*/ (() => {
    class ButtonView extends Base {
        constructor() {
            super();
            this.a = null;
            this.h = null;
            this.c = null;
            this.g = new List$1(Delegate_$type, 0);
            this.d = true;
            this.k = null;
            this.i = null;
            this.b = null;
            this.j = null;
            this.m = null;
            this.l = null;
        }
        ag() {
        }
        f() {
            return true;
        }
        get n() {
            return this.k;
        }
        get o() {
            return this.j;
        }
        aa(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.g.clear();
                return;
            }
            this.h = a;
            this.h.rootWrapper.setStyleProperty("display", "flex");
            this.h.rootWrapper.setStyleProperty("flex-direction", "row");
            this.h.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.h.rootWrapper.setStyleProperty("align-items", "center");
            let c = this.h.createElement("button");
            this.k = c;
            this.k.setStyleProperty("position", "relative");
            this.k.setStyleProperty("display", "inline-flex");
            this.k.setStyleProperty("align-items", "center");
            this.k.setStyleProperty("justify-content", "center");
            this.an();
            this.k.setStyleProperty("border", "none");
            this.k.setStyleProperty("cursor", "pointer");
            this.k.setStyleProperty("user-select", "none");
            this.k.setStyleProperty("outline-style", "none");
            this.k.setStyleProperty("-webkit-tap-highlight-color", "transparent");
            this.k.setStyleProperty("overflow", "hidden");
            this.k.setStyleProperty("white-space", "no-wrap");
            this.k.setStyleProperty("color", "#000");
            this.k.setStyleProperty("background", this.a.my._fill);
            NativeUI.l(this.k, this.a.j2);
            this.k.setAttribute("id", this.a.hz);
            this.ak();
            this.g.add(c.listen("change", runOn(this, this.t)));
            this.g.add(c.listen("click", runOn(this, this.u)));
            this.g.add(c.listen("focus", runOn(this, this.v)));
            this.g.add(c.listen("blur", runOn(this, this.s)));
            this.g.add(c.listen("mouseenter", runOn(this, this.q)));
            this.g.add(c.listen("mouseleave", runOn(this, this.r)));
            this.h.append(c);
            let d = this.h.createElement("div");
            let e = this.h.getSubRenderer(d);
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            d.setStyleProperty("overflow", "hidden");
            let f = new Ripple();
            f.provideContainer(e);
            f.p = c;
            let g = this.h.getExternal(f, this.h.rootWrapper, this.h.getExternal(this.a, null, null));
            f.g = false;
            f.j = true;
            this.b = f;
            this.k.append(d);
            let h = this.h.createElement("div");
            h.addClass("ig-button-content");
            h.setStyleProperty("font-family", "'Segoe UI', Verdana");
            h.setStyleProperty("font-weight", "400");
            h.setStyleProperty("font-size", ".875rem");
            h.setStyleProperty("cursor", "pointer");
            this.j = h;
            this.g.add(h.listen("click", runOn(this, this.p)));
            this.k.append(h);
            this.l = h;
            this.h.getPortal(h, "ChildContent", (i) => {
                let comp_ = i.componentRef;
                this.m = comp_;
                {
                    this.l.setStyleProperty("flex-direction", this.a.g6);
                    this.l.setStyleProperty("align-items", this.a.fp);
                    let direction_ = this.a.g6;
                    let display_ = this.a.f5;
                    let alignItems_ = this.a.fp;
                    comp_.display = display_;
                    comp_.flexDirection = direction_;
                    comp_.alignItems = alignItems_;
                }
            }, true);
            this.a.jp();
        }
        ac() {
            this.b.h = this.a.ad;
        }
        an() {
            let a = "2.25rem";
            let b = "2.25rem";
            let c = "2.25rem";
            let d = "2.25rem";
            let e = "3.5rem";
            let f = "3.5rem";
            let g = "3.5rem";
            let h = "3.5rem";
            let i = "5.5rem";
            let j = "2.25rem";
            let k = "0px";
            let l = ".9375rem";
            let m = ".5625rem 1rem";
            switch (this.a.g) {
                case 2:
                    m = ".375rem .75rem";
                    j = "1.875rem";
                    e = "3rem";
                    f = "3rem";
                    g = "3rem";
                    h = "3rem";
                    l = ".6875rem";
                    break;
                case 3:
                    m = ".1875rem 1rem";
                    j = "1.5rem";
                    f = "2.5rem";
                    e = "2.5rem";
                    h = "2.5rem";
                    g = "2.5rem";
                    l = ".4375rem";
                    break;
            }
            if (this.a.r == 4) {
                this.k.setStyleProperty("min-width", a);
                this.k.setStyleProperty("min-height", b);
                this.k.setStyleProperty("padding", k);
                this.k.setStyleProperty("width", c);
                this.k.setStyleProperty("height", d);
            }
            else if (this.a.r == 3) {
                this.k.setStyleProperty("min-width", e);
                this.k.setStyleProperty("min-height", f);
                this.k.setStyleProperty("padding", l);
                this.k.setStyleProperty("width", g);
                this.k.setStyleProperty("height", h);
            }
            else {
                this.k.setStyleProperty("min-width", i);
                this.k.setStyleProperty("min-height", j);
                this.k.setStyleProperty("padding", m);
            }
            if (!isNaN_(this.a.at) && this.a.at > 0) {
                this.k.setStyleProperty("border-style", "solid");
            }
            else {
                this.k.setStyleProperty("border-style", "none");
            }
        }
        ai() {
            this.k.setAttribute("disabled", this.a.disabled ? "true" : "false");
            this.k.setProperty("disabled", this.a.disabled);
        }
        ad() {
            if (this.h != null) {
                this.h.rootWrapper.setStyleProperty("display", this.a.f5);
                let comp_ = this.m;
                if (this.m != null) {
                    this.l.setStyleProperty("display", this.a.f5);
                    let display_ = this.a.f5;
                    comp_.display = display_;
                }
                let ext_ = this.h.getExternal(this.a, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        y() {
            if (this.h != null) {
                this.h.rootWrapper.setStyleProperty("align-items", this.a.fp);
                this.k.setStyleProperty("align-items", this.a.fp);
                let comp_ = this.m;
                if (this.m != null) {
                    this.l.setStyleProperty("align-items", this.a.fp);
                    let alignItems_ = this.a.fp;
                    comp_.alignItems = alignItems_;
                }
                let ext_ = this.h.getExternal(this.a, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        ae() {
            if (this.h != null) {
                this.h.rootWrapper.setStyleProperty("flex-direction", this.a.g6);
                this.k.setStyleProperty("flex-direction", this.a.g6);
                let ext_ = this.h.getExternal(this.a, null, null);
                let comp_ = this.m;
                if (this.m != null) {
                    this.l.setStyleProperty("flex-direction", this.a.g6);
                    let direction_ = this.a.g6;
                    comp_.flexDirection = direction_;
                }
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        af() {
            if (this.h != null) {
                this.h.rootWrapper.setStyleProperty("flex-grow", this.a.g8);
                this.k.setStyleProperty("flex-grow", this.a.g8);
                let ext_ = this.h.getExternal(this.a, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        p(a) {
        }
        ak() {
            if (this.f()) {
                let a = this.a.hz;
                this.k.setAttribute("name", this.a.h5);
                this.k.setProperty("value", this.a.et);
                if (this.a.ag) {
                    this.k.setAttribute("tabindex", this.a.ep.toString());
                }
                this.k.setProperty("disabled", this.a.disabled);
                {
                }
                this.k.setAttribute("aria-label", this.a.fr);
            }
        }
        ah() {
            if (this.f()) {
                let a = this.a.hz;
                this.k.setAttribute("id", a);
            }
        }
        q(a) {
            this.a.jm();
        }
        r(a) {
            this.a.jn();
        }
        s(a) {
            this.a.ji();
        }
        v(a) {
            this.a.jl();
        }
        u(a) {
            this.a.jj();
        }
        e() {
            return false;
        }
        t(a) {
        }
        x() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.h;
            }
        }
        z() {
            this.d = true;
            this.g.add(this.k.listen("change", runOn(this, this.t)));
            this.g.add(this.k.listen("click", runOn(this, this.u)));
            this.g.add(this.k.listen("focus", runOn(this, this.v)));
            this.g.add(this.k.listen("blur", runOn(this, this.s)));
            this.g.add(this.j.listen("click", runOn(this, this.p)));
            this.g.add(this.k.listen("mouseenter", runOn(this, this.q)));
            this.g.add(this.k.listen("mouseleave", runOn(this, this.r)));
        }
        ab() {
            this.d = false;
            for (let a of fromEnum(this.g)) {
                a();
            }
            this.g.clear();
        }
        aj() {
            let model_ = this.a;
            if (model_.externalObject && model_.externalObject.refreshDefaults) {
                model_.externalObject.refreshDefaults();
            }
            ;
        }
        al(a, b) {
            this.b.au = a;
            this.b.at = b;
        }
        am(a, b) {
            let c = ElevationHelper.e(a, this.a.na, this.a.m7, this.a.mx, b);
            this.k.setStyleProperty("box-shadow", c);
        }
        ao(a) {
            if (a != null) {
                this.j.setStyleProperty("font", a.fontString);
            }
        }
        w(a) {
            this.j.append(a);
        }
    }
    ButtonView.$t = /*@__PURE__*/ markType(ButtonView, 'ButtonView');
    return ButtonView;
})();
/**
 * @hidden
 */
export let Button = /*@__PURE__*/ (() => {
    class Button extends Base {
        constructor() {
            super();
            this._view = null;
            this.r6 = ThemeResolver.e(Button.c, Button.ri, Button.oz);
            this.ru = ThemeResolver.e(Button.c, Button.q6, Button.on);
            this.nd = ThemeResolver.e(Button.c, Button.px, Button.ne);
            this.m = ThemeResolver.a(Button.c, Button.n, Button.l);
            this.rx = ThemeResolver.e(Button.c, Button.q9, Button.oq);
            this.ry = ThemeResolver.e(Button.c, Button.ra, Button.or);
            this.rz = ThemeResolver.e(Button.c, Button.rb, Button.os);
            this.dx = ThemeResolver.c(Button.c, Button.dp, Button.cs);
            this.d0 = ThemeResolver.c(Button.c, Button.ds, Button.cv);
            this.dz = ThemeResolver.c(Button.c, Button.dr, Button.cu);
            this.dy = ThemeResolver.c(Button.c, Button.dq, Button.ct);
            this.rw = ThemeResolver.e(Button.c, Button.q8, Button.op);
            this.r4 = ThemeResolver.e(Button.c, Button.rg, Button.ox);
            this.kj = ThemeResolver.d(Button.c, Button.kh, Button.j9);
            this.a9 = ThemeResolver.b(Button.c, Button.a7, Button.az);
            this.rv = ThemeResolver.e(Button.c, Button.q7, Button.oo);
            this.r5 = ThemeResolver.e(Button.c, Button.rh, Button.oy);
            this.r3 = ThemeResolver.e(Button.c, Button.rf, Button.ow);
            this.r2 = ThemeResolver.e(Button.c, Button.re, Button.ov);
            this.r0 = ThemeResolver.e(Button.c, Button.rc, Button.ot);
            this.r1 = ThemeResolver.e(Button.c, Button.rd, Button.ou);
            this.pd = ThemeResolver.e(Button.c, Button.qb, Button.ns);
            this.pe = ThemeResolver.e(Button.c, Button.qc, Button.nt);
            this.pf = ThemeResolver.e(Button.c, Button.qd, Button.nu);
            this.c0 = ThemeResolver.c(Button.c, Button.dc, Button.cg);
            this.c3 = ThemeResolver.c(Button.c, Button.df, Button.cj);
            this.c2 = ThemeResolver.c(Button.c, Button.de, Button.ci);
            this.c1 = ThemeResolver.c(Button.c, Button.dd, Button.ch);
            this.pc = ThemeResolver.e(Button.c, Button.qa, Button.nr);
            this.pk = ThemeResolver.e(Button.c, Button.qi, Button.nz);
            this.kb = ThemeResolver.d(Button.c, Button.ke, Button.j6);
            this.a1 = ThemeResolver.b(Button.c, Button.a4, Button.aw);
            this.pb = ThemeResolver.e(Button.c, Button.p9, Button.nq);
            this.pl = ThemeResolver.e(Button.c, Button.qj, Button.n0);
            this.pj = ThemeResolver.e(Button.c, Button.qh, Button.ny);
            this.pi = ThemeResolver.e(Button.c, Button.qg, Button.nx);
            this.pg = ThemeResolver.e(Button.c, Button.qe, Button.nv);
            this.ph = ThemeResolver.e(Button.c, Button.qf, Button.nw);
            this.rl = ThemeResolver.e(Button.c, Button.qx, Button.oe);
            this.rm = ThemeResolver.e(Button.c, Button.qy, Button.of);
            this.rn = ThemeResolver.e(Button.c, Button.qz, Button.og);
            this.dt = ThemeResolver.c(Button.c, Button.dk, Button.co);
            this.dw = ThemeResolver.c(Button.c, Button.dn, Button.cr);
            this.dv = ThemeResolver.c(Button.c, Button.dm, Button.cq);
            this.du = ThemeResolver.c(Button.c, Button.dl, Button.cp);
            this.rk = ThemeResolver.e(Button.c, Button.qw, Button.od);
            this.rs = ThemeResolver.e(Button.c, Button.q4, Button.ol);
            this.ki = ThemeResolver.d(Button.c, Button.kg, Button.j8);
            this.a8 = ThemeResolver.b(Button.c, Button.a6, Button.ay);
            this.rj = ThemeResolver.e(Button.c, Button.qv, Button.oc);
            this.rt = ThemeResolver.e(Button.c, Button.q5, Button.om);
            this.rr = ThemeResolver.e(Button.c, Button.q3, Button.ok);
            this.rq = ThemeResolver.e(Button.c, Button.q2, Button.oj);
            this.ro = ThemeResolver.e(Button.c, Button.q0, Button.oh);
            this.rp = ThemeResolver.e(Button.c, Button.q1, Button.oi);
            this.po = ThemeResolver.e(Button.c, Button.qm, Button.n3);
            this.pp = ThemeResolver.e(Button.c, Button.qn, Button.n4);
            this.pq = ThemeResolver.e(Button.c, Button.qo, Button.n5);
            this.c4 = ThemeResolver.c(Button.c, Button.dg, Button.ck);
            this.c7 = ThemeResolver.c(Button.c, Button.dj, Button.cn);
            this.c6 = ThemeResolver.c(Button.c, Button.di, Button.cm);
            this.c5 = ThemeResolver.c(Button.c, Button.dh, Button.cl);
            this.pn = ThemeResolver.e(Button.c, Button.ql, Button.n2);
            this.pv = ThemeResolver.e(Button.c, Button.qt, Button.oa);
            this.kc = ThemeResolver.d(Button.c, Button.kf, Button.j7);
            this.a2 = ThemeResolver.b(Button.c, Button.a5, Button.ax);
            this.pm = ThemeResolver.e(Button.c, Button.qk, Button.n1);
            this.pw = ThemeResolver.e(Button.c, Button.qu, Button.ob);
            this.pu = ThemeResolver.e(Button.c, Button.qs, Button.n9);
            this.pt = ThemeResolver.e(Button.c, Button.qr, Button.n8);
            this.pr = ThemeResolver.e(Button.c, Button.qp, Button.n6);
            this.ps = ThemeResolver.e(Button.c, Button.qq, Button.n7);
            this.o2 = ThemeResolver.e(Button.c, Button.p0, Button.nh);
            this.o3 = ThemeResolver.e(Button.c, Button.p1, Button.ni);
            this.o4 = ThemeResolver.e(Button.c, Button.p2, Button.nj);
            this.cw = ThemeResolver.c(Button.c, Button.c8, Button.cc);
            this.cz = ThemeResolver.c(Button.c, Button.db, Button.cf);
            this.cy = ThemeResolver.c(Button.c, Button.da, Button.ce);
            this.cx = ThemeResolver.c(Button.c, Button.c9, Button.cd);
            this.o1 = ThemeResolver.e(Button.c, Button.pz, Button.ng);
            this.o9 = ThemeResolver.e(Button.c, Button.p7, Button.no);
            this.ka = ThemeResolver.d(Button.c, Button.kd, Button.j5);
            this.a0 = ThemeResolver.b(Button.c, Button.a3, Button.av);
            this.o0 = ThemeResolver.e(Button.c, Button.py, Button.nf);
            this.pa = ThemeResolver.e(Button.c, Button.p8, Button.np);
            this.o8 = ThemeResolver.e(Button.c, Button.p6, Button.nn);
            this.o7 = ThemeResolver.e(Button.c, Button.p5, Button.nm);
            this.o5 = ThemeResolver.e(Button.c, Button.p3, Button.nk);
            this.o6 = ThemeResolver.e(Button.c, Button.p4, Button.nl);
            this.q = 0;
            this.f = 0;
            this.b = 0;
            this.e = 1;
            this.kr = ThemeResolver.e(Button.c, Button.q8, Button.op);
            this.k2 = ThemeResolver.e(Button.c, Button.ri, Button.oz);
            this.kz = ThemeResolver.e(Button.c, Button.q6, Button.on);
            this.kp = ThemeResolver.e(Button.c, Button.px, Button.ne);
            this.bi = ThemeResolver.c(Button.c, Button.ds, Button.cv);
            this.bg = ThemeResolver.c(Button.c, Button.dq, Button.ct);
            this.bh = ThemeResolver.c(Button.c, Button.dr, Button.cu);
            this.k0 = ThemeResolver.e(Button.c, Button.rg, Button.ox);
            this.jv = ThemeResolver.d(Button.c, Button.kh, Button.j9);
            this.kq = ThemeResolver.e(Button.c, Button.q7, Button.oo);
            this.ks = ThemeResolver.e(Button.c, Button.q9, Button.oq);
            this.kt = ThemeResolver.e(Button.c, Button.ra, Button.or);
            this.ku = ThemeResolver.e(Button.c, Button.rb, Button.os);
            this.bf = ThemeResolver.c(Button.c, Button.dp, Button.cs);
            this.i = ThemeResolver.a(Button.c, Button.n, Button.l);
            this.k1 = ThemeResolver.e(Button.c, Button.rh, Button.oy);
            this.ky = ThemeResolver.e(Button.c, Button.rf, Button.ow);
            this.kv = ThemeResolver.e(Button.c, Button.rc, Button.ot);
            this.kw = ThemeResolver.e(Button.c, Button.rd, Button.ou);
            this.kx = ThemeResolver.e(Button.c, Button.re, Button.ov);
            this.am = ThemeResolver.b(Button.c, Button.a7, Button.az);
            this.mk = null;
            this.mm = null;
            this.mn = null;
            this.mo = null;
            this.b2 = -1;
            this.mr = null;
            this.ml = null;
            this.b5 = -1;
            this.b4 = -1;
            this.b3 = -1;
            this.as = NaN;
            this.j1 = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mt = null;
            this.li = null;
            this.lk = null;
            this.ll = null;
            this.lm = null;
            this.bo = -1;
            this.lp = null;
            this.lj = null;
            this.br = -1;
            this.bq = -1;
            this.bp = -1;
            this.lr = null;
            this.ls = null;
            this.lq = null;
            this.ln = null;
            this.lo = null;
            this.ap = NaN;
            this.jy = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.k3 = null;
            this.k5 = null;
            this.k6 = null;
            this.k7 = null;
            this.bj = -1;
            this.j = 0;
            this.lv = null;
            this.k4 = null;
            this.b6 = -1;
            this.bt = -1;
            this.bs = -1;
            this.t = null;
            this.mw = null;
            this.lx = null;
            this.mv = null;
            this.mu = null;
            this.ms = null;
            this.mp = null;
            this.mq = null;
            this.lt = null;
            this.lu = null;
            this.an = NaN;
            this.jw = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.l9 = null;
            this.mb = null;
            this.mc = null;
            this.md = null;
            this.by = -1;
            this.mg = null;
            this.ma = null;
            this.b1 = -1;
            this.b0 = -1;
            this.bz = -1;
            this.ar = NaN;
            this.j0 = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mi = null;
            this.mj = null;
            this.mh = null;
            this.me = null;
            this.mf = null;
            this.k8 = null;
            this.la = null;
            this.lb = null;
            this.lc = null;
            this.bk = -1;
            this.lw = null;
            this.k9 = null;
            this.bn = -1;
            this.bm = -1;
            this.bl = -1;
            this.ao = NaN;
            this.jx = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.lg = null;
            this.lh = null;
            this.lf = null;
            this.ld = null;
            this.le = null;
            this.ly = null;
            this.l0 = null;
            this.l1 = null;
            this.l2 = null;
            this.bu = -1;
            this.l5 = null;
            this.lz = null;
            this.bx = -1;
            this.bw = -1;
            this.bv = -1;
            this.aq = NaN;
            this.jz = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.l7 = null;
            this.l8 = null;
            this.l6 = null;
            this.l3 = null;
            this.l4 = null;
            this.e0 = "ig-native-button-" + Button.er++;
            this.ez = "ig-button-" + Button.eq++;
            this.ew = "inline-block";
            this.ex = "inline-block";
            this.ey = null;
            this.eu = "center";
            this.es = null;
            this.e1 = null;
            this.b7 = 0;
            this.y = false;
            this.aa = false;
            this.ab = true;
            this.ev = null;
            this.w = false;
            this.v = false;
            this.ac = false;
            this.z = false;
            this.x = false;
            this.propertyChanged = null;
            this.clicked = null;
            let a = new ButtonView();
            a.a = this;
            this.view = a;
            this.view.ag();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        jo(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.jq(a, b, c);
        }
        jq(a, b, c) {
            switch (a) {
                case "CornerRadius":
                case "BorderColor":
                case "RestingElevation":
                case "HoverElevation":
                case "FocusElevation":
                case "RippleColor":
                case "BorderWidth":
                case "BackgroundColor":
                case "DisabledBackgroundColor":
                case "DisabledBorderColor":
                case "DisabledTextColor":
                case "DisabledElevation":
                case "HoverBackgroundColor":
                case "TextStyle":
                case "FocusTextColor":
                case "TextColor":
                case "HoverTextColor":
                case "FocusBackgroundColor":
                case "RaisedBorderColor":
                case "RaisedRestingElevation":
                case "RaisedFocusElevation":
                case "RaisedHoverElevation":
                case "RaisedRippleColor":
                case "RaisedBorderWidth":
                case "RaisedBackgroundColor":
                case "RaisedDisabledBackgroundColor":
                case "RaisedDisabledBorderColor":
                case "RaisedDisabledTextColor":
                case "RaisedDisabledElevation":
                case "RaisedHoverBackgroundColor":
                case "RaisedCornerRadius":
                case "RaisedFocusBackgroundColor":
                case "RaisedFocusTextColor":
                case "RaisedTextColor":
                case "RaisedHoverTextColor":
                case "FlatBorderColor":
                case "FlatRestingElevation":
                case "FlatFocusElevation":
                case "FlatHoverElevation":
                case "FlatRippleColor":
                case "FlatBorderWidth":
                case "FlatBackgroundColor":
                case "FlatDisabledBackgroundColor":
                case "FlatDisabledBorderColor":
                case "FlatDisabledTextColor":
                case "FlatDisabledElevation":
                case "FlatHoverBackgroundColor":
                case "FlatCornerRadius":
                case "FlatFocusBackgroundColor":
                case "FlatFocusTextColor":
                case "FlatTextColor":
                case "FlatHoverTextColor":
                case "OutlinedRippleColor":
                case "OutlinedRestingElevation":
                case "OutlinedFocusElevation":
                case "OutlinedHoverElevation":
                case "OutlinedBorderColor":
                case "OutlinedBorderWidth":
                case "OutlinedBackgroundColor":
                case "OutlinedDisabledBackgroundColor":
                case "OutlinedDisabledBorderColor":
                case "OutlinedDisabledTextColor":
                case "OutlinedDisabledElevation":
                case "OutlinedHoverBackgroundColor":
                case "OutlinedCornerRadius":
                case "OutlinedFocusBackgroundColor":
                case "OutlinedFocusTextColor":
                case "OutlinedTextColor":
                case "OutlinedHoverTextColor":
                case "FabBorderColor":
                case "FabRippleColor":
                case "FabRestingElevation":
                case "FabFocusElevation":
                case "FabHoverElevation":
                case "FabBorderWidth":
                case "FabBackgroundColor":
                case "FabDisabledBackgroundColor":
                case "FabDisabledBorderColor":
                case "FabDisabledTextColor":
                case "FabDisabledElevation":
                case "FabHoverBackgroundColor":
                case "FabCornerRadius":
                case "FabFocusBackgroundColor":
                case "FabFocusTextColor":
                case "FabTextColor":
                case "FabHoverTextColor":
                case "IconRestingElevation":
                case "IconFocusElevation":
                case "IconHoverElevation":
                case "IconBorderColor":
                case "IconRippleColor":
                case "IconBorderWidth":
                case "IconBackgroundColor":
                case "IconDisabledBackgroundColor":
                case "IconDisabledBorderColor":
                case "IconDisabledTextColor":
                case "IconDisabledElevation":
                case "IconHoverBackgroundColor":
                case "IconCornerRadius":
                case "IconFocusBackgroundColor":
                case "IconFocusTextColor":
                case "IconTextColor":
                case "IconHoverTextColor":
                case "ElevationMode":
                    this.jt();
                    break;
                case "BaseTheme":
                    this.ju(this.d == 0 ? 2 : this.d);
                    this.jt();
                    break;
                case "IsDisabled":
                    this.ad = this.disabled || this.ae;
                    this.jt();
                    this.view.ai();
                    break;
                case "DisableRipple":
                    this.ad = this.disabled || this.ae;
                    this.jt();
                    break;
                case "ActualDisableRipple":
                    this.view.ac();
                    break;
                case "ActualBackgroundColor":
                case "ActualDisabledBackgroundColor":
                case "ActualDisabledBorderColor":
                case "ActualDisabledTextColor":
                case "ActualDisabledElevation":
                case "ActualHoverBackgroundColor":
                case "ActualBorderColor":
                case "ActualFocusTextColor":
                case "ActualHoverTextColor":
                case "ActualElevationMode":
                    this.js();
                    break;
                case "Density":
                    this.g = this.h == 0 ? 1 : this.h;
                    break;
                case "ActualDensity":
                case "ActualBorderWidth":
                case "ActualCornerRadius":
                    this.view.an();
                    this.js();
                    break;
                case "Type":
                    this.view.an();
                    this.jt();
                    this.js();
                    break;
                case "InputId":
                    this.view.ah();
                    break;
                case "Display":
                    this.view.ad();
                    break;
                case "FlexDirection":
                    this.view.ae();
                    break;
                case "FlexGrow":
                    this.view.af();
                    break;
                case "AlignItems":
                    this.view.y();
                    break;
            }
        }
        j3(a, b) {
            return new CornerRadius(1, !isNaN_(a.topLeft) ? a.topLeft : b.topLeft, !isNaN_(a.topRight) ? a.topRight : b.topRight, !isNaN_(a.bottomRight) ? a.bottomRight : b.bottomRight, !isNaN_(a.bottomLeft) ? a.bottomLeft : b.bottomLeft);
        }
        jt() {
            this.k = this.o != 0 ? this.o : this.m;
            this.na = this.r6;
            this.m7 = this.ru;
            this.mx = this.nd;
            switch (this.r) {
                case 0:
                    this.m0 = this.r7 != null ? this.r7 : this.to != null ? this.to : this.rx;
                    this.m1 = this.r8 != null ? this.r8 : this.tp != null ? this.tp : this.ry;
                    this.m2 = this.r9 != null ? this.r9 : this.tq != null ? this.tq : this.rz;
                    this.b8 = this.d1 >= 0 ? this.d1 : this.ek >= 0 ? this.ek : this.dx;
                    this.cb = this.eo >= 0 ? this.eo : this.en >= 0 ? this.en : this.d0;
                    this.ca = this.eb >= 0 ? this.eb : this.em >= 0 ? this.em : this.dz;
                    this.b9 = this.ea >= 0 ? this.ea : this.el >= 0 ? this.el : this.dy;
                    this.mz = this.nc != null ? this.nc : this.tn != null ? this.tn : this.rw;
                    this.my = this.nb != null ? this.nb : this.tm != null ? this.tm : this.rv;
                    this.m5 = this.sy != null ? this.sy : this.tt != null ? this.tt : this.r2;
                    this.j2 = this.j3(this.j4, this.j3(this.ko, this.kj));
                    this.at = !isNaN_(this.au) ? this.au : !isNaN_(this.be) ? this.be : this.a9;
                    this.m8 = this.tx != null ? this.tx : this.tv != null ? this.tv : this.r4;
                    this.m3 = this.sw != null ? this.sw : this.tr != null ? this.tr : this.r0;
                    this.m4 = this.sx != null ? this.sx : this.ts != null ? this.ts : this.r1;
                    this.m9 = this.ty != null ? this.ty : this.tw != null ? this.tw : this.r5;
                    this.m6 = this.sz != null ? this.sz : this.tu != null ? this.tu : this.r3;
                    break;
                case 2:
                    this.m0 = this.r7 != null ? this.r7 : this.td != null ? this.td : this.rl;
                    this.m1 = this.r8 != null ? this.r8 : this.te != null ? this.te : this.rm;
                    this.m2 = this.r9 != null ? this.r9 : this.tf != null ? this.tf : this.rn;
                    this.b8 = this.d1 >= 0 ? this.d1 : this.eg >= 0 ? this.eg : this.dt;
                    this.cb = this.eo >= 0 ? this.eo : this.ej >= 0 ? this.ej : this.dw;
                    this.ca = this.eb >= 0 ? this.eb : this.ei >= 0 ? this.ei : this.dv;
                    this.b9 = this.ea >= 0 ? this.ea : this.eh >= 0 ? this.eh : this.du;
                    this.mz = this.nc != null ? this.nc : this.tc != null ? this.tc : this.rk;
                    this.my = this.sy != null ? this.sy : this.nb != null ? this.nb : this.tb != null ? this.tb : this.rj;
                    this.m5 = this.ti != null ? this.ti : this.rq;
                    this.j2 = this.j3(this.j4, this.j3(this.kn, this.ki));
                    this.at = !isNaN_(this.au) ? this.au : !isNaN_(this.bd) ? this.bd : this.a8;
                    this.m8 = this.tx != null ? this.tx : this.tk != null ? this.tk : this.rs;
                    this.m3 = this.sw != null ? this.sw : this.tg != null ? this.tg : this.ro;
                    this.m4 = this.sx != null ? this.sx : this.th != null ? this.th : this.rp;
                    this.m9 = this.ty != null ? this.ty : this.tl != null ? this.tl : this.rt;
                    this.m6 = this.sz != null ? this.sz : this.tj != null ? this.tj : this.rr;
                    break;
                case 1:
                    this.m0 = this.r7 != null ? this.r7 : this.sn != null ? this.sn : this.pd;
                    this.m1 = this.r8 != null ? this.r8 : this.so != null ? this.so : this.pe;
                    this.m2 = this.r9 != null ? this.r9 : this.sp != null ? this.sp : this.pf;
                    this.b8 = this.d1 >= 0 ? this.d1 : this.d6 >= 0 ? this.d6 : this.c0;
                    this.cb = this.eo >= 0 ? this.eo : this.d9 >= 0 ? this.d9 : this.c3;
                    this.ca = this.eb >= 0 ? this.eb : this.d8 >= 0 ? this.d8 : this.c2;
                    this.b9 = this.ea >= 0 ? this.ea : this.d7 >= 0 ? this.d7 : this.c1;
                    this.mz = this.nc != null ? this.nc : this.sm != null ? this.sm : this.pc;
                    this.my = this.nb != null ? this.nb : this.sl != null ? this.sl : this.pb;
                    this.m5 = this.sy != null ? this.sy : this.ss != null ? this.ss : this.pi;
                    this.j2 = this.j3(this.j4, this.j3(this.kl, this.kb));
                    this.at = !isNaN_(this.au) ? this.au : !isNaN_(this.bb) ? this.bb : this.a1;
                    this.m8 = this.tx != null ? this.tx : this.su != null ? this.su : this.pk;
                    this.m3 = this.sw != null ? this.sw : this.sq != null ? this.sq : this.pg;
                    this.m4 = this.sx != null ? this.sx : this.sr != null ? this.sr : this.ph;
                    this.m9 = this.ty != null ? this.ty : this.sv != null ? this.sv : this.pl;
                    this.m6 = this.sz != null ? this.sz : this.st != null ? this.st : this.pj;
                    break;
                case 4:
                    this.m0 = this.r7 != null ? this.r7 : this.s2 != null ? this.s2 : this.po;
                    this.m1 = this.r8 != null ? this.r8 : this.s3 != null ? this.s3 : this.pp;
                    this.m2 = this.r9 != null ? this.r9 : this.s4 != null ? this.s4 : this.pq;
                    this.b8 = this.d1 >= 0 ? this.d1 : this.ec >= 0 ? this.ec : this.c4;
                    this.cb = this.eo >= 0 ? this.eo : this.ef >= 0 ? this.ef : this.c7;
                    this.ca = this.eb >= 0 ? this.eb : this.ee >= 0 ? this.ee : this.c6;
                    this.b9 = this.ea >= 0 ? this.ea : this.ed >= 0 ? this.ed : this.c5;
                    this.mz = this.nc != null ? this.nc : this.s1 != null ? this.s1 : this.pn;
                    this.my = this.nb != null ? this.nb : this.s0 != null ? this.s0 : this.pm;
                    this.m5 = this.sy != null ? this.sy : this.s7 != null ? this.s7 : this.pt;
                    this.j2 = this.j3(this.j4, this.j3(this.km, this.kc));
                    this.at = !isNaN_(this.au) ? this.au : !isNaN_(this.bc) ? this.bc : this.a2;
                    this.m8 = this.tx != null ? this.tx : this.s9 != null ? this.s9 : this.pv;
                    this.m3 = this.sw != null ? this.sw : this.s5 != null ? this.s5 : this.pr;
                    this.m4 = this.sx != null ? this.sx : this.s6 != null ? this.s6 : this.ps;
                    this.m9 = this.ty != null ? this.ty : this.ta != null ? this.ta : this.pw;
                    this.m6 = this.sz != null ? this.sz : this.s8 != null ? this.s8 : this.pu;
                    break;
                case 3:
                    this.m0 = this.r7 != null ? this.r7 : this.sc != null ? this.sc : this.o2;
                    this.m1 = this.r8 != null ? this.r8 : this.sd != null ? this.sd : this.o3;
                    this.m2 = this.r9 != null ? this.r9 : this.se != null ? this.se : this.o4;
                    this.b8 = this.d1 >= 0 ? this.d1 : this.d2 >= 0 ? this.d2 : this.cw;
                    this.cb = this.eo >= 0 ? this.eo : this.d5 >= 0 ? this.d5 : this.cz;
                    this.ca = this.eb >= 0 ? this.eb : this.d4 >= 0 ? this.d4 : this.cy;
                    this.b9 = this.ea >= 0 ? this.ea : this.d3 >= 0 ? this.d3 : this.cx;
                    this.mz = this.nc != null ? this.nc : this.sb != null ? this.sb : this.o1;
                    this.my = this.nb != null ? this.nb : this.sa != null ? this.sa : this.o0;
                    this.m5 = this.sy != null ? this.sy : this.sh != null ? this.sh : this.o7;
                    this.j2 = this.j3(this.j4, this.j3(this.kk, this.ka));
                    this.at = !isNaN_(this.au) ? this.au : !isNaN_(this.ba) ? this.ba : this.a0;
                    this.m8 = this.tx != null ? this.tx : this.sj != null ? this.sj : this.r4;
                    this.m3 = this.sw != null ? this.sw : this.sf != null ? this.sf : this.o5;
                    this.m4 = this.sx != null ? this.sx : this.sg != null ? this.sg : this.o6;
                    this.m9 = this.ty != null ? this.ty : this.sk != null ? this.sk : this.pa;
                    this.m6 = this.sz != null ? this.sz : this.si != null ? this.si : this.o8;
                    break;
            }
        }
        jj() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new ButtonClickEventArgs());
            }
        }
        ji() {
            this.focused = false;
            this.js();
        }
        jl() {
            this.focused = true;
            this.js();
        }
        jn() {
            this.ak = false;
            this.js();
        }
        jm() {
            this.ak = true;
            this.js();
        }
        js() {
            let a = this.view.n;
            NativeUI.l(a, this.j2);
            NativeUI.k(a, this.mz);
            if (!isNaN_(this.at)) {
                NativeUI.m(a, new Thickness(0, this.at));
            }
            if (this.disabled) {
                this.view.am(this.b8, this.k);
            }
            else if (this.focused && this.aj) {
                this.view.am(this.b9, this.k);
            }
            else {
                if (this.ak) {
                    this.view.am(this.ca, this.k);
                }
                else {
                    this.view.am(this.cb, this.k);
                }
            }
            if (this.disabled) {
                NativeUI.j(a, this.m0);
            }
            else if (this.focused && this.aj) {
                NativeUI.j(a, this.m3);
            }
            else {
                if (this.ak) {
                    NativeUI.j(a, this.m5);
                }
                else {
                    NativeUI.j(a, this.my);
                }
            }
            this.view.al(this.m8, BrushUtil.g(0, 0, 0, 0));
            if (this.u != null) {
                this.view.ao(this.u);
            }
            if (this.disabled) {
                NativeUI.n(this.view.o, this.m2);
                NativeUI.o(this.view.o, this.m2);
            }
            else if (this.focused && this.aj) {
                NativeUI.n(this.view.o, this.m4);
                NativeUI.o(this.view.o, this.m4);
            }
            else {
                NativeUI.n(this.view.o, this.m9);
                NativeUI.o(this.view.o, this.m9);
            }
        }
        ju(a) {
            this.r6 = ThemeResolver.e(a, Button.ri, Button.oz);
            this.ru = ThemeResolver.e(a, Button.q6, Button.on);
            this.nd = ThemeResolver.e(a, Button.px, Button.ne);
            this.m = ThemeResolver.a(a, Button.n, Button.l);
            this.rx = ThemeResolver.e(a, Button.q9, Button.oq);
            this.ry = ThemeResolver.e(a, Button.ra, Button.or);
            this.rz = ThemeResolver.e(a, Button.rb, Button.os);
            this.dx = ThemeResolver.c(a, Button.dp, Button.cs);
            this.d0 = ThemeResolver.c(a, Button.ds, Button.cv);
            this.dz = ThemeResolver.c(a, Button.dr, Button.cu);
            this.dy = ThemeResolver.c(a, Button.dq, Button.ct);
            this.rw = ThemeResolver.e(a, Button.q8, Button.op);
            this.r4 = ThemeResolver.e(a, Button.rg, Button.ox);
            this.kj = ThemeResolver.d(a, Button.kh, Button.j9);
            this.a9 = ThemeResolver.b(a, Button.a7, Button.az);
            this.rv = ThemeResolver.e(a, Button.q7, Button.oo);
            this.r5 = ThemeResolver.e(a, Button.rh, Button.oy);
            this.r3 = ThemeResolver.e(a, Button.rf, Button.ow);
            this.r2 = ThemeResolver.e(a, Button.re, Button.ov);
            this.r0 = ThemeResolver.e(a, Button.rc, Button.ot);
            this.r1 = ThemeResolver.e(a, Button.rd, Button.ou);
            this.pd = ThemeResolver.e(a, Button.qb, Button.ns);
            this.pe = ThemeResolver.e(a, Button.qc, Button.nt);
            this.pf = ThemeResolver.e(a, Button.qd, Button.nu);
            this.c0 = ThemeResolver.c(a, Button.dc, Button.cg);
            this.c3 = ThemeResolver.c(a, Button.df, Button.cj);
            this.c2 = ThemeResolver.c(a, Button.de, Button.ci);
            this.c1 = ThemeResolver.c(a, Button.dd, Button.ch);
            this.pc = ThemeResolver.e(a, Button.qa, Button.nr);
            this.pk = ThemeResolver.e(a, Button.qi, Button.nz);
            this.kb = ThemeResolver.d(a, Button.ke, Button.j6);
            this.a1 = ThemeResolver.b(a, Button.a4, Button.aw);
            this.pb = ThemeResolver.e(a, Button.p9, Button.nq);
            this.pl = ThemeResolver.e(a, Button.qj, Button.n0);
            this.pj = ThemeResolver.e(a, Button.qh, Button.ny);
            this.pi = ThemeResolver.e(a, Button.qg, Button.nx);
            this.pg = ThemeResolver.e(a, Button.qe, Button.nv);
            this.ph = ThemeResolver.e(a, Button.qf, Button.nw);
            this.rl = ThemeResolver.e(a, Button.qx, Button.oe);
            this.rm = ThemeResolver.e(a, Button.qy, Button.of);
            this.rn = ThemeResolver.e(a, Button.qz, Button.og);
            this.dt = ThemeResolver.c(a, Button.dk, Button.co);
            this.dw = ThemeResolver.c(a, Button.dn, Button.cr);
            this.dv = ThemeResolver.c(a, Button.dm, Button.cq);
            this.du = ThemeResolver.c(a, Button.dl, Button.cp);
            this.rk = ThemeResolver.e(a, Button.qw, Button.od);
            this.rs = ThemeResolver.e(a, Button.q4, Button.ol);
            this.ki = ThemeResolver.d(a, Button.kg, Button.j8);
            this.a8 = ThemeResolver.b(a, Button.a6, Button.ay);
            this.rj = ThemeResolver.e(a, Button.qv, Button.oc);
            this.rt = ThemeResolver.e(a, Button.q5, Button.om);
            this.rr = ThemeResolver.e(a, Button.q3, Button.ok);
            this.rq = ThemeResolver.e(a, Button.q2, Button.oj);
            this.ro = ThemeResolver.e(a, Button.q0, Button.oh);
            this.rp = ThemeResolver.e(a, Button.q1, Button.oi);
            this.po = ThemeResolver.e(a, Button.qm, Button.n3);
            this.pp = ThemeResolver.e(a, Button.qn, Button.n4);
            this.pq = ThemeResolver.e(a, Button.qo, Button.n5);
            this.c4 = ThemeResolver.c(a, Button.dg, Button.ck);
            this.c7 = ThemeResolver.c(a, Button.dj, Button.cn);
            this.c6 = ThemeResolver.c(a, Button.di, Button.cm);
            this.c5 = ThemeResolver.c(a, Button.dh, Button.cl);
            this.pn = ThemeResolver.e(a, Button.ql, Button.n2);
            this.pv = ThemeResolver.e(a, Button.qt, Button.oa);
            this.kc = ThemeResolver.d(a, Button.kf, Button.j7);
            this.a2 = ThemeResolver.b(a, Button.a5, Button.ax);
            this.pm = ThemeResolver.e(a, Button.qk, Button.n1);
            this.pw = ThemeResolver.e(a, Button.qu, Button.ob);
            this.pu = ThemeResolver.e(a, Button.qs, Button.n9);
            this.pt = ThemeResolver.e(a, Button.qr, Button.n8);
            this.pr = ThemeResolver.e(a, Button.qp, Button.n6);
            this.ps = ThemeResolver.e(a, Button.qq, Button.n7);
            this.o2 = ThemeResolver.e(a, Button.p0, Button.nh);
            this.o3 = ThemeResolver.e(a, Button.p1, Button.ni);
            this.o4 = ThemeResolver.e(a, Button.p2, Button.nj);
            this.cw = ThemeResolver.c(a, Button.c8, Button.cc);
            this.cz = ThemeResolver.c(a, Button.db, Button.cf);
            this.cy = ThemeResolver.c(a, Button.da, Button.ce);
            this.cx = ThemeResolver.c(a, Button.c9, Button.cd);
            this.o1 = ThemeResolver.e(a, Button.pz, Button.ng);
            this.o9 = ThemeResolver.e(a, Button.p7, Button.no);
            this.ka = ThemeResolver.d(a, Button.kd, Button.j5);
            this.a0 = ThemeResolver.b(a, Button.a3, Button.av);
            this.o0 = ThemeResolver.e(a, Button.py, Button.nf);
            this.pa = ThemeResolver.e(a, Button.p8, Button.np);
            this.o8 = ThemeResolver.e(a, Button.p6, Button.nn);
            this.o7 = ThemeResolver.e(a, Button.p5, Button.nm);
            this.o5 = ThemeResolver.e(a, Button.p3, Button.nk);
            this.o6 = ThemeResolver.e(a, Button.p4, Button.nl);
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.jo("Type", enumGetBox(ButtonDisplayStyle_$type, b), enumGetBox(ButtonDisplayStyle_$type, a));
            }
        }
        get h() {
            return this.f;
        }
        set h(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.jo("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.jo("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get g() {
            return this.e;
        }
        set g(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.jo("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get mz() {
            return this.kr;
        }
        set mz(a) {
            let b = this.kr;
            this.kr = a;
            if (b != this.kr) {
                this.jo("ActualBorderColor", b, a);
            }
        }
        get na() {
            return this.k2;
        }
        set na(a) {
            let b = this.k2;
            this.k2 = a;
            if (b != this.k2) {
                this.jo("ActualUmbraShadowColor", b, a);
            }
        }
        get m7() {
            return this.kz;
        }
        set m7(a) {
            let b = this.kz;
            this.kz = a;
            if (b != this.kz) {
                this.jo("ActualPenumbraShadowColor", b, a);
            }
        }
        get mx() {
            return this.kp;
        }
        set mx(a) {
            let b = this.kp;
            this.kp = a;
            if (b != this.kp) {
                this.jo("ActualAmbientShadowColor", b, a);
            }
        }
        get cb() {
            return this.bi;
        }
        set cb(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.jo("ActualRestingElevation", b, a);
            }
        }
        get b9() {
            return this.bg;
        }
        set b9(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.jo("ActualFocusElevation", b, a);
            }
        }
        get ca() {
            return this.bh;
        }
        set ca(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.jo("ActualHoverElevation", b, a);
            }
        }
        get m8() {
            return this.k0;
        }
        set m8(a) {
            let b = this.k0;
            this.k0 = a;
            if (b != this.k0) {
                this.jo("ActualRippleColor", b, a);
            }
        }
        get j2() {
            return this.jv;
        }
        set j2(a) {
            let b = this.jv;
            this.jv = a;
            if (b != this.jv) {
                this.jo("ActualCornerRadius", b, a);
            }
        }
        get my() {
            return this.kq;
        }
        set my(a) {
            let b = this.kq;
            this.kq = a;
            if (b != this.kq) {
                this.jo("ActualBackgroundColor", b, a);
            }
        }
        get m0() {
            return this.ks;
        }
        set m0(a) {
            let b = this.ks;
            this.ks = a;
            if (b != this.ks) {
                this.jo("ActualDisabledBackgroundColor", b, a);
            }
        }
        get m1() {
            return this.kt;
        }
        set m1(a) {
            let b = this.kt;
            this.kt = a;
            if (b != this.kt) {
                this.jo("ActualDisabledBorderColor", b, a);
            }
        }
        get m2() {
            return this.ku;
        }
        set m2(a) {
            let b = this.ku;
            this.ku = a;
            if (b != this.ku) {
                this.jo("ActualDisabledTextColor", b, a);
            }
        }
        get b8() {
            return this.bf;
        }
        set b8(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.jo("ActualDisabledElevation", b, a);
            }
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.jo("ActualElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get m9() {
            return this.k1;
        }
        set m9(a) {
            let b = this.k1;
            this.k1 = a;
            if (b != this.k1) {
                this.jo("ActualTextColor", b, a);
            }
        }
        get m6() {
            return this.ky;
        }
        set m6(a) {
            let b = this.ky;
            this.ky = a;
            if (b != this.ky) {
                this.jo("ActualHoverTextColor", b, a);
            }
        }
        get m3() {
            return this.kv;
        }
        set m3(a) {
            let b = this.kv;
            this.kv = a;
            if (b != this.kv) {
                this.jo("ActualFocusBackgroundColor", b, a);
            }
        }
        get m4() {
            return this.kw;
        }
        set m4(a) {
            let b = this.kw;
            this.kw = a;
            if (b != this.kw) {
                this.jo("ActualFocusTextColor", b, a);
            }
        }
        get m5() {
            return this.kx;
        }
        set m5(a) {
            let b = this.kx;
            this.kx = a;
            if (b != this.kx) {
                this.jo("ActualHoverBackgroundColor", b, a);
            }
        }
        get at() {
            return this.am;
        }
        set at(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.jo("ActualBorderWidth", b, a);
            }
        }
        get tm() {
            return this.mk;
        }
        set tm(a) {
            let b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.jo("RaisedBackgroundColor", b, a);
            }
        }
        get to() {
            return this.mm;
        }
        set to(a) {
            let b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.jo("RaisedDisabledBackgroundColor", b, a);
            }
        }
        get tp() {
            return this.mn;
        }
        set tp(a) {
            let b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.jo("RaisedDisabledBorderColor", b, a);
            }
        }
        get tq() {
            return this.mo;
        }
        set tq(a) {
            let b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.jo("RaisedDisabledTextColor", b, a);
            }
        }
        get ek() {
            return this.b2;
        }
        set ek(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.jo("RaisedDisabledElevation", b, a);
            }
        }
        get tt() {
            return this.mr;
        }
        set tt(a) {
            let b = this.mr;
            this.mr = a;
            if (b != this.mr) {
                this.jo("RaisedHoverBackgroundColor", b, a);
            }
        }
        get tn() {
            return this.ml;
        }
        set tn(a) {
            let b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.jo("RaisedBorderColor", b, a);
            }
        }
        get en() {
            return this.b5;
        }
        set en(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.jo("RaisedRestingElevation", b, a);
            }
        }
        get em() {
            return this.b4;
        }
        set em(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.jo("RaisedHoverElevation", b, a);
            }
        }
        get el() {
            return this.b3;
        }
        set el(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.jo("RaisedFocusElevation", b, a);
            }
        }
        get be() {
            return this.as;
        }
        set be(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.jo("RaisedBorderWidth", b, a);
            }
        }
        get ko() {
            return this.j1;
        }
        set ko(a) {
            let b = this.j1;
            this.j1 = a;
            {
                this.jo("RaisedCornerRadius", b, a);
            }
        }
        get tv() {
            return this.mt;
        }
        set tv(a) {
            let b = this.mt;
            this.mt = a;
            if (b != this.mt) {
                this.jo("RaisedRippleColor", b, a);
            }
        }
        get sl() {
            return this.li;
        }
        set sl(a) {
            let b = this.li;
            this.li = a;
            if (b != this.li) {
                this.jo("FlatBackgroundColor", b, a);
            }
        }
        get sn() {
            return this.lk;
        }
        set sn(a) {
            let b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.jo("FlatDisabledBackgroundColor", b, a);
            }
        }
        get so() {
            return this.ll;
        }
        set so(a) {
            let b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.jo("FlatDisabledBorderColor", b, a);
            }
        }
        get sp() {
            return this.lm;
        }
        set sp(a) {
            let b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.jo("FlatDisabledTextColor", b, a);
            }
        }
        get d6() {
            return this.bo;
        }
        set d6(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.jo("FlatDisabledElevation", b, a);
            }
        }
        get ss() {
            return this.lp;
        }
        set ss(a) {
            let b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.jo("FlatHoverBackgroundColor", b, a);
            }
        }
        get sm() {
            return this.lj;
        }
        set sm(a) {
            let b = this.lj;
            this.lj = a;
            if (b != this.lj) {
                this.jo("FlatBorderColor", b, a);
            }
        }
        get d9() {
            return this.br;
        }
        set d9(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.jo("FlatRestingElevation", b, a);
            }
        }
        get d8() {
            return this.bq;
        }
        set d8(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.jo("FlatHoverElevation", b, a);
            }
        }
        get d7() {
            return this.bp;
        }
        set d7(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.jo("FlatFocusElevation", b, a);
            }
        }
        get su() {
            return this.lr;
        }
        set su(a) {
            let b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.jo("FlatRippleColor", b, a);
            }
        }
        get sv() {
            return this.ls;
        }
        set sv(a) {
            let b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.jo("FlatTextColor", b, a);
            }
        }
        get st() {
            return this.lq;
        }
        set st(a) {
            let b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.jo("FlatHoverTextColor", b, a);
            }
        }
        get sq() {
            return this.ln;
        }
        set sq(a) {
            let b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.jo("FlatFocusBackgroundColor", b, a);
            }
        }
        get sr() {
            return this.lo;
        }
        set sr(a) {
            let b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.jo("FlatFocusTextColor", b, a);
            }
        }
        get bb() {
            return this.ap;
        }
        set bb(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.jo("FlatBorderWidth", b, a);
            }
        }
        get kl() {
            return this.jy;
        }
        set kl(a) {
            let b = this.jy;
            this.jy = a;
            {
                this.jo("FlatCornerRadius", b, a);
            }
        }
        get nb() {
            return this.k3;
        }
        set nb(a) {
            let b = this.k3;
            this.k3 = a;
            if (b != this.k3) {
                this.jo("BackgroundColor", b, a);
            }
        }
        get r7() {
            return this.k5;
        }
        set r7(a) {
            let b = this.k5;
            this.k5 = a;
            if (b != this.k5) {
                this.jo("DisabledBackgroundColor", b, a);
            }
        }
        get r8() {
            return this.k6;
        }
        set r8(a) {
            let b = this.k6;
            this.k6 = a;
            if (b != this.k6) {
                this.jo("DisabledBorderColor", b, a);
            }
        }
        get r9() {
            return this.k7;
        }
        set r9(a) {
            let b = this.k7;
            this.k7 = a;
            if (b != this.k7) {
                this.jo("DisabledTextColor", b, a);
            }
        }
        get d1() {
            return this.bj;
        }
        set d1(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.jo("DisabledElevation", b, a);
            }
        }
        get o() {
            return this.j;
        }
        set o(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.jo("ElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get sy() {
            return this.lv;
        }
        set sy(a) {
            let b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.jo("HoverBackgroundColor", b, a);
            }
        }
        get nc() {
            return this.k4;
        }
        set nc(a) {
            let b = this.k4;
            this.k4 = a;
            if (b != this.k4) {
                this.jo("BorderColor", b, a);
            }
        }
        get eo() {
            return this.b6;
        }
        set eo(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.jo("RestingElevation", b, a);
            }
        }
        get eb() {
            return this.bt;
        }
        set eb(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.jo("HoverElevation", b, a);
            }
        }
        get ea() {
            return this.bs;
        }
        set ea(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.jo("FocusElevation", b, a);
            }
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.jo("TextStyle", b, a);
            }
        }
        get ty() {
            return this.mw;
        }
        set ty(a) {
            let b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.jo("TextColor", b, a);
            }
        }
        get sz() {
            return this.lx;
        }
        set sz(a) {
            let b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.jo("HoverTextColor", b, a);
            }
        }
        get tx() {
            return this.mv;
        }
        set tx(a) {
            let b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.jo("RippleColor", b, a);
            }
        }
        get tw() {
            return this.mu;
        }
        set tw(a) {
            let b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.jo("RaisedTextColor", b, a);
            }
        }
        get tu() {
            return this.ms;
        }
        set tu(a) {
            let b = this.ms;
            this.ms = a;
            if (b != this.ms) {
                this.jo("RaisedHoverTextColor", b, a);
            }
        }
        get tr() {
            return this.mp;
        }
        set tr(a) {
            let b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.jo("RaisedFocusBackgroundColor", b, a);
            }
        }
        get ts() {
            return this.mq;
        }
        set ts(a) {
            let b = this.mq;
            this.mq = a;
            if (b != this.mq) {
                this.jo("RaisedFocusTextColor", b, a);
            }
        }
        get sw() {
            return this.lt;
        }
        set sw(a) {
            let b = this.lt;
            this.lt = a;
            if (b != this.lt) {
                this.jo("FocusBackgroundColor", b, a);
            }
        }
        get sx() {
            return this.lu;
        }
        set sx(a) {
            let b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.jo("FocusTextColor", b, a);
            }
        }
        get au() {
            return this.an;
        }
        set au(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.jo("BorderWidth", b, a);
            }
        }
        get j4() {
            return this.jw;
        }
        set j4(a) {
            let b = this.jw;
            this.jw = a;
            {
                this.jo("CornerRadius", b, a);
            }
        }
        get tb() {
            return this.l9;
        }
        set tb(a) {
            let b = this.l9;
            this.l9 = a;
            if (b != this.l9) {
                this.jo("OutlinedBackgroundColor", b, a);
            }
        }
        get td() {
            return this.mb;
        }
        set td(a) {
            let b = this.mb;
            this.mb = a;
            if (b != this.mb) {
                this.jo("OutlinedDisabledBackgroundColor", b, a);
            }
        }
        get te() {
            return this.mc;
        }
        set te(a) {
            let b = this.mc;
            this.mc = a;
            if (b != this.mc) {
                this.jo("OutlinedDisabledBorderColor", b, a);
            }
        }
        get tf() {
            return this.md;
        }
        set tf(a) {
            let b = this.md;
            this.md = a;
            if (b != this.md) {
                this.jo("OutlinedDisabledTextColor", b, a);
            }
        }
        get eg() {
            return this.by;
        }
        set eg(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.jo("OutlinedDisabledElevation", b, a);
            }
        }
        get ti() {
            return this.mg;
        }
        set ti(a) {
            let b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.jo("OutlinedHoverBackgroundColor", b, a);
            }
        }
        get tc() {
            return this.ma;
        }
        set tc(a) {
            let b = this.ma;
            this.ma = a;
            if (b != this.ma) {
                this.jo("OutlinedBorderColor", b, a);
            }
        }
        get ej() {
            return this.b1;
        }
        set ej(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.jo("OutlinedRestingElevation", b, a);
            }
        }
        get ei() {
            return this.b0;
        }
        set ei(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.jo("OutlinedHoverElevation", b, a);
            }
        }
        get eh() {
            return this.bz;
        }
        set eh(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.jo("OutlinedFocusElevation", b, a);
            }
        }
        get bd() {
            return this.ar;
        }
        set bd(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.jo("OutlinedBorderWidth", b, a);
            }
        }
        get kn() {
            return this.j0;
        }
        set kn(a) {
            let b = this.j0;
            this.j0 = a;
            {
                this.jo("OutlinedCornerRadius", b, a);
            }
        }
        get tk() {
            return this.mi;
        }
        set tk(a) {
            let b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.jo("OutlinedRippleColor", b, a);
            }
        }
        get tl() {
            return this.mj;
        }
        set tl(a) {
            let b = this.mj;
            this.mj = a;
            if (b != this.mj) {
                this.jo("OutlinedTextColor", b, a);
            }
        }
        get tj() {
            return this.mh;
        }
        set tj(a) {
            let b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.jo("OutlinedHoverTextColor", b, a);
            }
        }
        get tg() {
            return this.me;
        }
        set tg(a) {
            let b = this.me;
            this.me = a;
            if (b != this.me) {
                this.jo("OutlinedFocusBackgroundColor", b, a);
            }
        }
        get th() {
            return this.mf;
        }
        set th(a) {
            let b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.jo("OutlinedFocusTextColor", b, a);
            }
        }
        get sa() {
            return this.k8;
        }
        set sa(a) {
            let b = this.k8;
            this.k8 = a;
            if (b != this.k8) {
                this.jo("FabBackgroundColor", b, a);
            }
        }
        get sc() {
            return this.la;
        }
        set sc(a) {
            let b = this.la;
            this.la = a;
            if (b != this.la) {
                this.jo("FabDisabledBackgroundColor", b, a);
            }
        }
        get sd() {
            return this.lb;
        }
        set sd(a) {
            let b = this.lb;
            this.lb = a;
            if (b != this.lb) {
                this.jo("FabDisabledBorderColor", b, a);
            }
        }
        get se() {
            return this.lc;
        }
        set se(a) {
            let b = this.lc;
            this.lc = a;
            if (b != this.lc) {
                this.jo("FabDisabledTextColor", b, a);
            }
        }
        get d2() {
            return this.bk;
        }
        set d2(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.jo("FabDisabledElevation", b, a);
            }
        }
        get sh() {
            return this.lw;
        }
        set sh(a) {
            let b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.jo("FabHoverBackgroundColor", b, a);
            }
        }
        get sb() {
            return this.k9;
        }
        set sb(a) {
            let b = this.k9;
            this.k9 = a;
            if (b != this.k9) {
                this.jo("FabBorderColor", b, a);
            }
        }
        get d5() {
            return this.bn;
        }
        set d5(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.jo("FabRestingElevation", b, a);
            }
        }
        get d4() {
            return this.bm;
        }
        set d4(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.jo("FabHoverElevation", b, a);
            }
        }
        get d3() {
            return this.bl;
        }
        set d3(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.jo("FabFocusElevation", b, a);
            }
        }
        get ba() {
            return this.ao;
        }
        set ba(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.jo("FabBorderWidth", b, a);
            }
        }
        get kk() {
            return this.jx;
        }
        set kk(a) {
            let b = this.jx;
            this.jx = a;
            {
                this.jo("FabCornerRadius", b, a);
            }
        }
        get sj() {
            return this.lg;
        }
        set sj(a) {
            let b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.jo("FabRippleColor", b, a);
            }
        }
        get sk() {
            return this.lh;
        }
        set sk(a) {
            let b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.jo("FabTextColor", b, a);
            }
        }
        get si() {
            return this.lf;
        }
        set si(a) {
            let b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.jo("FabHoverTextColor", b, a);
            }
        }
        get sf() {
            return this.ld;
        }
        set sf(a) {
            let b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.jo("FabFocusBackgroundColor", b, a);
            }
        }
        get sg() {
            return this.le;
        }
        set sg(a) {
            let b = this.le;
            this.le = a;
            if (b != this.le) {
                this.jo("FabFocusTextColor", b, a);
            }
        }
        get s0() {
            return this.ly;
        }
        set s0(a) {
            let b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.jo("IconBackgroundColor", b, a);
            }
        }
        get s2() {
            return this.l0;
        }
        set s2(a) {
            let b = this.l0;
            this.l0 = a;
            if (b != this.l0) {
                this.jo("IconDisabledBackgroundColor", b, a);
            }
        }
        get s3() {
            return this.l1;
        }
        set s3(a) {
            let b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.jo("IconDisabledBorderColor", b, a);
            }
        }
        get s4() {
            return this.l2;
        }
        set s4(a) {
            let b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.jo("IconDisabledTextColor", b, a);
            }
        }
        get ec() {
            return this.bu;
        }
        set ec(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.jo("IconDisabledElevation", b, a);
            }
        }
        get s7() {
            return this.l5;
        }
        set s7(a) {
            let b = this.l5;
            this.l5 = a;
            if (b != this.l5) {
                this.jo("IconHoverBackgroundColor", b, a);
            }
        }
        get s1() {
            return this.lz;
        }
        set s1(a) {
            let b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.jo("IconBorderColor", b, a);
            }
        }
        get ef() {
            return this.bx;
        }
        set ef(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.jo("IconRestingElevation", b, a);
            }
        }
        get ee() {
            return this.bw;
        }
        set ee(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.jo("IconHoverElevation", b, a);
            }
        }
        get ed() {
            return this.bv;
        }
        set ed(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.jo("IconFocusElevation", b, a);
            }
        }
        get bc() {
            return this.aq;
        }
        set bc(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.jo("IconBorderWidth", b, a);
            }
        }
        get km() {
            return this.jz;
        }
        set km(a) {
            let b = this.jz;
            this.jz = a;
            {
                this.jo("IconCornerRadius", b, a);
            }
        }
        get s9() {
            return this.l7;
        }
        set s9(a) {
            let b = this.l7;
            this.l7 = a;
            if (b != this.l7) {
                this.jo("IconRippleColor", b, a);
            }
        }
        get ta() {
            return this.l8;
        }
        set ta(a) {
            let b = this.l8;
            this.l8 = a;
            if (b != this.l8) {
                this.jo("IconTextColor", b, a);
            }
        }
        get s8() {
            return this.l6;
        }
        set s8(a) {
            let b = this.l6;
            this.l6 = a;
            if (b != this.l6) {
                this.jo("IconHoverTextColor", b, a);
            }
        }
        get s5() {
            return this.l3;
        }
        set s5(a) {
            let b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.jo("IconFocusBackgroundColor", b, a);
            }
        }
        get s6() {
            return this.l4;
        }
        set s6(a) {
            let b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.jo("IconFocusTextColor", b, a);
            }
        }
        get hz() {
            return this.e0;
        }
        set hz(a) {
            let b = this.e0;
            this.e0 = a;
            if (b != this.e0) {
                this.jo("InputId", b, a);
            }
        }
        get hx() {
            return this.ez;
        }
        set hx(a) {
            let b = this.ez;
            this.ez = a;
            if (b != this.ez) {
                this.jo("Id", b, a);
            }
        }
        get f5() {
            return this.ew;
        }
        set f5(a) {
            let b = this.ew;
            this.ew = a;
            if (b != this.ew) {
                this.jo("Display", b, a);
            }
        }
        get g6() {
            return this.ex;
        }
        set g6(a) {
            let b = this.ex;
            this.ex = a;
            if (b != this.ex) {
                this.jo("FlexDirection", b, a);
            }
        }
        get g8() {
            return this.ey;
        }
        set g8(a) {
            let b = this.ey;
            this.ey = a;
            if (b != this.ey) {
                this.jo("FlexGrow", b, a);
            }
        }
        get fp() {
            return this.eu;
        }
        set fp(a) {
            let b = this.eu;
            this.eu = a;
            if (b != this.eu) {
                this.jo("AlignItems", b, a);
            }
        }
        get et() {
            return this.es;
        }
        set et(a) {
            let b = this.es;
            this.es = a;
            if (b != this.es) {
                this.jo("Value", b, a);
            }
        }
        get h5() {
            return this.e1;
        }
        set h5(a) {
            let b = this.e1;
            this.e1 = a;
            if (b != this.e1) {
                this.jo("Name", b, a);
            }
        }
        get ag() {
            return this.y;
        }
        get ep() {
            return this.b7;
        }
        set ep(a) {
            let b = this.b7;
            this.b7 = a;
            this.y = true;
            if (b != this.b7) {
                this.jo("TabIndex", b, a);
            }
        }
        get focused() {
            return this.aa;
        }
        set focused(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.jo("IsFocused", b, a);
            }
        }
        get aj() {
            return this.ab;
        }
        set aj(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.jo("IsFocusStyleEnabled", b, a);
            }
        }
        get fr() {
            return this.ev;
        }
        set fr(a) {
            let b = this.ev;
            this.ev = a;
            if (b != this.ev) {
                this.jo("AriaLabel", b, a);
            }
        }
        get ae() {
            return this.w;
        }
        set ae(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.jo("DisableRipple", b, a);
            }
        }
        get ad() {
            return this.v;
        }
        set ad(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.jo("ActualDisableRipple", b, a);
            }
        }
        get ak() {
            return this.ac;
        }
        set ak(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.jo("IsHover", b, a);
            }
        }
        get disabled() {
            return this.z;
        }
        set disabled(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.jo("IsDisabled", b, a);
            }
        }
        get af() {
            return this.x;
        }
        set af(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.jo("DisableTransitions", b, a);
            }
        }
        jp() {
            this.jg();
            this.view.al(this.m8, BrushUtil.g(0, 0, 0, 0));
            this.js();
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        jg() {
            this.view.x();
        }
        onDetachedFromUI() {
            this.view.ab();
        }
        onAttachedToUI() {
            this.view.z();
        }
        appendButtonContent(a) {
            this.view.w(a);
        }
        al() {
            return this.view.f();
        }
        provideContainer(a) {
            this.view.aa(a);
        }
    }
    Button.$t = /*@__PURE__*/ markType(Button, 'Button', Base.$, [INotifyPropertyChanged_$type]);
    Button.ri = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.q6 = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Button.px = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    Button.n = 1;
    Button.q9 = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.ra = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.rb = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.dp = 0;
    Button.ds = 2;
    Button.dr = 4;
    Button.dq = 8;
    Button.q8 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.rg = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.kh = /*@__PURE__*/ new CornerRadius(0, 4);
    Button.a7 = NaN;
    Button.q7 = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.rh = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.rf = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.re = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    Button.rc = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    Button.rd = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.qb = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qc = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qd = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.dc = 0;
    Button.df = 0;
    Button.de = 0;
    Button.dd = 0;
    Button.qa = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.qi = null;
    Button.ke = /*@__PURE__*/ new CornerRadius(0, 4);
    Button.a4 = NaN;
    Button.p9 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qj = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.qh = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.qg = /*@__PURE__*/ BrushUtil.g(13, 228, 28, 119);
    Button.qe = /*@__PURE__*/ BrushUtil.g(30, 228, 28, 119);
    Button.qf = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.qx = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qy = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Button.qz = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.dk = 0;
    Button.dn = 0;
    Button.dm = 0;
    Button.dl = 0;
    Button.qw = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Button.q4 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.kg = /*@__PURE__*/ new CornerRadius(0, 4);
    Button.a6 = 1;
    Button.qv = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.q5 = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.q3 = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.q2 = /*@__PURE__*/ BrushUtil.g(13, 228, 28, 119);
    Button.q0 = /*@__PURE__*/ BrushUtil.g(30, 228, 28, 119);
    Button.q1 = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.qm = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qn = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qo = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.dg = 0;
    Button.dj = 0;
    Button.di = 0;
    Button.dh = 0;
    Button.ql = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.qt = null;
    Button.kf = /*@__PURE__*/ new CornerRadius(0, 28);
    Button.a5 = NaN;
    Button.qk = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.qu = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.qs = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.qr = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Button.qp = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.qq = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.p0 = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.p1 = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.p2 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.c8 = 0;
    Button.db = 6;
    Button.da = 12;
    Button.c9 = 12;
    Button.pz = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.p7 = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.kd = /*@__PURE__*/ new CornerRadius(0, 28);
    Button.a3 = NaN;
    Button.py = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Button.p8 = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.p6 = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.p5 = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    Button.p3 = /*@__PURE__*/ BrushUtil.g(255, 220, 83, 145);
    Button.p4 = /*@__PURE__*/ BrushUtil.g(255, 0, 0, 0);
    Button.oz = /*@__PURE__*/ BrushUtil.g(100, 33, 150, 243);
    Button.on = /*@__PURE__*/ BrushUtil.g(70, 33, 150, 243);
    Button.ne = /*@__PURE__*/ BrushUtil.g(40, 33, 150, 243);
    Button.l = 2;
    Button.oq = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.or = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.os = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.cs = 0;
    Button.cv = 0;
    Button.cu = 0;
    Button.ct = 2;
    Button.op = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.ox = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.j9 = /*@__PURE__*/ new CornerRadius(0, 3);
    Button.az = NaN;
    Button.oo = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.oy = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.ow = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.ov = /*@__PURE__*/ BrushUtil.g(255, 27, 135, 220);
    Button.ot = /*@__PURE__*/ BrushUtil.g(255, 21, 112, 184);
    Button.ou = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.ns = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.nt = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.nu = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.cg = 0;
    Button.cj = 0;
    Button.ci = 0;
    Button.ch = 2;
    Button.nr = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.nz = /*@__PURE__*/ BrushUtil.g(100, 33, 150, 243);
    Button.j6 = /*@__PURE__*/ new CornerRadius(0, 3);
    Button.aw = NaN;
    Button.nq = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.n0 = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    Button.ny = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    Button.nx = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    Button.nv = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.nw = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.oe = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.of = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Button.og = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.co = 0;
    Button.cr = 0;
    Button.cq = 0;
    Button.cp = 2;
    Button.od = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.ol = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.j8 = /*@__PURE__*/ new CornerRadius(0, 3);
    Button.ay = 1;
    Button.oc = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.om = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.ok = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.oj = /*@__PURE__*/ BrushUtil.g(26, 33, 150, 243);
    Button.oh = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.oi = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.n3 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.n4 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.n5 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.ck = 0;
    Button.cn = 0;
    Button.cm = 0;
    Button.cl = 2;
    Button.n2 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.oa = null;
    Button.j7 = /*@__PURE__*/ new CornerRadius(0, 28);
    Button.ax = NaN;
    Button.n1 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    Button.ob = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    Button.n9 = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    Button.n8 = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Button.n6 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.n7 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.nh = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.ni = /*@__PURE__*/ BrushUtil.g(10, 0, 0, 0);
    Button.nj = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Button.cc = 0;
    Button.cf = 0;
    Button.ce = 0;
    Button.cd = 2;
    Button.ng = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Button.no = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.j5 = /*@__PURE__*/ new CornerRadius(0, 28);
    Button.av = NaN;
    Button.nf = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Button.np = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.nn = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.nm = /*@__PURE__*/ BrushUtil.g(255, 27, 135, 220);
    Button.nk = /*@__PURE__*/ BrushUtil.g(255, 21, 112, 184);
    Button.nl = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Button.c = 2;
    Button.er = 0;
    Button.eq = 0;
    return Button;
})();
//# sourceMappingURL=ButtonView_combined.js.map
