/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "igniteui-react-core";
import { Ripple } from "./Ripple";
import { List$1 } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { stringReplace } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CheckboxLabelPosition_$type } from "./CheckboxLabelPosition";
import { ThemeResolver } from "./ThemeResolver";
import { CornerRadius } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { CheckboxChangeEventArgs } from "./CheckboxChangeEventArgs";
import { BrushUtil } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TransformGroup } from "igniteui-react-core";
import { RotateTransform } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let CheckboxView = /*@__PURE__*/ (() => {
    class CheckboxView extends Base {
        constructor() {
            super();
            this.c = null;
            this.l = null;
            this.f = null;
            this.j = new List$1(Delegate_$type, 0);
            this.g = true;
            this.q = null;
            this.m = null;
            this.p = null;
            this.n = null;
            this.d = null;
            this.o = null;
        }
        ad() {
        }
        i() {
            return true;
        }
        ab(a) {
            if (a == null) {
                for (let b of fromEnum(this.j)) {
                    b();
                }
                this.j.clear();
                return;
            }
            this.l = a;
            this.l.rootWrapper.setStyleProperty("display", "flex");
            this.l.rootWrapper.setStyleProperty("flex-direction", "row");
            this.l.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.l.rootWrapper.setStyleProperty("align-items", "center");
            let c = this.l.createElement("input");
            this.q = c;
            this.q.addClass("ig-native-checkbox");
            this.q.setStyleProperty("position", "absolute");
            this.q.setStyleProperty("width", "1px");
            this.q.setStyleProperty("height", "1px");
            this.q.setStyleProperty("margin", "-1px");
            this.q.setStyleProperty("border", "none");
            this.q.setStyleProperty("clip", "rect(0, 0, 0, 0)");
            this.q.setStyleProperty("outline", "0");
            this.q.setStyleProperty("pointer-events", "none");
            this.q.setStyleProperty("overflow", "hidden");
            this.q.setStyleProperty("-webkit-appearance", "none");
            this.q.setStyleProperty("-moz-appearance", "none");
            this.q.setStyleProperty("appearance", "none");
            this.q.setAttribute("type", "checkbox");
            this.q.setAttribute("id", this.c.bv);
            this.ag();
            this.j.add(c.listen("change", runOn(this, this.v)));
            this.j.add(c.listen("click", runOn(this, this.w)));
            this.j.add(c.listen("focus", runOn(this, this.x)));
            this.j.add(c.listen("blur", runOn(this, this.u)));
            this.l.append(c);
            let d = this.l.createElement("div");
            d.addClass("ig-checkbox-box");
            d.setStyleProperty("width", "1.25em");
            d.setStyleProperty("height", "1.25em");
            d.setStyleProperty("position", "relative");
            this.m = d;
            this.l.append(d);
            let e = this.l.createElement("label");
            e.setAttribute("for", this.c.bv);
            e.addClass("ig-checkbox-composite");
            e.setStyleProperty("box-sizing", "border-box");
            e.setStyleProperty("position", "relative");
            e.setStyleProperty("display", "inline-block");
            e.setStyleProperty("cursor", "pointer");
            e.setStyleProperty("width", "1.25em");
            e.setStyleProperty("height", "1.25em");
            e.setStyleProperty("min-width", "1.25em");
            e.setStyleProperty("border-width", "0.125rem");
            e.setStyleProperty("border-style", "solid");
            e.setStyleProperty("border-color", "rgba(0,0,0,0.54)");
            e.setStyleProperty("border-top-color", "rgba(0, 0, 0, 0.54)");
            e.setStyleProperty("border-right-color", "rgba(0, 0, 0, 0.54)");
            e.setStyleProperty("border-bottom-color", "rgba(0, 0, 0, 0.54)");
            e.setStyleProperty("border-left-color", "rgba(0, 0, 0, 0.54)");
            e.setStyleProperty("border-radius", "2px");
            e.setStyleProperty("-webkit-tap-highlight-color", "transparent");
            e.setStyleProperty("overflow", "hidden");
            this.p = e;
            this.m.append(e);
            let f = this.l.createElementNS("svg", "http://www.w3.org/2000/svg");
            f.setAttribute("viewBox", "0 0 24 24");
            f.addClass("ig-checkbox-mark");
            f.setStyleProperty("position", "absolute");
            f.setStyleProperty("top", "0");
            f.setStyleProperty("left", "0");
            f.setStyleProperty("right", "0");
            f.setStyleProperty("bottom", "0");
            f.setStyleProperty("stroke", "#fff");
            f.setStyleProperty("stroke-linecap", "square");
            f.setStyleProperty("stroke-width", "3");
            f.setStyleProperty("stroke-dasharray", "24");
            f.setStyleProperty("stroke-dashoffset", "24");
            f.setStyleProperty("fill", "none");
            f.setStyleProperty("opacity", "0");
            f.setStyleProperty("z-index", "1");
            this.n = f;
            e.append(f);
            let g = this.l.createElementNS("path", "http://www.w3.org/2000/svg");
            g.setAttribute("d", "M4.1,12.7 9,17.6 20.3,6.3");
            f.append(g);
            let h = this.l.createElement("div");
            let i = this.l.getSubRenderer(h);
            h.setStyleProperty("position", "absolute");
            h.setStyleProperty("width", "3em");
            h.setStyleProperty("height", "3em");
            h.setStyleProperty("right", "calc(50% - 1.5em)");
            h.setStyleProperty("top", "calc(50% - 1.5em)");
            h.setStyleProperty("border-radius", "24px");
            h.setStyleProperty("overflow", "hidden");
            let j = new Ripple();
            j.provideContainer(i);
            j.p = d;
            let k = this.l.getExternal(j, this.l.rootWrapper, this.l.getExternal(this.c, null, null));
            j.g = true;
            j.j = true;
            this.d = j;
            d.append(h);
            let l = this.l.createElement("span");
            l.addClass("ig-checkbox-label");
            l.setStyleProperty("font-family", "'Segoe UI', Verdana");
            l.setStyleProperty("font-weight", "400");
            l.setStyleProperty("font-size", "1rem");
            l.setStyleProperty("letter-spacing", ".00937rem");
            l.setStyleProperty("text-transform", "none");
            l.setStyleProperty("line-height", "1.5rem");
            l.setStyleProperty("margin-left", "8px");
            l.setStyleProperty("margin-top", "0");
            l.setStyleProperty("margin-bottom", "0");
            l.setStyleProperty("cursor", "pointer");
            l.setStyleProperty("role", "label");
            this.o = l;
            this.j.add(l.listen("click", runOn(this, this.t)));
            this.l.append(l);
            this.l.getPortal(l, "ChildContent", (m) => {
            }, true);
            this.c.cj();
        }
        t(a) {
            this.c.toggle();
        }
        ag() {
            if (this.i()) {
                let a = this.c.bv;
                this.q.setAttribute("name", this.c.b4);
                this.q.setProperty("value", this.c.a3);
                if (this.c.u) {
                    this.q.setAttribute("tabindex", this.c.az.toString());
                }
                this.q.setProperty("disabled", this.c.disabled);
                this.q.setProperty("indeterminate", this.c.indeterminate);
                this.q.setProperty("checked", this.c.checked);
                this.q.setProperty("required", this.c.ay);
                if (this.c.indeterminate) {
                    this.q.setAttribute("aria-checked", "mixed");
                }
                else {
                    this.q.setAttribute("aria-checked", this.c.checked ? "true" : "false");
                }
                this.q.setAttribute("aria-labelledby", this.c.bj);
                this.q.setAttribute("aria-label", this.c.bi);
            }
        }
        ae() {
            if (this.i()) {
                let a = this.c.bv;
                this.q.setAttribute("id", a);
                this.p.setAttribute("for", a);
            }
        }
        u(a) {
            this.c.focused = false;
        }
        x(a) {
            this.c.focused = true;
        }
        w(a) {
            a.stopPropagation();
            if (this.h()) {
                let native_ = this.q.getNativeElement();
                native_.blur();
            }
            this.c.toggle();
        }
        h() {
            return false;
        }
        v(a) {
            a.stopPropagation();
        }
        y() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.p, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
        }
        z(a) {
        }
        get r() {
            return this.p;
        }
        get e() {
            return this.d;
        }
        get s() {
            return this.n;
        }
        aa() {
            this.g = true;
            this.j.add(this.q.listen("change", runOn(this, this.v)));
            this.j.add(this.q.listen("click", runOn(this, this.w)));
            this.j.add(this.q.listen("focus", runOn(this, this.x)));
            this.j.add(this.q.listen("blur", runOn(this, this.u)));
            this.j.add(this.o.listen("click", runOn(this, this.t)));
        }
        ac() {
            this.g = false;
            for (let a of fromEnum(this.j)) {
                a();
            }
            this.j.clear();
        }
        af() {
            let model_ = this.c;
            if (model_.externalObject && model_.externalObject.refreshDefaults) {
                model_.externalObject.refreshDefaults();
            }
            ;
        }
        ah(a, b) {
            this.d.au = a;
            this.d.at = b;
        }
        k() {
            let a = this.p.getStyleProperty("border-top-width");
            a = stringReplace(a, "px", "");
            return parseFloat(a);
        }
    }
    CheckboxView.$t = /*@__PURE__*/ markType(CheckboxView, 'CheckboxView');
    return CheckboxView;
})();
/**
 * @hidden
 */
export let Checkbox = /*@__PURE__*/ (() => {
    class Checkbox extends Base {
        constructor() {
            super();
            this._view = null;
            this.b = 0;
            this.m = false;
            this.aa = false;
            this.c0 = null;
            this.cv = ThemeResolver.e(Checkbox.c, Checkbox.dj, Checkbox.de);
            this.cx = null;
            this.cz = null;
            this.cu = ThemeResolver.e(Checkbox.c, Checkbox.di, Checkbox.dd);
            this.c1 = null;
            this.cy = null;
            this.dn = ThemeResolver.e(Checkbox.c, Checkbox.dk, Checkbox.df);
            this.da = ThemeResolver.e(Checkbox.c, Checkbox.dh, Checkbox.dc);
            this.am = ThemeResolver.b(Checkbox.c, Checkbox.ar, Checkbox.ao);
            this.c9 = ThemeResolver.e(Checkbox.c, Checkbox.dg, Checkbox.db);
            this.an = ThemeResolver.b(Checkbox.c, Checkbox.as, Checkbox.ap);
            this.dl = ThemeResolver.e(Checkbox.c, Checkbox.di, Checkbox.dd);
            this.au = ThemeResolver.b(Checkbox.c, Checkbox.at, Checkbox.aq);
            this.dm = ThemeResolver.e(Checkbox.c, Checkbox.dj, Checkbox.de);
            this.cw = ThemeResolver.e(Checkbox.c, Checkbox.dk, Checkbox.df);
            this.ct = ThemeResolver.e(Checkbox.c, Checkbox.dh, Checkbox.dc);
            this.ae = NaN;
            this.ab = ThemeResolver.b(Checkbox.c, Checkbox.ar, Checkbox.ao);
            this.af = NaN;
            this.ag = NaN;
            this.ad = ThemeResolver.b(Checkbox.c, Checkbox.at, Checkbox.aq);
            this.ac = ThemeResolver.b(Checkbox.c, Checkbox.as, Checkbox.ap);
            this.cs = ThemeResolver.e(Checkbox.c, Checkbox.dg, Checkbox.db);
            this.a7 = "ig-native-checkbox-" + Checkbox.a1++;
            this.a6 = "ig-checkbox-" + Checkbox.a0++;
            this.a8 = null;
            this.a2 = null;
            this.a9 = null;
            this.ax = 0;
            this.n = false;
            this.aw = 0;
            this.q = false;
            this.a5 = null;
            this.a4 = null;
            this.change = null;
            this.f = 0;
            this.k = false;
            this.o = false;
            this.r = false;
            this.p = false;
            this.l = false;
            this.i = null;
            this.j = null;
            this.propertyChanged = null;
            this.a8 = this.a6 + "-label";
            this.a5 = this.a8;
            let a = new CheckboxView();
            a.c = this;
            this.view = a;
            this.view.ad();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.ci("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        destroy() {
            this.provideContainer(null);
        }
        ci(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ck(a, b, c);
        }
        co() {
            this.c4 = this.dp != null ? this.dp : this.dl;
            this.c6 = this.dr != null ? this.dr : this.dn;
            this.c3 = this.c8 != null ? this.c8 : this.da;
            this.ah = !isNaN_(this.ak) ? this.ak : this.am;
            this.c2 = this.c7 != null ? this.c7 : this.c9;
            this.c5 = this.dq != null ? this.dq : this.dm;
            this.ai = !isNaN_(this.al) ? this.al : this.an;
            this.aj = !isNaN_(this.av) ? this.av : this.au;
        }
        ck(a, b, c) {
            switch (a) {
                case "BaseTheme":
                    this.cr(this.d);
                    this.co();
                    break;
                case "TickColor":
                    this.c4 = this.dp != null ? this.dp : this.dl;
                    break;
                case "UncheckedBorderColor":
                    this.c6 = this.dr != null ? this.dr : this.dn;
                    break;
                case "CheckedBorderColor":
                    this.c3 = this.c8 != null ? this.c8 : this.da;
                    break;
                case "BorderWidth":
                    this.ah = !isNaN_(this.ak) ? this.ak : this.am;
                    break;
                case "CheckedBackgroundColor":
                    this.c2 = this.c7 != null ? this.c7 : this.c9;
                    break;
                case "UncheckedBackgroundColor":
                    this.c5 = this.dq != null ? this.dq : this.dm;
                    break;
                case "CornerRadius":
                    this.ai = !isNaN_(this.al) ? this.al : this.an;
                    break;
                case "TickStrokeWidth":
                    this.aj = !isNaN_(this.av) ? this.av : this.au;
                    break;
                case "ActualTickStrokeWidth":
                case "ActualTickColor":
                    this.cq();
                    break;
                case "ActualCheckedBackgroundColor":
                case "ActualUncheckedBackgroundColor":
                case "ActualUncheckedBorderColor":
                case "ActualCheckedBorderColor":
                case "ActualBorderWidth":
                    if (this.i != null) {
                        this.i.cancel();
                    }
                    if (this.j != null) {
                        this.j.cancel();
                    }
                    this.i = null;
                    this.j = null;
                    this.cn();
                    let d = (this.t);
                    this.t = true;
                    this.cp(this.indeterminate);
                    this.t = d;
                    break;
                case "ActualCornerRadius":
                    this.cn();
                    break;
                case "IsChecked":
                    if (!this.m) {
                        let e = this.indeterminate;
                        this.m = true;
                        this.indeterminate = false;
                        this.m = false;
                        let f = (this.t);
                        this.t = true;
                        this.cp(e);
                        this.t = f;
                    }
                    break;
                case "IsIndeterminate":
                    if (!this.m) {
                        this.cp(b);
                    }
                    break;
                case "DisableRipple":
                    this.view.e.h = this.s;
                    break;
                case "InputId":
                    this.view.ae();
                    break;
            }
        }
        cn() {
            let a = this.view.r;
            NativeUI.l(a, new CornerRadius(0, this.ai));
            if (!isNaN_(this.ah)) {
                NativeUI.m(a, new Thickness(0, this.ah));
            }
            if (this.checked) {
                NativeUI.j(a, this.c2);
                NativeUI.k(a, this.c3);
            }
            else {
                NativeUI.j(a, this.c5);
                NativeUI.k(a, this.c6);
            }
        }
        cq() {
            let a = this.view.s;
            NativeUI.v(a, this.c4);
            NativeUI.y(a, this.aj);
        }
        get dq() {
            return this.c0;
        }
        set dq(a) {
            let b = this.c0;
            this.c0 = a;
            if (b != this.c0) {
                this.ci("UncheckedBackgroundColor", b, a);
            }
        }
        get c5() {
            return this.cv;
        }
        set c5(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.ci("ActualUncheckedBackgroundColor", b, a);
            }
        }
        get c7() {
            return this.cx;
        }
        set c7(a) {
            let b = this.cx;
            this.cx = a;
            if (b != this.cx) {
                this.ci("CheckedBackgroundColor", b, a);
            }
        }
        get dp() {
            return this.cz;
        }
        set dp(a) {
            let b = this.cz;
            this.cz = a;
            if (b != this.cz) {
                this.ci("TickColor", b, a);
            }
        }
        get c4() {
            return this.cu;
        }
        set c4(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.ci("ActualTickColor", b, a);
            }
        }
        get dr() {
            return this.c1;
        }
        set dr(a) {
            let b = this.c1;
            this.c1 = a;
            if (b != this.c1) {
                this.ci("UncheckedBorderColor", b, a);
            }
        }
        get c8() {
            return this.cy;
        }
        set c8(a) {
            let b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.ci("CheckedBorderColor", b, a);
            }
        }
        cr(a) {
            this.dn = ThemeResolver.e(a, Checkbox.dk, Checkbox.df);
            this.da = ThemeResolver.e(a, Checkbox.dh, Checkbox.dc);
            this.am = ThemeResolver.b(a, Checkbox.ar, Checkbox.ao);
            this.c9 = ThemeResolver.e(a, Checkbox.dg, Checkbox.db);
            this.an = ThemeResolver.b(a, Checkbox.as, Checkbox.ap);
            this.dl = ThemeResolver.e(a, Checkbox.di, Checkbox.dd);
            this.au = ThemeResolver.b(a, Checkbox.at, Checkbox.aq);
            this.dm = ThemeResolver.e(a, Checkbox.dj, Checkbox.de);
        }
        get c6() {
            return this.cw;
        }
        set c6(a) {
            let b = this.cw;
            this.cw = a;
            if (b != this.cw) {
                this.ci("ActualUncheckedBorderColor", b, a);
            }
        }
        get c3() {
            return this.ct;
        }
        set c3(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.ci("ActualCheckedBorderColor", b, a);
            }
        }
        get ak() {
            return this.ae;
        }
        set ak(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.ci("BorderWidth", b, a);
            }
        }
        get ah() {
            return this.ab;
        }
        set ah(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.ci("ActualBorderWidth", b, a);
            }
        }
        get al() {
            return this.af;
        }
        set al(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.ci("CornerRadius", b, a);
            }
        }
        get av() {
            return this.ag;
        }
        set av(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.ci("TickStrokeWidth", b, a);
            }
        }
        get aj() {
            return this.ad;
        }
        set aj(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.ci("ActualTickStrokeWidth", b, a);
            }
        }
        get ai() {
            return this.ac;
        }
        set ai(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.ci("ActualCornerRadius", b, a);
            }
        }
        get c2() {
            return this.cs;
        }
        set c2(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.ci("ActualCheckedBackgroundColor", b, a);
            }
        }
        get bv() {
            return this.a7;
        }
        set bv(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.ci("InputId", b, a);
            }
        }
        get bt() {
            return this.a6;
        }
        set bt(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.ci("Id", b, a);
            }
        }
        get labelId() {
            return this.a8;
        }
        set labelId(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.ci("LabelId", b, a);
            }
        }
        get a3() {
            return this.a2;
        }
        set a3(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.ci("Value", b, a);
            }
        }
        get b4() {
            return this.a9;
        }
        set b4(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.ci("Name", b, a);
            }
        }
        get u() {
            return this.n;
        }
        get az() {
            return this.ax;
        }
        set az(a) {
            let b = this.ax;
            this.ax = a;
            this.n = true;
            if (b != this.ax) {
                this.ci("TabIndex", b, a);
            }
        }
        get ay() {
            return this.aw;
        }
        set ay(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.ci("Required", b, a);
            }
        }
        get focused() {
            return this.q;
        }
        set focused(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ci("IsFocused", b, a);
            }
        }
        get bj() {
            return this.a5;
        }
        set bj(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.ci("AriaLabelledBy", b, a);
            }
        }
        get bi() {
            return this.a4;
        }
        set bi(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.ci("AriaLabel", b, a);
            }
        }
        get g() {
            return this.f;
        }
        set g(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.ci("LabelPosition", enumGetBox(CheckboxLabelPosition_$type, b), enumGetBox(CheckboxLabelPosition_$type, a));
            }
        }
        get s() {
            return this.k;
        }
        set s(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.ci("DisableRipple", b, a);
            }
        }
        get checked() {
            return this.o;
        }
        set checked(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ci("IsChecked", b, a);
            }
        }
        get indeterminate() {
            return this.r;
        }
        set indeterminate(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ci("IsIndeterminate", b, a);
            }
        }
        get disabled() {
            return this.p;
        }
        set disabled(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ci("IsDisabled", b, a);
            }
        }
        get t() {
            return this.l;
        }
        set t(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.ci("DisableTransitions", b, a);
            }
        }
        cj() {
            this.ce();
            if (this.checked) {
                this.view.ah(BrushUtil.n(this.c2, 0.6), BrushUtil.n(this.c2, 0.1));
            }
            else {
                this.view.ah(BrushUtil.n(this.c2, 0.6), BrushUtil.n(this.c6, 0.1));
            }
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        ce() {
            this.view.y();
            let a = false;
            if (this.i == null) {
                if (!a) {
                    a = true;
                    this.view.af();
                }
                this.i = KeyFrameAnimationFactory.f.c(this.view.a(this.a).m(new AnimationKeyFrameProperty(2, this.c5), new AnimationKeyFrameProperty(3, this.c6)).m(new AnimationKeyFrameProperty(2, this.c2), new AnimationKeyFrameProperty(3, this.c3)));
                this.j = KeyFrameAnimationFactory.f.c(this.view.b(this.a).m(new AnimationKeyFrameProperty(19, 24), new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(19, 0), new AnimationKeyFrameProperty(1, 1)));
            }
        }
        toggle() {
            if (this.disabled) {
                return;
            }
            this.ce();
            this.focused = false;
            this.m = true;
            let a = false;
            if (this.indeterminate) {
                a = true;
                this.checked = true;
            }
            this.indeterminate = false;
            this.checked = !this.checked;
            this.m = false;
            this.cp(a);
            if (this.change != null) {
                let b = new CheckboxChangeEventArgs();
                b.isChecked = this.checked;
                b.isIndeterminate = this.indeterminate;
                this.change(this, b);
            }
        }
        cp(a) {
            this.ce();
            let b = this.checked;
            if (this.indeterminate) {
                b = true;
            }
            let c = 1;
            if (!b) {
                c = -1;
            }
            if (b) {
                this.view.ah(BrushUtil.n(this.c2, 0.6), BrushUtil.n(this.c2, 0.1));
            }
            else {
                this.view.ah(BrushUtil.n(this.c2, 0.6), BrushUtil.n(this.c6, 0.1));
            }
            if (!this.indeterminate) {
                NativeUI.z(this.view.s, null);
            }
            if (this.t || this.indeterminate || a) {
                let d = this.view.r;
                let e = this.view.s;
                if (this.indeterminate) {
                    let f = new TransformGroup();
                    f.j.add(((() => {
                        let $ret = new RotateTransform();
                        $ret.j = 45;
                        return $ret;
                    })()));
                    f.j.add(((() => {
                        let $ret = new TranslateTransform();
                        $ret.j = -this.view.k();
                        return $ret;
                    })()));
                    NativeUI.j(d, this.c2);
                    NativeUI.k(d, this.c3);
                    NativeUI.t(e, 1);
                    NativeUI.x(e, 41);
                    NativeUI.z(e, f);
                }
                else if (b) {
                    NativeUI.j(d, this.c2);
                    NativeUI.k(d, this.c3);
                    NativeUI.t(e, 1);
                    NativeUI.x(e, 0);
                }
                else {
                    NativeUI.j(d, this.c5);
                    NativeUI.k(d, this.c6);
                    NativeUI.t(e, 0);
                    NativeUI.x(e, 24);
                }
                return;
            }
            if ((c > 0 && this.i.playbackRate < 0) || (c < 0 && this.i.playbackRate > 0)) {
                this.i.reverse();
                this.i.finished.f((g) => {
                    if (this.i != null) {
                        this.i.commitStyles();
                    }
                });
                this.j.reverse();
                this.j.finished.f((g) => {
                    if (this.j != null) {
                        this.j.commitStyles();
                    }
                });
            }
            else {
                this.i.play();
                this.i.finished.f((g) => {
                    if (this.i != null) {
                        this.i.commitStyles();
                    }
                });
                this.j.play();
                this.j.finished.f((g) => {
                    if (this.j != null) {
                        this.j.commitStyles();
                    }
                });
            }
        }
        onDetachedFromUI() {
            this.view.ac();
        }
        onAttachedToUI() {
            this.view.aa();
        }
        onContentReady() {
            if (this.indeterminate) {
                this.cp(false);
            }
        }
        z() {
            return this.view.i();
        }
        provideContainer(a) {
            this.view.ab(a);
        }
    }
    Checkbox.$t = /*@__PURE__*/ markType(Checkbox, 'Checkbox', Base.$, [INotifyPropertyChanged_$type]);
    Checkbox.dk = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Checkbox.dh = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    Checkbox.ar = NaN;
    Checkbox.dg = /*@__PURE__*/ BrushUtil.g(255, 228, 28, 119);
    Checkbox.as = 2;
    Checkbox.di = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Checkbox.at = 3;
    Checkbox.dj = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Checkbox.df = /*@__PURE__*/ BrushUtil.g(255, 153, 153, 153);
    Checkbox.dc = /*@__PURE__*/ BrushUtil.g(138, 33, 150, 243);
    Checkbox.ao = NaN;
    Checkbox.db = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Checkbox.ap = 2;
    Checkbox.dd = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Checkbox.aq = 3;
    Checkbox.de = /*@__PURE__*/ BrushUtil.g(255, 255, 255, 255);
    Checkbox.c = 2;
    Checkbox.a1 = 0;
    Checkbox.a0 = 0;
    return Checkbox;
})();
//# sourceMappingURL=CheckboxView_combined.js.map
