/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ScaleTransform } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { LinkedList$1 } from "igniteui-react-core";
import { IKeyFrameAnimation_$type } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let RippleView = /*@__PURE__*/ (() => {
    class RippleView extends Base {
        constructor() {
            super();
            this.b = null;
            this.g = null;
            this.c = null;
            this.f = new List$1(Delegate_$type, 0);
            this.l = null;
            this.d = true;
            this.k = null;
            this.h = null;
            this.j = null;
            this.i = null;
        }
        w() {
        }
        e() {
            return true;
        }
        t(a) {
            if (a == null) {
                for (let b of fromEnum(this.f)) {
                    b();
                }
                this.f.clear();
            }
            this.g = a;
            this.b.af();
        }
        v() {
            if (this.b.p == null) {
                this.l = null;
                for (let a of fromEnum(this.f)) {
                    a();
                }
                this.f.clear();
            }
            else {
                let b = this.b.p;
                let c = this.g.getWrapper(b);
                this.l = c;
                this.f.add(c.listen("click", runOn(this, this.p)));
                this.f.add(c.listen("mouseenter", runOn(this, this.q)));
                this.f.add(c.listen("mouseleave", runOn(this, this.r)));
            }
        }
        r(a) {
            this.b.ad();
        }
        q(a) {
            this.b.ac();
        }
        p(a) {
            if (this.l == null) {
                return;
            }
            let b = this.g.rootWrapper.getOffset();
            let c = a.pageX - b.left;
            let d = a.pageY - b.top;
            this.b.ai(c, d, this.g.rootWrapper.outerWidth(), this.g.rootWrapper.outerHeight());
        }
        aa() {
            if (this.b.i) {
                this.g.rootWrapper.setStyleProperty("background-color", this.b.ap._fill);
            }
        }
        x() {
            this.g.rootWrapper.setStyleProperty("background-color", "transparent");
        }
        z() {
            this.g.rootWrapper.setStyleProperty("background-color", this.b.ap._fill);
        }
        m(a, b, c) {
            let d = this.g.createElement("span");
            d.setStyleProperty("width", c * 2 + "px");
            d.setStyleProperty("height", c * 2 + "px");
            d.setStyleProperty("top", b + "px");
            d.setStyleProperty("left", a + "px");
            d.setStyleProperty("background-color", this.b.aq._fill);
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("pointer-events", "none");
            d.setStyleProperty("border-radius", c + "px");
            d.setStyleProperty("opacity", ".5");
            NativeUI.z(d, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 0.3;
                $ret.m = 0.3;
                return $ret;
            })()));
            this.g.append(d);
            return d;
        }
        y(a) {
            let b = a;
            b.remove();
        }
        n() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.g;
            }
        }
        a(a, b) {
            return new AnimationKeyFrameEffect(0, a, 0, null, b);
        }
        o(a) {
        }
        s() {
            this.d = true;
            this.v();
        }
        u() {
            this.d = false;
            for (let a of fromEnum(this.f)) {
                a();
            }
            this.f.clear();
        }
    }
    RippleView.$t = /*@__PURE__*/ markType(RippleView, 'RippleView');
    return RippleView;
})();
/**
 * @hidden
 */
export let Ripple = /*@__PURE__*/ (() => {
    class Ripple extends Base {
        constructor() {
            super();
            this.b = null;
            this.i = false;
            this.o = null;
            this.ao = null;
            this.an = null;
            this.al = Ripple.ar;
            this.l = new LinkedList$1(IKeyFrameAnimation_$type);
            this.am = Ripple.as;
            this.m = 600;
            this.e = false;
            this.d = false;
            this.f = false;
            this.propertyChanged = null;
            let a = new RippleView();
            a.b = this;
            this.b = a;
            this.b.w();
        }
        destroy() {
            this.provideContainer(null);
        }
        ae(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ag(a, b, c);
        }
        ag(a, b, c) {
            switch (a) {
                case "RippleColor":
                    this.aq = this.au != null ? this.au : Ripple.as;
                    break;
                case "HoverColor":
                    this.ap = this.at != null ? this.at : Ripple.ar;
                    break;
                case "EventSource":
                    if (this.b.e()) {
                        this.b.v();
                    }
                    break;
                case "ActualRippleColor":
                    this.ak();
                    break;
                case "ActualHoverColor":
                    this.aj();
                    break;
            }
        }
        aj() {
            if (this.h) {
                this.b.x();
                return;
            }
            this.b.aa();
        }
        ak() {
        }
        ac() {
            this.i = true;
            if (this.h) {
                this.b.x();
                return;
            }
            if (this.j) {
                this.b.z();
            }
        }
        ad() {
            this.i = false;
            if (this.j || this.h) {
                this.b.x();
            }
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ae("EventSource", b, a);
            }
        }
        get au() {
            return this.ao;
        }
        set au(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.ae("RippleColor", b, a);
            }
        }
        get at() {
            return this.an;
        }
        set at(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.ae("HoverColor", b, a);
            }
        }
        get ap() {
            return this.al;
        }
        set ap(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.ae("ActualHoverColor", b, a);
            }
        }
        ai(a, b, c, d) {
            if (this.h) {
                return;
            }
            let e = Math.max(c, d);
            let f = e / 2;
            let g = a - f;
            let h = b - f;
            if (this.g) {
                g = 0;
                h = 0;
            }
            let i = this.b.m(g, h, f);
            let j = this.c(i);
            this.l.f(j);
            let k = this.l.d;
            j.play();
            j.finished.f((l) => {
                j.commitStyles();
                this.l.h(k);
                this.b.y(i);
            });
        }
        c(a) {
            let b = this.a;
            let c = KeyFrameAnimationFactory.f.c(this.b.a(a, b).m(new AnimationKeyFrameProperty(1, 0.5), new AnimationKeyFrameProperty(14, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 0.3;
                $ret.m = 0.3;
                return $ret;
            })()))).m(new AnimationKeyFrameProperty(1, 0), new AnimationKeyFrameProperty(14, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 2;
                $ret.m = 2;
                return $ret;
            })()))));
            return c;
        }
        get aq() {
            return this.am;
        }
        set aq(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.ae("ActualRippleColor", b, a);
            }
        }
        get n() {
            return this.m;
        }
        set n(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.ae("RippleDuration", b, a);
            }
        }
        get h() {
            return this.e;
        }
        set h(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ae("IsDisabled", b, a);
            }
        }
        get g() {
            return this.d;
        }
        set g(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.ae("IsCentered", b, a);
            }
        }
        get j() {
            return this.f;
        }
        set j(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.ae("IsHoverEnabled", b, a);
            }
        }
        af() {
            this.b.v();
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.n;
            a.b = 0;
            return a;
        }
        onDetachedFromUI() {
            this.b.u();
        }
        onAttachedToUI() {
            this.b.s();
        }
        k() {
            return this.b.e();
        }
        provideContainer(a) {
            this.b.t(a);
        }
    }
    Ripple.$t = /*@__PURE__*/ markType(Ripple, 'Ripple', Base.$, [INotifyPropertyChanged_$type]);
    Ripple.ar = /*@__PURE__*/ BrushUtil.g(40, 0, 0, 0);
    Ripple.as = /*@__PURE__*/ BrushUtil.g(189, 0, 0, 0);
    return Ripple;
})();
//# sourceMappingURL=RippleView_combined.js.map
