/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, delegateCombine, typeCast, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ScaleTransform } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-react-core";
import { TransformGroup } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { PrefixShiftType_$type } from "./PrefixShiftType";
import { LabelShiftType_$type } from "./LabelShiftType";
import { InputShiftType_$type } from "./InputShiftType";
import { InputGroupDisplayType_$type } from "./InputGroupDisplayType";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ObservableCollection$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
/**
 * @hidden
 */
var InputGroupView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(InputGroupView, _super);
    function InputGroupView() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.l = null;
        _this.e = null;
        _this.i = new List$1(Delegate_$type, 0);
        _this.y = null;
        _this.f = true;
        _this.n = null;
        _this.o = null;
        _this.p = null;
        _this.s = null;
        _this.r = null;
        _this.q = null;
        _this.m = null;
        return _this;
    }
    InputGroupView.prototype.af = function () {
    };
    InputGroupView.prototype.g = function () {
        return true;
    };
    Object.defineProperty(InputGroupView.prototype, "v", {
        get: function () {
            return this.n;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupView.prototype, "al", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupView.prototype, "h", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    InputGroupView.prototype.ad = function (a) {
        var e_1, _a;
        var _this = this;
        if (a == null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.i)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.i.clear();
        }
        this.l = a;
        a.rootWrapper.setStyleProperty("position", "relative");
        a.rootWrapper.setStyleProperty("box-sizing", "border-box");
        a.rootWrapper.setStyleProperty("border-width", "0px");
        a.rootWrapper.setStyleProperty("border-style", "solid");
        var c = this.l.createElement("div");
        c.setStyleProperty("position", "absolute");
        c.setStyleProperty("width", "100%");
        c.setStyleProperty("height", "100%");
        c.setStyleProperty("border-style", "solid");
        c.setStyleProperty("box-sizing", "border-box");
        c.setStyleProperty("left", "0px");
        c.setStyleProperty("top", "0px");
        this.l.append(c);
        this.m = c;
        var d = this.l.createElement("div");
        d.addClass("ig-input-content");
        d.setStyleProperty("position", "relative");
        d.setStyleProperty("display", "flex");
        d.setStyleProperty("flex-direction", "row");
        d.setStyleProperty("flex-wrap", "no-wrap");
        d.setStyleProperty("flex-flow", "row nowrap");
        d.setStyleProperty("align-items", "center");
        d.setStyleProperty("padding-top", "1.125rem");
        this.p = d;
        this.i.add(d.listen("click", runOn(this, this.z)));
        this.l.append(d);
        this.l.getPortal(d, "ChildContent", function (e) {
            var comp_ = e.componentRef;
            _this.s = comp_;
            _this.p.setStyleProperty("flex-direction", "row");
        }, true);
        var e = this.l.createElement("div");
        e.setStyleProperty("position", "absolute");
        e.setStyleProperty("width", "100%");
        e.setStyleProperty("background-color", "rgba(0, 0, 0, 0.54)");
        e.setStyleProperty("height", "1px");
        e.setStyleProperty("pointer-events", "none");
        e.setStyleProperty("left", "0px");
        e.setStyleProperty("bottom", "1px");
        e.setStyleProperty("overflow", "visible");
        var f = this.l.createElement("span");
        f.setStyleProperty("width", "100%");
        f.setStyleProperty("height", "2px");
        f.setStyleProperty("display", "block");
        f.setStyleProperty("pointer-events", "none");
        NativeUI.z(f, ((function () {
            var $ret = new ScaleTransform();
            $ret.l = 0.5;
            $ret.m = 1;
            return $ret;
        })()));
        f.setStyleProperty("opacity", "0");
        this.r = f;
        e.append(this.r);
        this.q = e;
        this.l.append(e);
        this.d.l3();
    };
    Object.defineProperty(InputGroupView.prototype, "u", {
        get: function () {
            return this.l.rootWrapper;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupView.prototype, "t", {
        get: function () {
            return this.m;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupView.prototype, "w", {
        get: function () {
            return this.q;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupView.prototype, "x", {
        get: function () {
            return this.r;
        },
        enumerable: true,
        configurable: true
    });
    InputGroupView.prototype.aj = function (a) {
        if (this.y != a) {
            this.y = a;
            if (this.o != null) {
                this.o.setAttribute("d", this.y);
            }
        }
    };
    InputGroupView.prototype.ai = function () {
        switch (this.d.g) {
            case 1:
                this.p.setStyleProperty("padding-top", "1.125rem");
                break;
            case 2:
                this.p.setStyleProperty("padding-top", ".94737rem");
                break;
            case 3:
                this.p.setStyleProperty("padding-top", ".81818rem");
                break;
        }
    };
    InputGroupView.prototype.z = function (a) {
    };
    InputGroupView.prototype.ag = function () {
        if (this.g()) {
        }
    };
    InputGroupView.prototype.j = function () {
        var a = this.l.rootWrapper.getStyleProperty("height");
        return parseFloat(stringReplace(a, "px", ""));
    };
    InputGroupView.prototype.ac = function () {
        this.f = true;
    };
    InputGroupView.prototype.ae = function () {
        var e_2, _a;
        this.f = false;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.i)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.i.clear();
    };
    InputGroupView.prototype.ak = function (a) {
        if (a != null) {
            this.l.rootWrapper.setStyleProperty("font", a.fontString);
        }
    };
    InputGroupView.prototype.k = function (a) {
        return a.view.h();
    };
    InputGroupView.prototype.ab = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.l;
        }
    };
    InputGroupView.prototype.a = function (a) {
        return new AnimationKeyFrameEffect(0, this.t, 0, null, a);
    };
    InputGroupView.prototype.c = function (a) {
        return new AnimationKeyFrameEffect(0, this.w, 0, null, a);
    };
    InputGroupView.prototype.b = function (a) {
        return new AnimationKeyFrameEffect(0, this.r, 0, null, a);
    };
    InputGroupView.prototype.ah = function (a) {
    };
    InputGroupView.prototype.aa = function (a) {
        this.p.append(a);
    };
    InputGroupView.$t = markType(InputGroupView, 'InputGroupView');
    return InputGroupView;
}(Base));
export { InputGroupView };
/**
 * @hidden
 */
var PrefixView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(PrefixView, _super);
    function PrefixView() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.g = null;
        _this.b = null;
        _this.e = new List$1(Delegate_$type, 0);
        _this.c = true;
        _this.h = null;
        return _this;
    }
    PrefixView.prototype.o = function () {
    };
    PrefixView.prototype.d = function () {
        return true;
    };
    Object.defineProperty(PrefixView.prototype, "r", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    PrefixView.prototype.m = function (a) {
        var e_3, _a;
        if (a == null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            this.e.clear();
        }
        this.g = a;
        this.g.rootWrapper.setStyleProperty("display", "inline-block");
        var c = this.g.createElement("div");
        c.addClass("ig-prefix-content");
        this.g.append(c);
        c.setStyleProperty("cursor", "pointer");
        this.h = c;
        this.g.getPortal(c, "ChildContent", function (d) {
        }, true);
        this.a.aj();
    };
    PrefixView.prototype.q = function () {
        var _this = this;
        var a = new TransformGroup();
        a.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.k = _this.a.j == 2 ? (_this.f() * -0.25) : 0;
            return $ret;
        })()));
        a.j.add(((function () {
            var $ret = new ScaleTransform();
            $ret.l = 1;
            $ret.m = 1;
            return $ret;
        })()));
        NativeUI.z(this.g.rootWrapper, a);
        this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
    };
    PrefixView.prototype.f = function () {
        var a = this.g.rootWrapper.getStyleProperty("height");
        return parseFloat(stringReplace(a, "px", ""));
    };
    PrefixView.prototype.p = function () {
        if (this.d()) {
        }
    };
    PrefixView.prototype.i = function (a) {
        this.a.ag();
    };
    PrefixView.prototype.j = function (a) {
        this.a.ah();
    };
    PrefixView.prototype.l = function () {
        this.c = true;
        this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
        this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
    };
    PrefixView.prototype.n = function () {
        var e_4, _a;
        this.c = false;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.e.clear();
    };
    PrefixView.prototype.k = function (a) {
        this.h.append(a);
    };
    PrefixView.$t = markType(PrefixView, 'PrefixView');
    return PrefixView;
}(Base));
export { PrefixView };
/**
 * @hidden
 */
var LabelView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(LabelView, _super);
    function LabelView() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.i = null;
        _this.c = null;
        _this.g = new List$1(Delegate_$type, 0);
        _this.m = null;
        _this.d = true;
        _this.j = null;
        _this.k = null;
        return _this;
    }
    LabelView.prototype.y = function () {
    };
    LabelView.prototype.e = function () {
        return true;
    };
    Object.defineProperty(LabelView.prototype, "l", {
        get: function () {
            return this.j;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LabelView.prototype, "af", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LabelView.prototype, "f", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    LabelView.prototype.q = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.i;
        }
    };
    LabelView.prototype.a = function (a) {
        return new AnimationKeyFrameEffect(0, this.i.rootWrapper, 0, null, a);
    };
    LabelView.prototype.t = function (a) {
        var e_5, _a;
        if (a == null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            this.g.clear();
        }
        this.i = a;
        this.i.rootWrapper.setStyleProperty("display", "inline-block");
        this.i.rootWrapper.setStyleProperty("position", "relative");
        var c = this.i.createElement("label");
        c.setAttribute("type", this.b.b0);
        c.setStyleProperty("position", "relative");
        c.setStyleProperty("display", "inline-block");
        c.setStyleProperty("white-space", "nowrap");
        c.setStyleProperty("text-overflow", "ellipsis");
        c.setStyleProperty("line-height", "1");
        c.setStyleProperty("overflow", "hidden");
        c.setStyleProperty("height", "1.125rem");
        c.setStyleProperty("backface-visibility", "hidden");
        NativeUI.n(this.i.rootWrapper, this.b.ct);
        c.setStyleProperty("outline-style", "none");
        c.setStyleProperty("box-shadow", "none");
        c.setStyleProperty("font-family", "'Segoe UI', Verdana");
        c.setStyleProperty("font-size", "1rem");
        this.j = c;
        this.i.append(this.j);
        this.b.cc();
    };
    LabelView.prototype.ab = function () {
        var _this = this;
        this.b.bd = "block";
        var a = new TransformGroup();
        a.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.k = _this.b.r == 0 ? (_this.h() * 0.5) : 0;
            return $ret;
        })()));
        a.j.add(((function () {
            var $ret = new ScaleTransform();
            $ret.l = 1;
            $ret.m = 1;
            return $ret;
        })()));
        NativeUI.z(this.i.rootWrapper, a);
        this.j.setStyleProperty("height", "1.125rem");
        this.i.rootWrapper.setStyleProperty("position", "absolute");
        this.i.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
    };
    LabelView.prototype.ac = function () {
        switch (this.b.o) {
            case 1:
                this.i.rootWrapper.setStyleProperty("margin-top", "0px");
                break;
            case 2:
                this.i.rootWrapper.setStyleProperty("margin-top", "-.125rem");
                break;
            case 3:
                this.i.rootWrapper.setStyleProperty("margin-top", "-.25rem");
                break;
        }
    };
    LabelView.prototype.aa = function () {
        this.j.setText(this.b.text != null ? this.b.text : "");
    };
    LabelView.prototype.ad = function (a) {
        if (this.m != a) {
            this.m = a;
            if (this.k != null) {
                this.k.setAttribute("d", this.m);
            }
        }
    };
    LabelView.prototype.v = function () {
        if (this.i != null) {
            this.i.rootWrapper.setStyleProperty("display", this.b.bd);
            this.j.setStyleProperty("display", this.b.bd);
            var ext_ = this.i.getExternal(this.b, null, null);
            if (ext_ && ext_._onDisplayChanged) {
                ext_._onDisplayChanged();
            }
            ;
        }
    };
    LabelView.prototype.r = function () {
        if (this.i != null) {
            this.i.rootWrapper.setStyleProperty("align-items", this.b.a7);
            this.j.setStyleProperty("align-items", this.b.a7);
            var ext_ = this.i.getExternal(this.b, null, null);
            if (ext_ && ext_._onAlignItemsChanged) {
                ext_._onAlignItemsChanged();
            }
            ;
        }
    };
    LabelView.prototype.w = function () {
        if (this.i != null) {
            this.i.rootWrapper.setStyleProperty("flex-direction", this.b.bf);
            this.j.setStyleProperty("flex-direction", this.b.bf);
            var ext_ = this.i.getExternal(this.b, null, null);
            if (ext_ && ext_._onFlexDirectionChanged) {
                ext_._onFlexDirectionChanged();
            }
            ;
        }
    };
    LabelView.prototype.x = function () {
        if (this.i != null) {
            this.i.rootWrapper.setStyleProperty("flex-grow", this.b.bh);
            this.j.setStyleProperty("flex-grow", this.b.bh);
            var ext_ = this.i.getExternal(this.b, null, null);
            if (ext_ && ext_._onFlexGrowChanged) {
                ext_._onFlexGrowChanged();
            }
            ;
        }
    };
    LabelView.prototype.n = function (a) {
    };
    LabelView.prototype.z = function () {
        if (this.e()) {
        }
    };
    LabelView.prototype.h = function () {
        var a = this.i.rootWrapper.getStyleProperty("height");
        return parseFloat(stringReplace(a, "px", ""));
    };
    LabelView.prototype.o = function (a) {
        this.b.b9();
    };
    LabelView.prototype.p = function (a) {
        this.b.ca();
    };
    LabelView.prototype.s = function () {
        this.d = true;
        this.g.add(this.i.rootWrapper.listen("mouseenter", runOn(this, this.o)));
        this.g.add(this.i.rootWrapper.listen("mouseleave", runOn(this, this.p)));
    };
    LabelView.prototype.u = function () {
        var e_6, _a;
        this.d = false;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        this.g.clear();
    };
    LabelView.prototype.ae = function (a) {
        if (a != null) {
            this.i.rootWrapper.setStyleProperty("font", a.fontString);
        }
    };
    LabelView.$t = markType(LabelView, 'LabelView');
    return LabelView;
}(Base));
export { LabelView };
/**
 * @hidden
 */
var InputView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(InputView, _super);
    function InputView() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.h = null;
        _this.b = null;
        _this.f = new List$1(Delegate_$type, 0);
        _this.l = null;
        _this.c = true;
        _this.i = null;
        _this.j = null;
        return _this;
    }
    InputView.prototype.x = function () {
    };
    InputView.prototype.d = function () {
        return true;
    };
    Object.defineProperty(InputView.prototype, "k", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputView.prototype, "ag", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputView.prototype, "e", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    InputView.prototype.v = function (a) {
        var e_7, _a;
        if (a == null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            this.f.clear();
        }
        this.h = a;
        this.h.rootWrapper.setStyleProperty("display", "inline-block");
        var c = this.h.createElement("input");
        c.setAttribute("type", this.a.a8);
        c.setStyleProperty("position", "relative");
        c.setStyleProperty("box-sizing", "border-box");
        c.setStyleProperty("display", "inline-block");
        c.setStyleProperty("border", "none");
        c.setStyleProperty("height", "2rem");
        c.setStyleProperty("line-height", "0");
        c.setStyleProperty("width", "100%");
        c.setStyleProperty("min-width", "0");
        c.setStyleProperty("overflow", "visible");
        c.setStyleProperty("background", "transparent");
        c.setStyleProperty("background-position-x", "initial");
        c.setStyleProperty("background-position-y", "initial");
        c.setStyleProperty("background-size", "initial");
        c.setStyleProperty("background-repeat-x", "initial");
        c.setStyleProperty("background-repeat-y", "initial");
        c.setStyleProperty("background-attachment", "initial");
        c.setStyleProperty("background-origin", "initial");
        c.setStyleProperty("background-color", "transparent");
        NativeUI.n(c, this.a.by);
        c.setStyleProperty("outline-style", "none");
        c.setStyleProperty("box-shadow", "none");
        c.setStyleProperty("border-top", "0.1875rem solid transparent");
        c.setStyleProperty("padding-bottom", "0.1875rem");
        c.setStyleProperty("font-family", "'Segoe UI', Verdana");
        c.setStyleProperty("font-size", "1rem");
        this.f.add(c.listen("change", runOn(this, this.r)));
        this.f.add(c.listen("input", runOn(this, this.s)));
        this.f.add(c.listen("focus", runOn(this, this.t)));
        this.f.add(c.listen("blur", runOn(this, this.q)));
        this.f.add(c.listen("mouseenter", runOn(this, this.o)));
        this.f.add(c.listen("mouseleave", runOn(this, this.p)));
        this.i = c;
        this.h.append(this.i);
        this.a.bp();
    };
    InputView.prototype.aa = function () {
        this.i.setAttribute("type", this.a.a8);
    };
    InputView.prototype.z = function () {
        this.i.setAttribute("placeholder", this.a.a2);
    };
    InputView.prototype.ad = function () {
        switch (this.a.k) {
            case 1:
                this.i.setStyleProperty("height", "2rem");
                this.i.setStyleProperty("font-size", "1rem");
                break;
            case 2:
                this.i.setStyleProperty("height", "1.68421rem");
                this.i.setStyleProperty("font-size", "1rem");
                break;
            case 3:
                this.i.setStyleProperty("height", "1.45455rem");
                this.i.setStyleProperty("font-size", ".95455rem");
                break;
        }
    };
    InputView.prototype.ac = function () {
        var _this = this;
        var a = new TransformGroup();
        a.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.k = _this.a.p == 2 ? (_this.g() * -0.25) : 0;
            return $ret;
        })()));
        a.j.add(((function () {
            var $ret = new ScaleTransform();
            $ret.l = 1;
            $ret.m = 1;
            return $ret;
        })()));
        NativeUI.z(this.h.rootWrapper, a);
        this.h.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
    };
    InputView.prototype.g = function () {
        var a = this.h.rootWrapper.getStyleProperty("height");
        var b = parseFloat(stringReplace(a, "px", ""));
        return b;
    };
    InputView.prototype.ab = function (a) {
        this.i.setProperty("value", a);
    };
    InputView.prototype.q = function (a) {
        this.a.be();
    };
    InputView.prototype.t = function (a) {
        this.a.bi();
    };
    InputView.prototype.r = function (a) {
        this.a.bf();
    };
    InputView.prototype.s = function (a) {
        this.a.bg();
    };
    InputView.prototype.ae = function (a) {
        if (this.l != a) {
            this.l = a;
            if (this.j != null) {
                this.j.setAttribute("d", this.l);
            }
        }
    };
    InputView.prototype.m = function () {
        return this.i.getProperty("value");
    };
    InputView.prototype.n = function (a) {
    };
    InputView.prototype.y = function () {
        if (this.d()) {
        }
    };
    InputView.prototype.o = function (a) {
        this.a.bk();
    };
    InputView.prototype.p = function (a) {
        this.a.bl();
    };
    InputView.prototype.u = function () {
        this.c = true;
        this.f.add(this.i.listen("change", runOn(this, this.r)));
        this.f.add(this.i.listen("input", runOn(this, this.s)));
        this.f.add(this.i.listen("focus", runOn(this, this.t)));
        this.f.add(this.i.listen("blur", runOn(this, this.q)));
        this.f.add(this.i.listen("mouseenter", runOn(this, this.o)));
        this.f.add(this.i.listen("mouseleave", runOn(this, this.p)));
    };
    InputView.prototype.w = function () {
        var e_8, _a;
        this.c = false;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        this.f.clear();
    };
    InputView.prototype.af = function (a) {
        if (a != null) {
            this.h.rootWrapper.setStyleProperty("font", a.fontString);
        }
    };
    InputView.$t = markType(InputView, 'InputView');
    return InputView;
}(Base));
export { InputView };
/**
 * @hidden
 */
var InputGroupItem = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(InputGroupItem, _super);
    function InputGroupItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.a = null;
        _this.propertyChanged = null;
        return _this;
    }
    Object.defineProperty(InputGroupItem.prototype, "e", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.g("Name", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroupItem.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g("InputGroup", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    InputGroupItem.prototype.g = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.h(a, b, c);
    };
    InputGroupItem.prototype.h = function (a, b, c) {
    };
    InputGroupItem.$t = markType(InputGroupItem, 'InputGroupItem', Base.$, [INotifyPropertyChanged_$type]);
    return InputGroupItem;
}(Base));
export { InputGroupItem };
/**
 * @hidden
 */
var Prefix = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(Prefix, _super);
    function Prefix() {
        var _this = _super.call(this) || this;
        _this._view = null;
        _this.i = 0;
        _this.t = "ig-prefix-" + Prefix.r++;
        _this.s = null;
        _this.m = false;
        _this.l = false;
        _this.n = false;
        var a = new PrefixView();
        a.a = _this;
        _this.view = a;
        _this.view.o();
        return _this;
    }
    Object.defineProperty(Prefix.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: true,
        configurable: true
    });
    Prefix.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Object.defineProperty(Prefix.prototype, "j", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ShiftType", enumGetBox(PrefixShiftType_$type, b), enumGetBox(PrefixShiftType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Prefix.prototype.h = function (a, b, c) {
        _super.prototype.h.call(this, a, b, c);
        switch (a) {
            case "InputGroup":
                this.af();
                break;
            case "ShiftType":
                this.ai();
                break;
        }
    };
    Prefix.prototype.ai = function () {
        this.view.q();
    };
    Prefix.prototype.af = function () {
        this.view.q();
    };
    Prefix.prototype.am = function () {
    };
    Prefix.prototype.al = function () {
    };
    Prefix.prototype.ag = function () {
        this.p = true;
    };
    Prefix.prototype.ah = function () {
        this.p = false;
    };
    Object.defineProperty(Prefix.prototype, "w", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("Id", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Prefix.prototype, "u", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.g("AriaLabel", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Prefix.prototype, "p", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsHover", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Prefix.prototype, "disabled", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            var b = this.l;
            this.l = a;
            if (b != this.l) {
                this.g("IsDisabled", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Prefix.prototype.aj = function () {
    };
    Prefix.prototype.onDetachedFromUI = function () {
        this.view.n();
    };
    Prefix.prototype.onAttachedToUI = function () {
        this.view.l();
    };
    Prefix.prototype.q = function () {
        return this.view.d();
    };
    Prefix.prototype.appendContentChild = function (a) {
        this.view.k(a);
    };
    Prefix.prototype.provideContainer = function (a) {
        this.view.m(a);
    };
    Prefix.$t = markType(Prefix, 'Prefix', InputGroupItem.$);
    Prefix.r = 0;
    return Prefix;
}(InputGroupItem));
export { Prefix };
/**
 * @hidden
 */
var InputGroup = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(InputGroup, _super);
    function InputGroup() {
        var _this = _super.call(this) || this;
        _this.i = 0;
        _this.f = 1;
        _this.e = 1;
        _this.b = 0;
        _this._view = null;
        _this.p = null;
        _this.n = null;
        _this.db = ThemeResolver.b(InputGroup.c, InputGroup.fq, InputGroup.dx);
        _this.e1 = ThemeResolver.b(InputGroup.c, InputGroup.f1, InputGroup.d8);
        _this.mq = ThemeResolver.d(InputGroup.c, InputGroup.mz, InputGroup.mt);
        _this.s6 = ThemeResolver.f(InputGroup.c, InputGroup.tf, InputGroup.s9);
        _this.oz = ThemeResolver.e(InputGroup.c, InputGroup.qx, InputGroup.ph);
        _this.qk = ThemeResolver.e(InputGroup.c, InputGroup.re, InputGroup.py);
        _this.ql = ThemeResolver.e(InputGroup.c, InputGroup.rf, InputGroup.pz);
        _this.g7 = ThemeResolver.b(InputGroup.c, InputGroup.gt, InputGroup.e0);
        _this.g6 = ThemeResolver.b(InputGroup.c, InputGroup.gs, InputGroup.ez);
        _this.e5 = ThemeResolver.b(InputGroup.c, InputGroup.f5, InputGroup.ec);
        _this.r8 = ThemeResolver.e(InputGroup.c, InputGroup.ry, InputGroup.qi);
        _this.r9 = ThemeResolver.e(InputGroup.c, InputGroup.rz, InputGroup.qj);
        _this.qn = ThemeResolver.e(InputGroup.c, InputGroup.rh, InputGroup.p1);
        _this.qm = ThemeResolver.e(InputGroup.c, InputGroup.rg, InputGroup.p0);
        _this.g4 = ThemeResolver.b(InputGroup.c, InputGroup.gq, InputGroup.ex);
        _this.e4 = ThemeResolver.b(InputGroup.c, InputGroup.f4, InputGroup.eb);
        _this.e2 = ThemeResolver.b(InputGroup.c, InputGroup.f2, InputGroup.d9);
        _this.e3 = ThemeResolver.b(InputGroup.c, InputGroup.f3, InputGroup.ea);
        _this.g5 = ThemeResolver.b(InputGroup.c, InputGroup.gr, InputGroup.ey);
        _this.oy = ThemeResolver.e(InputGroup.c, InputGroup.qw, InputGroup.pg);
        _this.e6 = ThemeResolver.b(InputGroup.c, InputGroup.f6, InputGroup.ed);
        _this.e7 = ThemeResolver.b(InputGroup.c, InputGroup.f7, InputGroup.ee);
        _this.mw = ThemeResolver.d(InputGroup.c, InputGroup.m0, InputGroup.mu);
        _this.tc = ThemeResolver.f(InputGroup.c, InputGroup.tg, InputGroup.ta);
        _this.qp = ThemeResolver.e(InputGroup.c, InputGroup.rj, InputGroup.p3);
        _this.qq = ThemeResolver.e(InputGroup.c, InputGroup.rk, InputGroup.p4);
        _this.qr = ThemeResolver.e(InputGroup.c, InputGroup.rl, InputGroup.p5);
        _this.ff = ThemeResolver.b(InputGroup.c, InputGroup.gf, InputGroup.em);
        _this.fe = ThemeResolver.b(InputGroup.c, InputGroup.ge, InputGroup.el);
        _this.fb = ThemeResolver.b(InputGroup.c, InputGroup.gb, InputGroup.ei);
        _this.qu = ThemeResolver.e(InputGroup.c, InputGroup.ro, InputGroup.p8);
        _this.qv = ThemeResolver.e(InputGroup.c, InputGroup.rp, InputGroup.p9);
        _this.qt = ThemeResolver.e(InputGroup.c, InputGroup.rn, InputGroup.p7);
        _this.qs = ThemeResolver.e(InputGroup.c, InputGroup.rm, InputGroup.p6);
        _this.fc = ThemeResolver.b(InputGroup.c, InputGroup.gc, InputGroup.ej);
        _this.fa = ThemeResolver.b(InputGroup.c, InputGroup.ga, InputGroup.eh);
        _this.e8 = ThemeResolver.b(InputGroup.c, InputGroup.f8, InputGroup.ef);
        _this.e9 = ThemeResolver.b(InputGroup.c, InputGroup.f9, InputGroup.eg);
        _this.fd = ThemeResolver.b(InputGroup.c, InputGroup.gd, InputGroup.ek);
        _this.qo = ThemeResolver.e(InputGroup.c, InputGroup.ri, InputGroup.p2);
        _this.dc = ThemeResolver.b(InputGroup.c, InputGroup.fr, InputGroup.dy);
        _this.dd = ThemeResolver.b(InputGroup.c, InputGroup.fs, InputGroup.dz);
        _this.mp = ThemeResolver.d(InputGroup.c, InputGroup.my, InputGroup.ms);
        _this.s5 = ThemeResolver.f(InputGroup.c, InputGroup.te, InputGroup.s8);
        _this.o9 = ThemeResolver.e(InputGroup.c, InputGroup.q7, InputGroup.pr);
        _this.pa = ThemeResolver.e(InputGroup.c, InputGroup.q8, InputGroup.ps);
        _this.pb = ThemeResolver.e(InputGroup.c, InputGroup.q9, InputGroup.pt);
        _this.dl = ThemeResolver.b(InputGroup.c, InputGroup.f0, InputGroup.d7);
        _this.dk = ThemeResolver.b(InputGroup.c, InputGroup.fz, InputGroup.d6);
        _this.dh = ThemeResolver.b(InputGroup.c, InputGroup.fw, InputGroup.d3);
        _this.pe = ThemeResolver.e(InputGroup.c, InputGroup.rc, InputGroup.pw);
        _this.pf = ThemeResolver.e(InputGroup.c, InputGroup.rd, InputGroup.px);
        _this.pd = ThemeResolver.e(InputGroup.c, InputGroup.rb, InputGroup.pv);
        _this.pc = ThemeResolver.e(InputGroup.c, InputGroup.ra, InputGroup.pu);
        _this.di = ThemeResolver.b(InputGroup.c, InputGroup.fx, InputGroup.d4);
        _this.dg = ThemeResolver.b(InputGroup.c, InputGroup.fv, InputGroup.d2);
        _this.de = ThemeResolver.b(InputGroup.c, InputGroup.ft, InputGroup.d0);
        _this.df = ThemeResolver.b(InputGroup.c, InputGroup.fu, InputGroup.d1);
        _this.dj = ThemeResolver.b(InputGroup.c, InputGroup.fy, InputGroup.d5);
        _this.o8 = ThemeResolver.e(InputGroup.c, InputGroup.q6, InputGroup.pq);
        _this.c1 = ThemeResolver.b(InputGroup.c, InputGroup.fg, InputGroup.dm);
        _this.c2 = ThemeResolver.b(InputGroup.c, InputGroup.fh, InputGroup.dn);
        _this.mo = ThemeResolver.d(InputGroup.c, InputGroup.mx, InputGroup.mr);
        _this.s4 = ThemeResolver.f(InputGroup.c, InputGroup.td, InputGroup.s7);
        _this.o1 = ThemeResolver.e(InputGroup.c, InputGroup.qz, InputGroup.pj);
        _this.o2 = ThemeResolver.e(InputGroup.c, InputGroup.q0, InputGroup.pk);
        _this.o3 = ThemeResolver.e(InputGroup.c, InputGroup.q1, InputGroup.pl);
        _this.da = ThemeResolver.b(InputGroup.c, InputGroup.fp, InputGroup.dw);
        _this.c9 = ThemeResolver.b(InputGroup.c, InputGroup.fo, InputGroup.dv);
        _this.c6 = ThemeResolver.b(InputGroup.c, InputGroup.fl, InputGroup.ds);
        _this.o6 = ThemeResolver.e(InputGroup.c, InputGroup.q4, InputGroup.po);
        _this.o7 = ThemeResolver.e(InputGroup.c, InputGroup.q5, InputGroup.pp);
        _this.o5 = ThemeResolver.e(InputGroup.c, InputGroup.q3, InputGroup.pn);
        _this.o4 = ThemeResolver.e(InputGroup.c, InputGroup.q2, InputGroup.pm);
        _this.c7 = ThemeResolver.b(InputGroup.c, InputGroup.fm, InputGroup.dt);
        _this.c5 = ThemeResolver.b(InputGroup.c, InputGroup.fk, InputGroup.dr);
        _this.c3 = ThemeResolver.b(InputGroup.c, InputGroup.fi, InputGroup.dp);
        _this.c4 = ThemeResolver.b(InputGroup.c, InputGroup.fj, InputGroup.dq);
        _this.c8 = ThemeResolver.b(InputGroup.c, InputGroup.fn, InputGroup.du);
        _this.o0 = ThemeResolver.e(InputGroup.c, InputGroup.qy, InputGroup.pi);
        _this.gu = ThemeResolver.b(InputGroup.c, InputGroup.gg, InputGroup.en);
        _this.gv = ThemeResolver.b(InputGroup.c, InputGroup.gh, InputGroup.eo);
        _this.m2 = ThemeResolver.d(InputGroup.c, InputGroup.m1, InputGroup.mv);
        _this.ti = ThemeResolver.f(InputGroup.c, InputGroup.th, InputGroup.tb);
        _this.r1 = ThemeResolver.e(InputGroup.c, InputGroup.rr, InputGroup.qb);
        _this.r2 = ThemeResolver.e(InputGroup.c, InputGroup.rs, InputGroup.qc);
        _this.r3 = ThemeResolver.e(InputGroup.c, InputGroup.rt, InputGroup.qd);
        _this.g3 = ThemeResolver.b(InputGroup.c, InputGroup.gp, InputGroup.ew);
        _this.g2 = ThemeResolver.b(InputGroup.c, InputGroup.go, InputGroup.ev);
        _this.gz = ThemeResolver.b(InputGroup.c, InputGroup.gl, InputGroup.es);
        _this.r6 = ThemeResolver.e(InputGroup.c, InputGroup.rw, InputGroup.qg);
        _this.r7 = ThemeResolver.e(InputGroup.c, InputGroup.rx, InputGroup.qh);
        _this.r5 = ThemeResolver.e(InputGroup.c, InputGroup.rv, InputGroup.qf);
        _this.r4 = ThemeResolver.e(InputGroup.c, InputGroup.ru, InputGroup.qe);
        _this.g0 = ThemeResolver.b(InputGroup.c, InputGroup.gm, InputGroup.et);
        _this.gy = ThemeResolver.b(InputGroup.c, InputGroup.gk, InputGroup.er);
        _this.gw = ThemeResolver.b(InputGroup.c, InputGroup.gi, InputGroup.ep);
        _this.gx = ThemeResolver.b(InputGroup.c, InputGroup.gj, InputGroup.eq);
        _this.g1 = ThemeResolver.b(InputGroup.c, InputGroup.gn, InputGroup.eu);
        _this.r0 = ThemeResolver.e(InputGroup.c, InputGroup.rq, InputGroup.qa);
        _this.m6 = ThemeResolver.e(InputGroup.c, InputGroup.qx, InputGroup.ph);
        _this.m7 = ThemeResolver.e(InputGroup.c, InputGroup.re, InputGroup.py);
        _this.ai = ThemeResolver.b(InputGroup.c, InputGroup.fq, InputGroup.dx);
        _this.aj = ThemeResolver.b(InputGroup.c, InputGroup.f1, InputGroup.d8);
        _this.md = ThemeResolver.d(InputGroup.c, InputGroup.mz, InputGroup.mt);
        _this.st = ThemeResolver.f(InputGroup.c, InputGroup.tf, InputGroup.s9);
        _this.ar = ThemeResolver.b(InputGroup.c, InputGroup.gt, InputGroup.e0);
        _this.aq = ThemeResolver.b(InputGroup.c, InputGroup.gs, InputGroup.ez);
        _this.an = ThemeResolver.b(InputGroup.c, InputGroup.f5, InputGroup.ec);
        _this.na = ThemeResolver.e(InputGroup.c, InputGroup.ry, InputGroup.qi);
        _this.nb = ThemeResolver.e(InputGroup.c, InputGroup.rz, InputGroup.qj);
        _this.m9 = ThemeResolver.e(InputGroup.c, InputGroup.rh, InputGroup.p1);
        _this.m8 = ThemeResolver.e(InputGroup.c, InputGroup.rg, InputGroup.p0);
        _this.ao = ThemeResolver.b(InputGroup.c, InputGroup.gq, InputGroup.ex);
        _this.am = ThemeResolver.b(InputGroup.c, InputGroup.f4, InputGroup.eb);
        _this.ak = ThemeResolver.b(InputGroup.c, InputGroup.f2, InputGroup.d9);
        _this.al = ThemeResolver.b(InputGroup.c, InputGroup.f3, InputGroup.ea);
        _this.ap = ThemeResolver.b(InputGroup.c, InputGroup.gr, InputGroup.ey);
        _this.m5 = ThemeResolver.e(InputGroup.c, InputGroup.qw, InputGroup.pg);
        _this.a2 = NaN;
        _this.bd = NaN;
        _this.nd = null;
        _this.mg = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.sw = new Thickness(1, NaN, NaN, NaN, NaN);
        _this.b5 = NaN;
        _this.b4 = NaN;
        _this.bh = NaN;
        _this.n9 = null;
        _this.oa = null;
        _this.nu = null;
        _this.nt = null;
        _this.b2 = NaN;
        _this.bg = NaN;
        _this.be = NaN;
        _this.bf = NaN;
        _this.b3 = NaN;
        _this.nc = null;
        _this.bi = NaN;
        _this.bj = NaN;
        _this.nx = null;
        _this.nw = null;
        _this.mh = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.sx = new Thickness(1, NaN, NaN, NaN, NaN);
        _this.br = NaN;
        _this.bq = NaN;
        _this.bn = NaN;
        _this.n0 = null;
        _this.n1 = null;
        _this.nz = null;
        _this.ny = null;
        _this.bo = NaN;
        _this.bm = NaN;
        _this.bk = NaN;
        _this.bl = NaN;
        _this.bp = NaN;
        _this.nv = null;
        _this.a3 = NaN;
        _this.a4 = NaN;
        _this.nn = null;
        _this.nm = null;
        _this.mf = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.sv = new Thickness(1, NaN, NaN, NaN, NaN);
        _this.bc = NaN;
        _this.bb = NaN;
        _this.a8 = NaN;
        _this.nq = null;
        _this.nr = null;
        _this.np = null;
        _this.no = null;
        _this.a9 = NaN;
        _this.a7 = NaN;
        _this.a5 = NaN;
        _this.a6 = NaN;
        _this.ba = NaN;
        _this.nl = null;
        _this.as = NaN;
        _this.at = NaN;
        _this.ng = null;
        _this.nf = null;
        _this.me = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.su = new Thickness(1, NaN, NaN, NaN, NaN);
        _this.a1 = NaN;
        _this.a0 = NaN;
        _this.ax = NaN;
        _this.nj = null;
        _this.nk = null;
        _this.ni = null;
        _this.nh = null;
        _this.ay = NaN;
        _this.aw = NaN;
        _this.au = NaN;
        _this.av = NaN;
        _this.az = NaN;
        _this.ne = null;
        _this.bs = NaN;
        _this.bt = NaN;
        _this.n4 = null;
        _this.n3 = null;
        _this.mi = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.sy = new Thickness(1, NaN, NaN, NaN, NaN);
        _this.b1 = NaN;
        _this.b0 = NaN;
        _this.bx = NaN;
        _this.n7 = null;
        _this.n8 = null;
        _this.n6 = null;
        _this.n5 = null;
        _this.by = NaN;
        _this.bw = NaN;
        _this.bu = NaN;
        _this.bv = NaN;
        _this.bz = NaN;
        _this.n2 = null;
        _this.w = false;
        _this.s = false;
        _this.y = false;
        _this.u = false;
        _this.x = false;
        _this.t = false;
        _this.q = false;
        _this.ns = null;
        _this.h2 = "ig-inputgroup-" + InputGroup.h1++;
        _this.v = false;
        _this.propertyChanged = null;
        _this.k = new InputGroupInputCollection();
        _this.o = null;
        _this.aa = false;
        _this.r = false;
        _this.z = false;
        var a = new InputGroupView();
        a.d = _this;
        _this.view = a;
        _this.view.af();
        var b = _this.k;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.ln));
        var c = _this.k;
        c.collectionResetting = delegateCombine(c.collectionResetting, runOn(_this, _this.lo));
        return _this;
    }
    InputGroup.prototype.lo = function (a, b) {
        this.l8();
    };
    InputGroup.prototype.appendContentChild = function (a) {
        this.view.aa(a);
    };
    Object.defineProperty(InputGroup.prototype, "j", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.l2("Type", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "h", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (b != this.f) {
                this.l2("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "g", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.l2("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    InputGroup.prototype.lt = function (a) {
        for (var b = 0; b < this.inputs.count; b++) {
            if (typeCast(Label.$, this.inputs._inner[b]) !== null) {
                a(this.inputs._inner[b]);
            }
        }
    };
    InputGroup.prototype.lu = function (a) {
        for (var b = 0; b < this.inputs.count; b++) {
            if (typeCast(Prefix.$, this.inputs._inner[b]) !== null) {
                a(this.inputs._inner[b]);
            }
        }
    };
    InputGroup.prototype.ls = function (a) {
        for (var b = 0; b < this.inputs.count; b++) {
            if (typeCast(Input.$, this.inputs._inner[b]) !== null) {
                a(this.inputs._inner[b]);
            }
        }
    };
    InputGroup.prototype.ln = function (a, b) {
        var e_9, _a, e_10, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = tslib_1.__values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    var d = c;
                    if (d != null) {
                        d.b = null;
                    }
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = tslib_1.__values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    var f = e;
                    if (f != null) {
                        f.b = this;
                    }
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        this.mb();
        this.ma();
        this.mc();
        this.l8();
    };
    Object.defineProperty(InputGroup.prototype, "d", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.l2("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: true,
        configurable: true
    });
    InputGroup.prototype.destroy = function () {
        this.provideContainer(null);
    };
    InputGroup.prototype.l2 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.l5(a, b, c);
    };
    InputGroup.prototype.l5 = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "BaseTheme":
                this.l7(this.d);
                this.l9();
                this.lt(function (d) { return d.l = _this.d == 0 ? 2 : _this.d; });
                break;
            case "ActualBorderColor":
            case "ActualBackgroundColor":
            case "ActualBorderWidth":
            case "ActualFocusBorderColor":
            case "ActualFocusBorderWidth":
            case "ActualCornerRadius":
            case "ActualContentPadding":
            case "ActualUnderlineOpacity":
            case "ActualUnderlineRippleOpacity":
            case "ActualUnderlineRippleWidth":
            case "ActualUnderlineRippleColor":
            case "ActualUnderlineColor":
            case "ActualHoverUnderlineColor":
            case "ActualUnderlineWidth":
            case "ActualHoverUnderlineWidth":
            case "ActualHoverUnderlineOpacity":
            case "ActualFocusUnderlineColor":
            case "ActualFocusUnderlineOpacity":
            case "ActualFocusUnderlineRippleOpacity":
            case "IsHovered":
                this.z = true;
                this.aa = true;
                this.r = true;
                this.l8();
                break;
            case "BorderColor":
            case "BackgroundColor":
            case "BorderWidth":
            case "FocusBorderColor":
            case "FocusBorderWidth":
            case "CornerRadius":
            case "ContentPadding":
            case "UnderlineOpacity":
            case "UnderlineRippleOpacity":
            case "UnderlineRippleWidth":
            case "UnderlineRippleColor":
            case "UnderlineColor":
            case "HoverUnderlineColor":
            case "UnderlineWidth":
            case "HoverUnderlineWidth":
            case "HoverUnderlineOpacity":
            case "FocusUnderlineColor":
            case "FocusUnderlineOpacity":
            case "FocusUnderlineRippleOpacity":
            case "LineTypeBorderColor":
            case "LineTypeBackgroundColor":
            case "LineTypeBorderWidth":
            case "LineTypeFocusBorderColor":
            case "LineTypeFocusBorderWidth":
            case "LineTypeCornerRadius":
            case "LineTypeContentPadding":
            case "LineTypeUnderlineOpacity":
            case "LineTypeUnderlineRippleOpacity":
            case "LineTypeUnderlineRippleWidth":
            case "LineTypeUnderlineRippleColor":
            case "LineTypeUnderlineColor":
            case "LineTypeHoverUnderlineColor":
            case "LineTypeUnderlineWidth":
            case "LineTypeHoverUnderlineWidth":
            case "LineTypeHoverUnderlineOpacity":
            case "LineTypeFocusUnderlineColor":
            case "LineTypeFocusUnderlineOpacity":
            case "LineTypeFocusUnderlineRippleOpacity":
            case "BoxTypeBorderColor":
            case "BoxTypeBackgroundColor":
            case "BoxTypeBorderWidth":
            case "BoxTypeFocusBorderColor":
            case "BoxTypeFocusBorderWidth":
            case "BoxTypeCornerRadius":
            case "BoxTypeContentPadding":
            case "BoxTypeUnderlineOpacity":
            case "BoxTypeUnderlineRippleOpacity":
            case "BoxTypeUnderlineRippleWidth":
            case "BoxTypeUnderlineRippleColor":
            case "BoxTypeUnderlineColor":
            case "BoxTypeHoverUnderlineColor":
            case "BoxTypeUnderlineWidth":
            case "BoxTypeHoverUnderlineWidth":
            case "BoxTypeHoverUnderlineOpacity":
            case "BoxTypeFocusUnderlineColor":
            case "BoxTypeFocusUnderlineOpacity":
            case "BoxTypeFocusUnderlineRippleOpacity":
            case "BorderTypeBorderColor":
            case "BorderTypeBackgroundColor":
            case "BorderTypeBorderWidth":
            case "BorderTypeFocusBorderColor":
            case "BorderTypeFocusBorderWidth":
            case "BorderTypeCornerRadius":
            case "BorderTypeContentPadding":
            case "BorderTypeUnderlineOpacity":
            case "BorderTypeUnderlineRippleOpacity":
            case "BorderTypeUnderlineRippleWidth":
            case "BorderTypeUnderlineRippleColor":
            case "BorderTypeUnderlineColor":
            case "BorderTypeHoverUnderlineColor":
            case "BorderTypeUnderlineWidth":
            case "BorderTypeHoverUnderlineWidth":
            case "BorderTypeHoverUnderlineOpacity":
            case "BorderTypeFocusUnderlineColor":
            case "BorderTypeFocusUnderlineOpacity":
            case "BorderTypeFocusUnderlineRippleOpacity":
            case "Type":
                this.l9();
                break;
            case "ActualDensity":
                this.view.ai();
                this.l9();
                break;
            case "Density":
                this.g = this.h == 0 ? 1 : this.h;
                break;
            case "IsFocused":
                this.l1();
                this.l8();
                break;
            case "IsExpanded":
                this.s = true;
                this.ab = this.ae;
                break;
            case "ActualIsExpanded":
                this.lv();
                break;
        }
    };
    InputGroup.prototype.mm = function (a, b) {
        return new CornerRadius(1, !isNaN_(a.topLeft) ? a.topLeft : b.topLeft, !isNaN_(a.topRight) ? a.topRight : b.topRight, !isNaN_(a.bottomRight) ? a.bottomRight : b.bottomRight, !isNaN_(a.bottomLeft) ? a.bottomLeft : b.bottomLeft);
    };
    InputGroup.prototype.s2 = function (a, b) {
        return new Thickness(1, !isNaN_(a.left) ? a.left : b.left, !isNaN_(a.top) ? a.top : b.top, !isNaN_(a.right) ? a.right : b.right, !isNaN_(a.bottom) ? a.bottom : b.bottom);
    };
    InputGroup.prototype.mb = function () {
        var _this = this;
        this.lt(function (a) {
            a.p = _this.g;
            a.l = _this.d == 0 ? 2 : _this.d;
            switch (_this.j) {
                case 0:
                    a.r = 0;
                    break;
                case 1:
                    a.r = 1;
                    break;
                case 2:
                case 3:
                    a.r = 2;
                    break;
            }
        });
    };
    InputGroup.prototype.mc = function () {
        var _this = this;
        this.lu(function (a) {
            switch (_this.j) {
                case 0:
                    a.j = 0;
                    break;
                case 1:
                    a.j = 1;
                    break;
                case 2:
                case 3:
                    a.j = 2;
                    break;
            }
        });
    };
    InputGroup.prototype.ma = function () {
        var _this = this;
        this.ls(function (a) {
            a.l = _this.g;
            switch (_this.j) {
                case 0:
                    a.p = 0;
                    break;
                case 1:
                    a.p = 1;
                    break;
                case 2:
                case 3:
                    a.p = 2;
                    break;
            }
        });
    };
    InputGroup.prototype.l9 = function () {
        this.mb();
        this.ma();
        this.mc();
        switch (this.j) {
            case 0:
                this.oc = this.oj != null ? this.oj : this.se != null ? this.se : this.qp;
                this.ob = this.oi != null ? this.oi : this.sd != null ? this.sd : this.qo;
                this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.hd) ? this.hd : this.e6;
                this.od = this.sa != null ? this.sa : this.sf != null ? this.sf : this.qq;
                this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.he) ? this.he : this.e7;
                this.mj = this.mm(this.mn, this.mm(this.m3, this.mw));
                this.sz = this.s2(this.s3, this.s2(this.tj, this.tc));
                this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.hj) ? this.hj : this.fc;
                this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.hk) ? this.hk : this.fd;
                this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.hl) ? this.hl : this.fe;
                this.oh = this.ss != null ? this.ss : this.sj != null ? this.sj : this.qv;
                this.og = this.sr != null ? this.sr : this.si != null ? this.si : this.qu;
                this.of = this.sc != null ? this.sc : this.sh != null ? this.sh : this.qt;
                this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.hm) ? this.hm : this.ff;
                this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hi) ? this.hi : this.fb;
                this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.hh) ? this.hh : this.fa;
                this.oe = this.sb != null ? this.sb : this.sg != null ? this.sg : this.qs;
                this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.hf) ? this.hf : this.e8;
                this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.hg) ? this.hg : this.e9;
                break;
            case 1:
                this.oc = this.oj != null ? this.oj : this.os != null ? this.os : this.o9;
                this.ob = this.oi != null ? this.oi : this.or != null ? this.or : this.o8;
                this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.cr) ? this.cr : this.dc;
                this.od = this.sa != null ? this.sa : this.ot != null ? this.ot : this.pa;
                this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.cs) ? this.cs : this.dd;
                this.mj = this.mm(this.mn, this.mm(this.ml, this.mp));
                this.sz = this.s2(this.s3, this.s2(this.s1, this.s5));
                this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.cx) ? this.cx : this.di;
                this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.cy) ? this.cy : this.dj;
                this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.cz) ? this.cz : this.dk;
                this.oh = this.ss != null ? this.ss : this.ox != null ? this.ox : this.pf;
                this.og = this.sr != null ? this.sr : this.ow != null ? this.ow : this.pe;
                this.of = this.sc != null ? this.sc : this.ov != null ? this.ov : this.pd;
                this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.c0) ? this.c0 : this.dl;
                this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cw) ? this.cw : this.dh;
                this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.cv) ? this.cv : this.dg;
                this.oe = this.sb != null ? this.sb : this.ou != null ? this.ou : this.pc;
                this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.ct) ? this.ct : this.de;
                this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.cu) ? this.cu : this.df;
                break;
            case 2:
                this.oc = this.oj != null ? this.oj : this.ol != null ? this.ol : this.o1;
                this.ob = this.oi != null ? this.oi : this.ok != null ? this.ok : this.o0;
                this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.cg) ? this.cg : this.c1;
                this.od = this.sa != null ? this.sa : this.om != null ? this.om : this.o2;
                this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.ch) ? this.ch : this.c2;
                this.mj = this.mm(this.mn, this.mm(this.mk, this.mo));
                this.sz = this.s2(this.s3, this.s2(this.s0, this.s4));
                this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.cm) ? this.cm : this.c7;
                this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.cn) ? this.cn : this.c8;
                this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.co) ? this.co : this.c9;
                this.oh = this.ss != null ? this.ss : this.oq != null ? this.oq : this.o7;
                this.og = this.sr != null ? this.sr : this.op != null ? this.op : this.o6;
                this.of = this.sc != null ? this.sc : this.oo != null ? this.oo : this.o5;
                this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.cp) ? this.cp : this.da;
                this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cl) ? this.cl : this.c6;
                this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.ck) ? this.ck : this.c5;
                this.oe = this.sb != null ? this.sb : this.on != null ? this.on : this.o4;
                this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.ci) ? this.ci : this.c3;
                this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.cj) ? this.cj : this.c4;
                break;
            case 3:
                this.oc = this.oj != null ? this.oj : this.sl != null ? this.sl : this.r1;
                this.ob = this.oi != null ? this.oi : this.sk != null ? this.sk : this.r0;
                this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.hn) ? this.hn : this.gu;
                this.od = this.sa != null ? this.sa : this.sm != null ? this.sm : this.r2;
                this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.ho) ? this.ho : this.gv;
                this.mj = this.mm(this.mn, this.mm(this.m4, this.m2));
                this.sz = this.s2(this.s3, this.s2(this.tk, this.ti));
                this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.ht) ? this.ht : this.g0;
                this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.hu) ? this.hu : this.g1;
                this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.hv) ? this.hv : this.g2;
                this.oh = this.ss != null ? this.ss : this.sq != null ? this.sq : this.r7;
                this.og = this.sr != null ? this.sr : this.sp != null ? this.sp : this.r6;
                this.of = this.sc != null ? this.sc : this.so != null ? this.so : this.r5;
                this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.hw) ? this.hw : this.g3;
                this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hs) ? this.hs : this.gz;
                this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.hr) ? this.hr : this.gy;
                this.oe = this.sb != null ? this.sb : this.sn != null ? this.sn : this.r4;
                this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.hp) ? this.hp : this.gw;
                this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.hq) ? this.hq : this.gx;
                break;
        }
    };
    InputGroup.prototype.l8 = function () {
        this.lt(function (a) {
        });
        this.ls(function (a) {
        });
        var a = this.view.u;
        var b = this.view.t;
        var c = this.view.w;
        var d = this.view.x;
        var e = this.o != null && this.o.playState == 1;
        var f = this.p != null && this.p.playState == 1;
        var g = this.n != null && this.n.playState == 1;
        NativeUI.l(a, this.mj);
        NativeUI.l(b, this.mj);
        NativeUI.j(a, this.ob);
        NativeUI.u(a, this.sz);
        if (this.af) {
            if (!g) {
                NativeUI.k(b, this.od);
                NativeUI.m(b, new Thickness(0, this.b7));
            }
            if (!f) {
                NativeUI.j(c, this.oe);
            }
        }
        else {
            if (!f) {
                if (this.ag) {
                    NativeUI.j(c, this.of);
                    NativeUI.t(c, this.ca);
                    NativeUI.q(c, this.cb);
                }
                else {
                    NativeUI.j(c, this.og);
                    NativeUI.t(c, this.cc);
                    NativeUI.q(c, this.cf);
                }
            }
            if (!g) {
                NativeUI.k(b, this.oc);
                NativeUI.m(b, new Thickness(0, this.b6));
            }
            if (!f) {
                NativeUI.j(a, this.ob);
            }
        }
        if (!e) {
            NativeUI.j(d, this.oh);
            NativeUI.q(d, this.ce);
            NativeUI.t(d, this.cd);
        }
    };
    Object.defineProperty(InputGroup.prototype, "a", {
        get: function () {
            var a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        },
        enumerable: true,
        configurable: true
    });
    InputGroup.prototype.onChildrenMutated = function () {
        this.ls(function (a) { return a.view.ac(); });
        this.lt(function (a) { return a.view.ab(); });
        this.lu(function (a) { return a.view.q(); });
    };
    InputGroup.prototype.lr = function () {
        this.view.ab();
        var a = false;
        if (this.p == null) {
            this.p = KeyFrameAnimationFactory.f.c(this.view.c(this.a).m(new AnimationKeyFrameProperty(2, this.oc)).m(new AnimationKeyFrameProperty(2, this.od)));
        }
        if (this.n == null) {
            this.n = KeyFrameAnimationFactory.f.c(this.view.a(this.a).m(new AnimationKeyFrameProperty(3, this.oc), new AnimationKeyFrameProperty(4, this.j == 2 || this.j == 3 ? new Thickness(0, this.b6) : new Thickness(0, 0))).m(new AnimationKeyFrameProperty(3, this.od), new AnimationKeyFrameProperty(4, this.j == 2 || this.j == 3 ? new Thickness(0, this.b7) : new Thickness(0, 0))));
        }
        if (this.o == null) {
            this.o = KeyFrameAnimationFactory.f.c(this.view.b(this.a).m(new AnimationKeyFrameProperty(2, this.od), new AnimationKeyFrameProperty(14, ((function () {
                var $ret = new ScaleTransform();
                $ret.l = 0.5;
                $ret.m = 1;
                return $ret;
            })())), new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(2, this.od), new AnimationKeyFrameProperty(14, ((function () {
                var $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })())), new AnimationKeyFrameProperty(1, 1)));
        }
    };
    Object.defineProperty(InputGroup.prototype, "ac", {
        get: function () {
            var a = false;
            this.ls(function (b) {
                if (b.ab) {
                    a = true;
                }
            });
            return a;
        },
        enumerable: true,
        configurable: true
    });
    InputGroup.prototype.lz = function (a) {
        this.ab = this.s ? this.ae : this.ac ? true : false;
        this.af = false;
    };
    InputGroup.prototype.l7 = function (a) {
        this.db = ThemeResolver.b(a, InputGroup.fq, InputGroup.dx);
        this.e1 = ThemeResolver.b(a, InputGroup.f1, InputGroup.d8);
        this.mq = ThemeResolver.d(a, InputGroup.mz, InputGroup.mt);
        this.s6 = ThemeResolver.f(a, InputGroup.tf, InputGroup.s9);
        this.oz = ThemeResolver.e(a, InputGroup.qx, InputGroup.ph);
        this.qk = ThemeResolver.e(a, InputGroup.re, InputGroup.py);
        this.ql = ThemeResolver.e(a, InputGroup.rf, InputGroup.pz);
        this.g7 = ThemeResolver.b(a, InputGroup.gt, InputGroup.e0);
        this.g6 = ThemeResolver.b(a, InputGroup.gs, InputGroup.ez);
        this.e5 = ThemeResolver.b(a, InputGroup.f5, InputGroup.ec);
        this.r8 = ThemeResolver.e(a, InputGroup.ry, InputGroup.qi);
        this.r9 = ThemeResolver.e(a, InputGroup.rz, InputGroup.qj);
        this.qn = ThemeResolver.e(a, InputGroup.rh, InputGroup.p1);
        this.qm = ThemeResolver.e(a, InputGroup.rg, InputGroup.p0);
        this.g4 = ThemeResolver.b(a, InputGroup.gq, InputGroup.ex);
        this.e4 = ThemeResolver.b(a, InputGroup.f4, InputGroup.eb);
        this.e2 = ThemeResolver.b(a, InputGroup.f2, InputGroup.d9);
        this.e3 = ThemeResolver.b(a, InputGroup.f3, InputGroup.ea);
        this.g5 = ThemeResolver.b(a, InputGroup.gr, InputGroup.ey);
        this.oy = ThemeResolver.e(a, InputGroup.qw, InputGroup.pg);
        this.e6 = ThemeResolver.b(a, InputGroup.f6, InputGroup.ed);
        this.e7 = ThemeResolver.b(a, InputGroup.f7, InputGroup.ee);
        this.mw = ThemeResolver.d(a, InputGroup.m0, InputGroup.mu);
        this.tc = ThemeResolver.f(a, InputGroup.tg, InputGroup.ta);
        this.qp = ThemeResolver.e(a, InputGroup.rj, InputGroup.p3);
        this.qq = ThemeResolver.e(a, InputGroup.rk, InputGroup.p4);
        this.qr = ThemeResolver.e(a, InputGroup.rl, InputGroup.p5);
        this.ff = ThemeResolver.b(a, InputGroup.gf, InputGroup.em);
        this.fe = ThemeResolver.b(a, InputGroup.ge, InputGroup.el);
        this.fb = ThemeResolver.b(a, InputGroup.gb, InputGroup.ei);
        this.qu = ThemeResolver.e(a, InputGroup.ro, InputGroup.p8);
        this.qv = ThemeResolver.e(a, InputGroup.rp, InputGroup.p9);
        this.qt = ThemeResolver.e(a, InputGroup.rn, InputGroup.p7);
        this.qs = ThemeResolver.e(a, InputGroup.rm, InputGroup.p6);
        this.fc = ThemeResolver.b(a, InputGroup.gc, InputGroup.ej);
        this.fa = ThemeResolver.b(a, InputGroup.ga, InputGroup.eh);
        this.e8 = ThemeResolver.b(a, InputGroup.f8, InputGroup.ef);
        this.e9 = ThemeResolver.b(a, InputGroup.f9, InputGroup.eg);
        this.fd = ThemeResolver.b(a, InputGroup.gd, InputGroup.ek);
        this.qo = ThemeResolver.e(a, InputGroup.ri, InputGroup.p2);
        this.dc = ThemeResolver.b(a, InputGroup.fr, InputGroup.dy);
        this.dd = ThemeResolver.b(a, InputGroup.fs, InputGroup.dz);
        this.mp = ThemeResolver.d(a, InputGroup.my, InputGroup.ms);
        this.s5 = ThemeResolver.f(a, InputGroup.te, InputGroup.s8);
        this.o9 = ThemeResolver.e(a, InputGroup.q7, InputGroup.pr);
        this.pa = ThemeResolver.e(a, InputGroup.q8, InputGroup.ps);
        this.pb = ThemeResolver.e(a, InputGroup.q9, InputGroup.pt);
        this.dl = ThemeResolver.b(a, InputGroup.f0, InputGroup.d7);
        this.dk = ThemeResolver.b(a, InputGroup.fz, InputGroup.d6);
        this.dh = ThemeResolver.b(a, InputGroup.fw, InputGroup.d3);
        this.pe = ThemeResolver.e(a, InputGroup.rc, InputGroup.pw);
        this.pf = ThemeResolver.e(a, InputGroup.rd, InputGroup.px);
        this.pd = ThemeResolver.e(a, InputGroup.rb, InputGroup.pv);
        this.pc = ThemeResolver.e(a, InputGroup.ra, InputGroup.pu);
        this.di = ThemeResolver.b(a, InputGroup.fx, InputGroup.d4);
        this.dg = ThemeResolver.b(a, InputGroup.fv, InputGroup.d2);
        this.de = ThemeResolver.b(a, InputGroup.ft, InputGroup.d0);
        this.df = ThemeResolver.b(a, InputGroup.fu, InputGroup.d1);
        this.dj = ThemeResolver.b(a, InputGroup.fy, InputGroup.d5);
        this.o8 = ThemeResolver.e(a, InputGroup.q6, InputGroup.pq);
        this.c1 = ThemeResolver.b(a, InputGroup.fg, InputGroup.dm);
        this.c2 = ThemeResolver.b(a, InputGroup.fh, InputGroup.dn);
        this.mo = ThemeResolver.d(a, InputGroup.mx, InputGroup.mr);
        this.s4 = ThemeResolver.f(a, InputGroup.td, InputGroup.s7);
        this.o1 = ThemeResolver.e(a, InputGroup.qz, InputGroup.pj);
        this.o2 = ThemeResolver.e(a, InputGroup.q0, InputGroup.pk);
        this.o3 = ThemeResolver.e(a, InputGroup.q1, InputGroup.pl);
        this.da = ThemeResolver.b(a, InputGroup.fp, InputGroup.dw);
        this.c9 = ThemeResolver.b(a, InputGroup.fo, InputGroup.dv);
        this.c6 = ThemeResolver.b(a, InputGroup.fl, InputGroup.ds);
        this.o6 = ThemeResolver.e(a, InputGroup.q4, InputGroup.po);
        this.o7 = ThemeResolver.e(a, InputGroup.q5, InputGroup.pp);
        this.o5 = ThemeResolver.e(a, InputGroup.q3, InputGroup.pn);
        this.o4 = ThemeResolver.e(a, InputGroup.q2, InputGroup.pm);
        this.c7 = ThemeResolver.b(a, InputGroup.fm, InputGroup.dt);
        this.c5 = ThemeResolver.b(a, InputGroup.fk, InputGroup.dr);
        this.c3 = ThemeResolver.b(a, InputGroup.fi, InputGroup.dp);
        this.c4 = ThemeResolver.b(a, InputGroup.fj, InputGroup.dq);
        this.c8 = ThemeResolver.b(a, InputGroup.fn, InputGroup.du);
        this.o0 = ThemeResolver.e(a, InputGroup.qy, InputGroup.pi);
        this.gu = ThemeResolver.b(a, InputGroup.gg, InputGroup.en);
        this.gv = ThemeResolver.b(a, InputGroup.gh, InputGroup.eo);
        this.m2 = ThemeResolver.d(a, InputGroup.m1, InputGroup.mv);
        this.ti = ThemeResolver.f(a, InputGroup.th, InputGroup.tb);
        this.r1 = ThemeResolver.e(a, InputGroup.rr, InputGroup.qb);
        this.r2 = ThemeResolver.e(a, InputGroup.rs, InputGroup.qc);
        this.r3 = ThemeResolver.e(a, InputGroup.rt, InputGroup.qd);
        this.g3 = ThemeResolver.b(a, InputGroup.gp, InputGroup.ew);
        this.g2 = ThemeResolver.b(a, InputGroup.go, InputGroup.ev);
        this.gz = ThemeResolver.b(a, InputGroup.gl, InputGroup.es);
        this.r6 = ThemeResolver.e(a, InputGroup.rw, InputGroup.qg);
        this.r7 = ThemeResolver.e(a, InputGroup.rx, InputGroup.qh);
        this.r5 = ThemeResolver.e(a, InputGroup.rv, InputGroup.qf);
        this.r4 = ThemeResolver.e(a, InputGroup.ru, InputGroup.qe);
        this.g0 = ThemeResolver.b(a, InputGroup.gm, InputGroup.et);
        this.gy = ThemeResolver.b(a, InputGroup.gk, InputGroup.er);
        this.gw = ThemeResolver.b(a, InputGroup.gi, InputGroup.ep);
        this.gx = ThemeResolver.b(a, InputGroup.gj, InputGroup.eq);
        this.g1 = ThemeResolver.b(a, InputGroup.gn, InputGroup.eu);
        this.r0 = ThemeResolver.e(a, InputGroup.rq, InputGroup.qa);
    };
    InputGroup.prototype.lv = function () {
        this.lr();
        if (this.ab) {
            this.lt(function (a) { return a.am = true; });
        }
        else {
            this.lt(function (a) { return a.am = false; });
        }
    };
    InputGroup.prototype.l1 = function () {
        this.lr();
        if (this.af) {
            var a = 1;
            this.lt(function (b) { return b.ak = true; });
            this.l4(a);
        }
        else {
            var b = -1;
            this.lt(function (c) { return c.ak = false; });
            this.l4(b);
        }
    };
    InputGroup.prototype.l0 = function (a) {
        this.ab = this.s ? this.ae : true;
        this.af = true;
    };
    InputGroup.prototype.l4 = function (a) {
        var _this = this;
        if ((a > 0 && this.p.playbackRate < 0) || (a < 0 && this.p.playbackRate > 0)) {
            this.p.reverse();
            this.p.finished.f(function (b) {
                if (_this.p != null) {
                    _this.p.commitStyles();
                }
                if (_this.aa) {
                    _this.p = null;
                    _this.aa = false;
                }
            });
            this.n.reverse();
            this.n.finished.f(function (b) {
                if (_this.n != null) {
                    _this.n.commitStyles();
                }
                if (_this.r) {
                    _this.n = null;
                    _this.r = false;
                }
            });
            this.o.reverse();
            this.o.finished.f(function (b) {
                if (_this.o != null) {
                    _this.o.commitStyles();
                }
                if (_this.z) {
                    _this.o = null;
                    _this.z = false;
                }
            });
        }
        else {
            this.p.play();
            this.p.finished.f(function (b) {
                if (_this.p != null) {
                    _this.p.commitStyles();
                }
                if (_this.aa) {
                    _this.p = null;
                    _this.aa = false;
                }
            });
            this.n.play();
            this.n.finished.f(function (b) {
                if (_this.n != null) {
                    _this.n.commitStyles();
                }
                if (_this.r) {
                    _this.n = null;
                    _this.r = false;
                }
            });
            this.o.play();
            this.o.finished.f(function (b) {
                if (_this.o != null) {
                    _this.o.commitStyles();
                }
                if (_this.z) {
                    _this.o = null;
                    _this.z = false;
                }
            });
        }
    };
    Object.defineProperty(InputGroup.prototype, "oc", {
        get: function () {
            return this.m6;
        },
        set: function (a) {
            var b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.l2("ActualBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "od", {
        get: function () {
            return this.m7;
        },
        set: function (a) {
            var b = this.m7;
            this.m7 = a;
            if (b != this.m7) {
                this.l2("ActualFocusBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "b6", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.l2("ActualBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "b7", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.l2("ActualFocusBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "mj", {
        get: function () {
            return this.md;
        },
        set: function (a) {
            var b = this.md;
            this.md = a;
            if (b != this.md) {
                this.l2("ActualCornerRadius", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sz", {
        get: function () {
            return this.st;
        },
        set: function (a) {
            var b = this.st;
            this.st = a;
            if (b != this.st) {
                this.l2("ActualContentPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cf", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            var b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.l2("ActualUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ce", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.l2("ActualUnderlineRippleWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cb", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.l2("ActualHoverUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "og", {
        get: function () {
            return this.na;
        },
        set: function (a) {
            var b = this.na;
            this.na = a;
            if (b != this.na) {
                this.l2("ActualUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "oh", {
        get: function () {
            return this.nb;
        },
        set: function (a) {
            var b = this.nb;
            this.nb = a;
            if (b != this.nb) {
                this.l2("ActualUnderlineRippleColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "of", {
        get: function () {
            return this.m9;
        },
        set: function (a) {
            var b = this.m9;
            this.m9 = a;
            if (b != this.m9) {
                this.l2("ActualHoverUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "oe", {
        get: function () {
            return this.m8;
        },
        set: function (a) {
            var b = this.m8;
            this.nt = a;
            if (b != this.m8) {
                this.l2("ActualFocusUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cc", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.l2("ActualUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ca", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.l2("ActualHoverUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "b8", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.l2("ActualFocusUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "b9", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.l2("ActualFocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cd", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.l2("ActualUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ob", {
        get: function () {
            return this.m5;
        },
        set: function (a) {
            var b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.l2("ActualBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cq", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.l2("BorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "g8", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.l2("FocusBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "oj", {
        get: function () {
            return this.nd;
        },
        set: function (a) {
            var b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.l2("BorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "mn", {
        get: function () {
            return this.mg;
        },
        set: function (a) {
            var b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.l2("CornerRadius", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "s3", {
        get: function () {
            return this.sw;
        },
        set: function (a) {
            var b = this.sw;
            this.sw = a;
            if (b != this.sw) {
                this.l2("ContentPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "h0", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            var b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.l2("UnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hz", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.l2("UnderlineRippleWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hc", {
        get: function () {
            return this.bh;
        },
        set: function (a) {
            var b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.l2("HoverUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sr", {
        get: function () {
            return this.n9;
        },
        set: function (a) {
            var b = this.n9;
            this.n9 = a;
            if (b != this.n9) {
                this.l2("UnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ss", {
        get: function () {
            return this.oa;
        },
        set: function (a) {
            var b = this.oa;
            this.oa = a;
            if (b != this.oa) {
                this.l2("UnderlineRippleColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sc", {
        get: function () {
            return this.nu;
        },
        set: function (a) {
            var b = this.nu;
            this.nu = a;
            if (b != this.nu) {
                this.l2("HoverUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sb", {
        get: function () {
            return this.nt;
        },
        set: function (a) {
            var b = this.nt;
            this.nt = a;
            if (b != this.nt) {
                this.l2("FocusUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hx", {
        get: function () {
            return this.b2;
        },
        set: function (a) {
            var b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.l2("UnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hb", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.l2("HoverUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "g9", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            var b = this.be;
            this.be = a;
            if (b != this.be) {
                this.l2("FocusUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ha", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            var b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.l2("FocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hy", {
        get: function () {
            return this.b3;
        },
        set: function (a) {
            var b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.l2("UnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "oi", {
        get: function () {
            return this.nc;
        },
        set: function (a) {
            var b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.l2("BackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hd", {
        get: function () {
            return this.bi;
        },
        set: function (a) {
            var b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.l2("LineTypeBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "he", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.l2("LineTypeFocusBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sf", {
        get: function () {
            return this.nx;
        },
        set: function (a) {
            var b = this.nx;
            this.nx = a;
            if (b != this.nx) {
                this.l2("LineTypeFocusBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "se", {
        get: function () {
            return this.nw;
        },
        set: function (a) {
            var b = this.nw;
            this.nw = a;
            if (b != this.nw) {
                this.l2("LineTypeBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "m3", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            var b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.l2("LineTypeCornerRadius", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "tj", {
        get: function () {
            return this.sx;
        },
        set: function (a) {
            var b = this.sx;
            this.sx = a;
            if (b != this.sx) {
                this.l2("LineTypeContentPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hm", {
        get: function () {
            return this.br;
        },
        set: function (a) {
            var b = this.br;
            this.br = a;
            if (b != this.br) {
                this.l2("LineTypeUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hl", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.l2("LineTypeUnderlineRippleWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hi", {
        get: function () {
            return this.bn;
        },
        set: function (a) {
            var b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.l2("LineTypeHoverUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "si", {
        get: function () {
            return this.n0;
        },
        set: function (a) {
            var b = this.n0;
            this.n0 = a;
            if (b != this.n0) {
                this.l2("LineTypeUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sj", {
        get: function () {
            return this.n1;
        },
        set: function (a) {
            var b = this.n1;
            this.n1 = a;
            if (b != this.n1) {
                this.l2("LineTypeUnderlineRippleColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sh", {
        get: function () {
            return this.nz;
        },
        set: function (a) {
            var b = this.nz;
            this.nu = a;
            if (b != this.nz) {
                this.l2("LineTypeHoverUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sg", {
        get: function () {
            return this.ny;
        },
        set: function (a) {
            var b = this.ny;
            this.ny = a;
            if (b != this.ny) {
                this.l2("LineTypeFocusUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hj", {
        get: function () {
            return this.bo;
        },
        set: function (a) {
            var b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.l2("LineTypeUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hh", {
        get: function () {
            return this.bm;
        },
        set: function (a) {
            var b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.l2("LineTypeHoverUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hf", {
        get: function () {
            return this.bk;
        },
        set: function (a) {
            var b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.l2("LineTypeFocusUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hg", {
        get: function () {
            return this.bl;
        },
        set: function (a) {
            var b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.l2("LineTypeFocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hk", {
        get: function () {
            return this.bp;
        },
        set: function (a) {
            var b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.l2("LineTypeUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sd", {
        get: function () {
            return this.nv;
        },
        set: function (a) {
            var b = this.nv;
            this.nv = a;
            if (b != this.nv) {
                this.l2("LineTypeBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cr", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.l2("BoxTypeBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cs", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.l2("BoxTypeFocusBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ot", {
        get: function () {
            return this.nn;
        },
        set: function (a) {
            var b = this.nn;
            this.nn = a;
            if (b != this.nn) {
                this.l2("BoxTypeFocusBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "os", {
        get: function () {
            return this.nm;
        },
        set: function (a) {
            var b = this.nm;
            this.nm = a;
            if (b != this.nm) {
                this.l2("BoxTypeBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ml", {
        get: function () {
            return this.mf;
        },
        set: function (a) {
            var b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.l2("BoxTypeCornerRadius", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "s1", {
        get: function () {
            return this.sv;
        },
        set: function (a) {
            var b = this.sv;
            this.sv = a;
            if (b != this.sv) {
                this.l2("BoxTypeContentPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "c0", {
        get: function () {
            return this.bc;
        },
        set: function (a) {
            var b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.l2("BoxTypeUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cz", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.l2("BoxTypeUnderlineRippleWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cw", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.l2("BoxTypeHoverUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ow", {
        get: function () {
            return this.nq;
        },
        set: function (a) {
            var b = this.nq;
            this.nq = a;
            if (b != this.nq) {
                this.l2("BoxTypeUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ox", {
        get: function () {
            return this.nr;
        },
        set: function (a) {
            var b = this.nr;
            this.nr = a;
            if (b != this.nr) {
                this.l2("BoxTypeUnderlineRippleColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ov", {
        get: function () {
            return this.np;
        },
        set: function (a) {
            var b = this.np;
            this.nu = a;
            if (b != this.np) {
                this.l2("BoxTypeHoverUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ou", {
        get: function () {
            return this.no;
        },
        set: function (a) {
            var b = this.no;
            this.no = a;
            if (b != this.no) {
                this.l2("BoxTypeFocusUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cx", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.l2("BoxTypeUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cv", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.l2("BoxTypeHoverUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ct", {
        get: function () {
            return this.a5;
        },
        set: function (a) {
            var b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.l2("BoxTypeFocusUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cu", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.l2("BoxTypeFocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cy", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.l2("BoxTypeUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "or", {
        get: function () {
            return this.nl;
        },
        set: function (a) {
            var b = this.nl;
            this.nl = a;
            if (b != this.nl) {
                this.l2("BoxTypeBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cg", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.l2("BorderTypeBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ch", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.l2("BorderTypeFocusBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "om", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            var b = this.ng;
            this.ng = a;
            if (b != this.ng) {
                this.l2("BorderTypeFocusBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ol", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            var b = this.nf;
            this.nf = a;
            if (b != this.nf) {
                this.l2("BorderTypeBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "mk", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            var b = this.me;
            this.me = a;
            if (b != this.me) {
                this.l2("BorderTypeCornerRadius", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "s0", {
        get: function () {
            return this.su;
        },
        set: function (a) {
            var b = this.su;
            this.su = a;
            if (b != this.su) {
                this.l2("BorderTypeContentPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cp", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            var b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.l2("BorderTypeUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "co", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.l2("BorderTypeUnderlineRippleWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cl", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.l2("BorderTypeHoverUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "op", {
        get: function () {
            return this.nj;
        },
        set: function (a) {
            var b = this.nj;
            this.nj = a;
            if (b != this.nj) {
                this.l2("BorderTypeUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "oq", {
        get: function () {
            return this.nk;
        },
        set: function (a) {
            var b = this.nk;
            this.nk = a;
            if (b != this.nk) {
                this.l2("BorderTypeUnderlineRippleColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "oo", {
        get: function () {
            return this.ni;
        },
        set: function (a) {
            var b = this.ni;
            this.nu = a;
            if (b != this.ni) {
                this.l2("BorderTypeHoverUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "on", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            var b = this.nh;
            this.nh = a;
            if (b != this.nh) {
                this.l2("BorderTypeFocusUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cm", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.l2("BorderTypeUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ck", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.l2("BorderTypeHoverUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ci", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.l2("BorderTypeFocusUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cj", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (b != this.av) {
                this.l2("BorderTypeFocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "cn", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.l2("BorderTypeUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ok", {
        get: function () {
            return this.ne;
        },
        set: function (a) {
            var b = this.ne;
            this.ne = a;
            if (b != this.ne) {
                this.l2("BorderTypeBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hn", {
        get: function () {
            return this.bs;
        },
        set: function (a) {
            var b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.l2("SearchTypeBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ho", {
        get: function () {
            return this.bt;
        },
        set: function (a) {
            var b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.l2("SearchTypeFocusBorderWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sm", {
        get: function () {
            return this.n4;
        },
        set: function (a) {
            var b = this.n4;
            this.n4 = a;
            if (b != this.n4) {
                this.l2("SearchTypeFocusBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sl", {
        get: function () {
            return this.n3;
        },
        set: function (a) {
            var b = this.n3;
            this.n3 = a;
            if (b != this.n3) {
                this.l2("SearchTypeBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "m4", {
        get: function () {
            return this.mi;
        },
        set: function (a) {
            var b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.l2("SearchTypeCornerRadius", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "tk", {
        get: function () {
            return this.sy;
        },
        set: function (a) {
            var b = this.sy;
            this.sy = a;
            if (b != this.sy) {
                this.l2("SearchTypeContentPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hw", {
        get: function () {
            return this.b1;
        },
        set: function (a) {
            var b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.l2("SearchTypeUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hv", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            var b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.l2("SearchTypeUnderlineRippleWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hs", {
        get: function () {
            return this.bx;
        },
        set: function (a) {
            var b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.l2("SearchTypeHoverUnderlineWidth", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sp", {
        get: function () {
            return this.n7;
        },
        set: function (a) {
            var b = this.n7;
            this.n7 = a;
            if (b != this.n7) {
                this.l2("SearchTypeUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sq", {
        get: function () {
            return this.n8;
        },
        set: function (a) {
            var b = this.n8;
            this.n8 = a;
            if (b != this.n8) {
                this.l2("SearchTypeUnderlineRippleColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "so", {
        get: function () {
            return this.n6;
        },
        set: function (a) {
            var b = this.n6;
            this.nu = a;
            if (b != this.n6) {
                this.l2("SearchTypeHoverUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sn", {
        get: function () {
            return this.n5;
        },
        set: function (a) {
            var b = this.n5;
            this.n5 = a;
            if (b != this.n5) {
                this.l2("SearchTypeFocusUnderlineColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ht", {
        get: function () {
            return this.by;
        },
        set: function (a) {
            var b = this.by;
            this.by = a;
            if (b != this.by) {
                this.l2("SearchTypeUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hr", {
        get: function () {
            return this.bw;
        },
        set: function (a) {
            var b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.l2("SearchTypeHoverUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hp", {
        get: function () {
            return this.bu;
        },
        set: function (a) {
            var b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.l2("SearchTypeFocusUnderlineOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hq", {
        get: function () {
            return this.bv;
        },
        set: function (a) {
            var b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.l2("SearchTypeFocusUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "hu", {
        get: function () {
            return this.bz;
        },
        set: function (a) {
            var b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.l2("SearchTypeUnderlineRippleOpacity", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sk", {
        get: function () {
            return this.n2;
        },
        set: function (a) {
            var b = this.n2;
            this.n2 = a;
            if (b != this.n2) {
                this.l2("SearchTypeBackgroundColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ae", {
        get: function () {
            return this.w;
        },
        set: function (a) {
            var b = this.w;
            this.w = a;
            if (b != this.w) {
                this.l2("IsExpanded", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ag", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (b != this.y) {
                this.l2("IsHovered", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "af", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.l2("IsFocused", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "ab", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.l2("ActualIsExpanded", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "sa", {
        get: function () {
            return this.ns;
        },
        set: function (a) {
            var b = this.ns;
            this.ns = a;
            if (b != this.ns) {
                this.l2("FocusBorderColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "j7", {
        get: function () {
            return this.h2;
        },
        set: function (a) {
            var b = this.h2;
            this.h2 = a;
            if (b != this.h2) {
                this.l2("Id", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputGroup.prototype, "disabled", {
        get: function () {
            return this.v;
        },
        set: function (a) {
            var b = this.v;
            this.v = a;
            if (b != this.v) {
                this.l2("IsDisabled", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    InputGroup.prototype.l3 = function () {
    };
    InputGroup.prototype.onDetachedFromUI = function () {
        this.view.ae();
    };
    InputGroup.prototype.onAttachedToUI = function () {
        this.view.ac();
    };
    InputGroup.prototype.ah = function () {
        return this.view.g();
    };
    InputGroup.prototype.provideContainer = function (a) {
        this.view.ad(a);
    };
    Object.defineProperty(InputGroup.prototype, "inputs", {
        get: function () {
            return this.k;
        },
        enumerable: true,
        configurable: true
    });
    InputGroup.$t = markType(InputGroup, 'InputGroup', Base.$, [INotifyPropertyChanged_$type]);
    InputGroup.c = 2;
    InputGroup.fq = 0;
    InputGroup.f1 = 0;
    InputGroup.mz = new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tf = new Thickness(1, 0, 0, 0, 0);
    InputGroup.qx = BrushUtil.g(138, 0, 0, 0);
    InputGroup.re = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rf = BrushUtil.g(255, 0, 153, 155);
    InputGroup.gt = 1;
    InputGroup.gs = 2;
    InputGroup.f5 = 2;
    InputGroup.ry = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rz = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rh = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rg = BrushUtil.g(255, 0, 153, 155);
    InputGroup.gq = 1;
    InputGroup.f4 = 1;
    InputGroup.f2 = 1;
    InputGroup.f3 = 1;
    InputGroup.gr = 0;
    InputGroup.qw = BrushUtil.g(0, 0, 0, 0);
    InputGroup.f6 = 0;
    InputGroup.f7 = 0;
    InputGroup.m0 = new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tg = new Thickness(1, 0, 0, 0, 0);
    InputGroup.rj = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rk = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rl = BrushUtil.g(255, 0, 153, 155);
    InputGroup.gf = 1;
    InputGroup.ge = 2;
    InputGroup.gb = 2;
    InputGroup.ro = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rp = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rn = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rm = BrushUtil.g(255, 0, 153, 155);
    InputGroup.gc = 1;
    InputGroup.ga = 1;
    InputGroup.f8 = 1;
    InputGroup.f9 = 1;
    InputGroup.gd = 0;
    InputGroup.ri = BrushUtil.g(0, 0, 0, 0);
    InputGroup.fr = 0;
    InputGroup.fs = 0;
    InputGroup.my = new CornerRadius(1, 4, 4, 0, 0);
    InputGroup.te = new Thickness(1, 16, 0, 16, 0);
    InputGroup.q7 = BrushUtil.g(138, 0, 0, 0);
    InputGroup.q8 = BrushUtil.g(255, 0, 153, 155);
    InputGroup.q9 = BrushUtil.g(255, 0, 153, 155);
    InputGroup.f0 = 1;
    InputGroup.fz = 2;
    InputGroup.fw = 2;
    InputGroup.rc = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rd = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rb = BrushUtil.g(138, 0, 0, 0);
    InputGroup.ra = BrushUtil.g(255, 0, 153, 155);
    InputGroup.fx = 1;
    InputGroup.fv = 1;
    InputGroup.ft = 1;
    InputGroup.fu = 1;
    InputGroup.fy = 0;
    InputGroup.q6 = BrushUtil.g(20, 0, 0, 0);
    InputGroup.fg = 1;
    InputGroup.fh = 2;
    InputGroup.mx = new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.td = new Thickness(1, 16, 0, 16, 0);
    InputGroup.qz = BrushUtil.g(138, 0, 0, 0);
    InputGroup.q0 = BrushUtil.g(255, 0, 153, 155);
    InputGroup.q1 = BrushUtil.g(255, 0, 153, 155);
    InputGroup.fp = 1;
    InputGroup.fo = 2;
    InputGroup.fl = 2;
    InputGroup.q4 = BrushUtil.g(138, 0, 0, 0);
    InputGroup.q5 = BrushUtil.g(255, 0, 153, 155);
    InputGroup.q3 = BrushUtil.g(138, 0, 0, 0);
    InputGroup.q2 = BrushUtil.g(255, 0, 153, 155);
    InputGroup.fm = 0;
    InputGroup.fk = 0;
    InputGroup.fi = 0;
    InputGroup.fj = 0;
    InputGroup.fn = 0;
    InputGroup.qy = BrushUtil.g(0, 0, 0, 0);
    InputGroup.gg = 1;
    InputGroup.gh = 2;
    InputGroup.m1 = new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.th = new Thickness(1, 16, 0, 16, 0);
    InputGroup.rr = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rs = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rt = BrushUtil.g(255, 0, 153, 155);
    InputGroup.gp = 1;
    InputGroup.go = 2;
    InputGroup.gl = 2;
    InputGroup.rw = BrushUtil.g(138, 0, 0, 0);
    InputGroup.rx = BrushUtil.g(255, 0, 153, 155);
    InputGroup.rv = BrushUtil.g(138, 0, 0, 0);
    InputGroup.ru = BrushUtil.g(255, 0, 153, 155);
    InputGroup.gm = 0;
    InputGroup.gk = 0;
    InputGroup.gi = 0;
    InputGroup.gj = 0;
    InputGroup.gn = 0;
    InputGroup.rq = BrushUtil.g(0, 0, 0, 0);
    InputGroup.dx = 0;
    InputGroup.d8 = 0;
    InputGroup.mt = new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.s9 = new Thickness(1, 0, 0, 0, 0);
    InputGroup.ph = BrushUtil.g(255, 186, 191, 199);
    InputGroup.py = BrushUtil.g(255, 33, 150, 243);
    InputGroup.pz = BrushUtil.g(255, 33, 150, 243);
    InputGroup.e0 = 1;
    InputGroup.ez = 2;
    InputGroup.ec = 2;
    InputGroup.qi = BrushUtil.g(255, 186, 191, 199);
    InputGroup.qj = BrushUtil.g(255, 33, 150, 243);
    InputGroup.p1 = BrushUtil.g(255, 186, 191, 199);
    InputGroup.p0 = BrushUtil.g(255, 33, 150, 243);
    InputGroup.ex = 1;
    InputGroup.eb = 1;
    InputGroup.d9 = 1;
    InputGroup.ea = 1;
    InputGroup.ey = 0;
    InputGroup.pg = BrushUtil.g(0, 0, 0, 0);
    InputGroup.ed = 0;
    InputGroup.ee = 0;
    InputGroup.mu = new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.ta = new Thickness(1, 0, 0, 0, 0);
    InputGroup.p3 = BrushUtil.g(255, 186, 191, 199);
    InputGroup.p4 = BrushUtil.g(255, 33, 150, 243);
    InputGroup.p5 = BrushUtil.g(255, 33, 150, 243);
    InputGroup.em = 1;
    InputGroup.el = 2;
    InputGroup.ei = 2;
    InputGroup.p8 = BrushUtil.g(255, 186, 191, 199);
    InputGroup.p9 = BrushUtil.g(255, 33, 150, 243);
    InputGroup.p7 = BrushUtil.g(255, 186, 191, 199);
    InputGroup.p6 = BrushUtil.g(255, 33, 150, 243);
    InputGroup.ej = 1;
    InputGroup.eh = 1;
    InputGroup.ef = 1;
    InputGroup.eg = 1;
    InputGroup.ek = 0;
    InputGroup.p2 = BrushUtil.g(0, 0, 0, 0);
    InputGroup.dy = 0;
    InputGroup.dz = 0;
    InputGroup.ms = new CornerRadius(1, 4, 4, 0, 0);
    InputGroup.s8 = new Thickness(1, 16, 0, 16, 0);
    InputGroup.pr = BrushUtil.g(255, 186, 191, 199);
    InputGroup.ps = BrushUtil.g(255, 33, 150, 243);
    InputGroup.pt = BrushUtil.g(255, 33, 150, 243);
    InputGroup.d7 = 1;
    InputGroup.d6 = 2;
    InputGroup.d3 = 2;
    InputGroup.pw = BrushUtil.g(255, 186, 191, 199);
    InputGroup.px = BrushUtil.g(255, 33, 150, 243);
    InputGroup.pv = BrushUtil.g(255, 186, 191, 199);
    InputGroup.pu = BrushUtil.g(255, 33, 150, 243);
    InputGroup.d4 = 1;
    InputGroup.d2 = 1;
    InputGroup.d0 = 1;
    InputGroup.d1 = 1;
    InputGroup.d5 = 0;
    InputGroup.pq = BrushUtil.g(20, 0, 0, 0);
    InputGroup.dm = 1;
    InputGroup.dn = 2;
    InputGroup.mr = new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.s7 = new Thickness(1, 16, 0, 16, 0);
    InputGroup.pj = BrushUtil.g(255, 186, 191, 199);
    InputGroup.pk = BrushUtil.g(255, 33, 150, 243);
    InputGroup.pl = BrushUtil.g(255, 33, 150, 243);
    InputGroup.dw = 1;
    InputGroup.dv = 2;
    InputGroup.ds = 2;
    InputGroup.po = BrushUtil.g(255, 186, 191, 199);
    InputGroup.pp = BrushUtil.g(255, 33, 150, 243);
    InputGroup.pn = BrushUtil.g(255, 186, 191, 199);
    InputGroup.pm = BrushUtil.g(255, 33, 150, 243);
    InputGroup.dt = 0;
    InputGroup.dr = 0;
    InputGroup.dp = 0;
    InputGroup.dq = 0;
    InputGroup.du = 0;
    InputGroup.pi = BrushUtil.g(0, 0, 0, 0);
    InputGroup.en = 1;
    InputGroup.eo = 2;
    InputGroup.mv = new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.tb = new Thickness(1, 16, 0, 16, 0);
    InputGroup.qb = BrushUtil.g(255, 186, 191, 199);
    InputGroup.qc = BrushUtil.g(255, 33, 150, 243);
    InputGroup.qd = BrushUtil.g(255, 33, 150, 243);
    InputGroup.ew = 1;
    InputGroup.ev = 2;
    InputGroup.es = 2;
    InputGroup.qg = BrushUtil.g(255, 186, 191, 199);
    InputGroup.qh = BrushUtil.g(255, 33, 150, 243);
    InputGroup.qf = BrushUtil.g(255, 186, 191, 199);
    InputGroup.qe = BrushUtil.g(255, 33, 150, 243);
    InputGroup.et = 0;
    InputGroup.er = 0;
    InputGroup.ep = 0;
    InputGroup.eq = 0;
    InputGroup.eu = 0;
    InputGroup.qa = BrushUtil.g(0, 0, 0, 0);
    InputGroup.h1 = 0;
    return InputGroup;
}(Base));
export { InputGroup };
/**
 * @hidden
 */
var InputGroupInputCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(InputGroupInputCollection, _super);
    function InputGroupInputCollection() {
        var _this = _super.call(this, InputGroupItem.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    InputGroupInputCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    InputGroupInputCollection.$t = markType(InputGroupInputCollection, 'InputGroupInputCollection', ObservableCollection$1.$.specialize(InputGroupItem.$));
    return InputGroupInputCollection;
}(ObservableCollection$1));
export { InputGroupInputCollection };
/**
 * @hidden
 */
var Label = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(Label, _super);
    function Label() {
        var _this = _super.call(this) || this;
        _this.j = 0;
        _this._view = null;
        _this.z = null;
        _this.y = null;
        _this.n = 0;
        _this.m = 1;
        _this.cl = ThemeResolver.e(Label.k, Label.c4, Label.cx);
        _this.ci = ThemeResolver.e(Label.k, Label.c1, Label.cu);
        _this.cj = ThemeResolver.e(Label.k, Label.c2, Label.cv);
        _this.ck = ThemeResolver.e(Label.k, Label.c3, Label.cw);
        _this.t = null;
        _this.cp = Label.c5;
        _this.cm = Label.cy;
        _this.cn = Label.cz;
        _this.q = 0;
        _this.ae = false;
        _this.ac = false;
        _this.u = null;
        _this.a0 = "text";
        _this.co = null;
        _this.ay = "ig-label-" + Label.ar++;
        _this.au = "inline-block";
        _this.av = "inline-block";
        _this.aw = null;
        _this.as = "center";
        _this.ap = 0;
        _this.aa = false;
        _this.ax = null;
        _this.at = null;
        _this.az = null;
        _this.ad = false;
        _this.ah = false;
        _this.ab = false;
        _this.ag = false;
        _this.af = false;
        var a = new LabelView();
        a.b = _this;
        _this.view = a;
        _this.view.y();
        return _this;
    }
    Object.defineProperty(Label.prototype, "l", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: true,
        configurable: true
    });
    Label.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Object.defineProperty(Label.prototype, "i", {
        get: function () {
            var a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        },
        enumerable: true,
        configurable: true
    });
    Label.prototype.b4 = function () {
        var _this = this;
        this.view.q();
        var a = false;
        if (this.z == null) {
            var b = new TransformGroup();
            b.j.add(((function () {
                var $ret = new TranslateTransform();
                $ret.k = _this.r == 0 ? (_this.view.h() * 0.5) : 0;
                return $ret;
            })()));
            b.j.add(((function () {
                var $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            var c_1 = -(this.view.h() * 1.3);
            if (this.o == 2) {
                c_1 = -(this.view.h() * 1.05);
            }
            if (this.o == 3) {
                c_1 = -(this.view.h() * 1.01);
            }
            var d = new TransformGroup();
            d.j.add(((function () {
                var $ret = new TranslateTransform();
                $ret.k = _this.r == 2 ? c_1 : -(_this.view.h() * 0.5);
                return $ret;
            })()));
            d.j.add(((function () {
                var $ret = new ScaleTransform();
                $ret.l = 0.75;
                $ret.m = 0.75;
                return $ret;
            })()));
            this.z = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(14, b), new AnimationKeyFrameProperty(2, BrushUtil.g(0, 255, 255, 255))).m(new AnimationKeyFrameProperty(14, d), new AnimationKeyFrameProperty(2, BrushUtil.g(this.r == 2 ? 255 : 0, 255, 255, 255))));
        }
        if (this.y == null) {
            this.y = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(7, this.ct)).m(new AnimationKeyFrameProperty(7, this.cq)));
        }
    };
    Label.prototype.cd = function (a, b) {
        var _this = this;
        if ((b > 0 && a.playbackRate < 0) || (b < 0 && a.playbackRate > 0)) {
            a.reverse();
            a.finished.f(function (c) {
                a.commitStyles();
                if (a == _this.z && _this.ag) {
                    _this.z = null;
                }
                if (a == _this.y && _this.af) {
                    _this.y = null;
                }
            });
        }
        else {
            a.play();
            a.finished.f(function (c) {
                a.commitStyles();
                if (a == _this.z && _this.ag) {
                    _this.z = null;
                }
                if (a == _this.y && _this.af) {
                    _this.y = null;
                }
            });
        }
    };
    Label.prototype.h = function (a, b, c) {
        _super.prototype.h.call(this, a, b, c);
        switch (a) {
            case "BaseTheme":
                this.cf(this.l);
                this.ch();
                break;
            case "TextColor":
            case "HoverTextColor":
            case "TextStyle":
            case "HighlightTextColor":
            case "HoverHighlightTextColor":
                this.ch();
                break;
            case "ActualTextColor":
            case "ActualHoverTextColor":
            case "ActualTextStyle":
            case "ActualHighlightTextColor":
            case "ActualHoverHighlightTextColor":
                if (this.z != null) {
                    if (this.z.playState == 3) {
                        this.z = null;
                    }
                    else {
                        this.ag = true;
                    }
                }
                if (this.y != null) {
                    if (this.y.playState == 3) {
                        this.y = null;
                    }
                    else {
                        this.af = true;
                    }
                }
                this.cg();
                break;
            case "Text":
                this.view.aa();
                break;
            case "Density":
                this.o = this.p == 0 ? 1 : this.p;
                break;
            case "ActualDensity":
                this.view.ac();
                this.view.ab();
                break;
            case "InputGroup":
                this.view.ab();
                break;
            case "IsHighlighted":
                this.b7();
                break;
            case "IsShifted":
                this.b8();
                break;
            case "ShiftType":
                if (this.z != null) {
                    if (this.z.playState == 3) {
                        this.z = null;
                    }
                    else {
                        this.ag = true;
                    }
                }
                this.cb();
                break;
            case "Display":
                this.view.v();
                break;
            case "FlexDirection":
                this.view.w();
                break;
            case "FlexGrow":
                this.view.x();
                break;
            case "AlignItems":
                this.view.r();
                break;
        }
    };
    Label.prototype.cb = function () {
        this.view.ab();
    };
    Label.prototype.b8 = function () {
        this.b4();
        var a = 1;
        var b = this.am;
        if (!b) {
            a = -1;
        }
        this.cd(this.z, a);
    };
    Label.prototype.b7 = function () {
        this.b4();
        var a = 1;
        var b = this.ak;
        if (!b) {
            a = -1;
        }
        this.cd(this.y, a);
    };
    Label.prototype.ch = function () {
        this.ct = this.c9 != null ? this.c9 : Label.c5;
        this.cs = this.c8 != null ? this.c8 : Label.c5;
        this.cq = this.c6 != null ? this.c6 : Label.cy;
    };
    Label.prototype.cg = function () {
        if (this.v != null) {
            this.view.ae(this.v);
        }
        NativeUI.n(this.view.i.rootWrapper, this.ct);
    };
    Label.prototype.cf = function (a) {
        Label.c5 = ThemeResolver.e(a, Label.c4, Label.cx);
        Label.cy = ThemeResolver.e(a, Label.c1, Label.cu);
        Label.c0 = ThemeResolver.e(a, Label.c3, Label.cw);
        Label.cz = ThemeResolver.e(a, Label.c2, Label.cv);
    };
    Object.defineProperty(Label.prototype, "p", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "o", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "ct", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.g("ActualTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "cq", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.g("ActualHighlightTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "cr", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.g("ActualHoverHighlightTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "cs", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.g("ActualHoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "v", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("ActualTextStyle", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "c9", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.g("TextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "c6", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.g("HighlightTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "c7", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.g("HoverHighlightTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.g("ShiftType", enumGetBox(LabelShiftType_$type, b), enumGetBox(LabelShiftType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "am", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.g("IsShifted", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "ak", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.g("IsHighlighted", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Label.prototype.b9 = function () {
        this.al = true;
    };
    Label.prototype.ca = function () {
        this.al = false;
    };
    Object.defineProperty(Label.prototype, "x", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("TextStyle", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "b0", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.g("Type", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "c8", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.g("HoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "bo", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.g("Id", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "bd", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.g("Display", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "bf", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (b != this.av) {
                this.g("FlexDirection", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "bh", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.g("FlexGrow", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "a7", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.g("AlignItems", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "ai", {
        get: function () {
            return this.aa;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            this.aa = true;
            if (b != this.ap) {
                this.g("TabIndex", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "bj", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.g("TabIndex", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "a9", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.g("AriaLabel", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "text", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.g("Text", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "al", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.g("IsHover", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "ao", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.g("Value", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Label.prototype, "disabled", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.g("IsDisabled", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Label.prototype.cc = function () {
        this.view.aa();
    };
    Label.prototype.onDetachedFromUI = function () {
        this.view.u();
    };
    Label.prototype.onAttachedToUI = function () {
        this.view.s();
    };
    Label.prototype.an = function () {
        return this.view.e();
    };
    Label.prototype.provideContainer = function (a) {
        this.view.t(a);
    };
    Label.$t = markType(Label, 'Label', InputGroupItem.$);
    Label.c4 = BrushUtil.g(221, 0, 0, 0);
    Label.c1 = BrushUtil.g(255, 0, 153, 155);
    Label.c3 = BrushUtil.g(221, 0, 0, 0);
    Label.c2 = BrushUtil.g(255, 0, 153, 155);
    Label.cx = BrushUtil.g(255, 24, 29, 31);
    Label.cu = BrushUtil.g(255, 33, 150, 243);
    Label.cw = BrushUtil.g(255, 24, 29, 31);
    Label.cv = BrushUtil.g(255, 33, 150, 243);
    Label.k = 2;
    Label.c5 = ThemeResolver.e(Label.k, Label.c4, Label.cx);
    Label.cy = ThemeResolver.e(Label.k, Label.c1, Label.cu);
    Label.c0 = ThemeResolver.e(Label.k, Label.c3, Label.cw);
    Label.cz = ThemeResolver.e(Label.k, Label.c2, Label.cv);
    Label.w = null;
    Label.ar = 0;
    return Label;
}(InputGroupItem));
export { Label };
/**
 * @hidden
 */
var Input = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(Input, _super);
    function Input() {
        var _this = _super.call(this) || this;
        _this._view = null;
        _this.o = 0;
        _this.j = 1;
        _this.i = 1;
        _this.bu = Input.b0;
        _this.bt = Input.bz;
        _this.r = null;
        _this.bw = Input.b0;
        _this.s = null;
        _this.am = "text";
        _this.al = "text";
        _this.bv = null;
        _this.ak = "ig-input-" + Input.ah++;
        _this.af = 0;
        _this.w = false;
        _this.aj = null;
        _this.ai = null;
        _this.z = false;
        _this.an = null;
        _this.y = false;
        _this.x = false;
        _this.change = null;
        _this.changing = null;
        var a = new InputView();
        a.a = _this;
        _this.view = a;
        _this.view.x();
        return _this;
    }
    Object.defineProperty(Input.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: true,
        configurable: true
    });
    Input.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Object.defineProperty(Input.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.g("ShiftType", enumGetBox(InputShiftType_$type, b), enumGetBox(InputShiftType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "l", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "k", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Input.prototype.h = function (a, b, c) {
        _super.prototype.h.call(this, a, b, c);
        switch (a) {
            case "TextColor":
            case "HoverTextColor":
            case "TextStyle":
                this.bs();
                break;
            case "ActualTextColor":
            case "ActualHoverTextColor":
            case "ActualTextStyle":
                this.br();
                break;
            case "Value":
                if (!this.x) {
                    this.view.ab(this.ba);
                }
                break;
            case "Density":
                this.k = this.l == 0 ? 1 : this.l;
                break;
            case "ActualDensity":
                this.view.ad();
                this.view.ac();
                break;
            case "InputGroup":
                this.bj();
                break;
            case "ShiftType":
                this.bn();
                break;
            case "Type":
                this.bo();
                break;
            case "Placeholder":
                this.bm();
                break;
        }
    };
    Input.prototype.bm = function () {
        this.view.z();
    };
    Input.prototype.bo = function () {
        this.view.aa();
    };
    Input.prototype.bn = function () {
        this.view.ac();
    };
    Input.prototype.bj = function () {
        this.view.ac();
    };
    Input.prototype.bs = function () {
        this.by = this.b2 != null ? this.b2 : Input.b0;
        this.bx = this.b1 != null ? this.b1 : Input.b0;
    };
    Input.prototype.br = function () {
        if (this.t != null) {
            this.view.af(this.t);
        }
        NativeUI.n(this.view.k, this.by);
    };
    Object.defineProperty(Input.prototype, "by", {
        get: function () {
            return this.bu;
        },
        set: function (a) {
            var b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.g("ActualTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "bx", {
        get: function () {
            return this.bt;
        },
        set: function (a) {
            var b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.g("ActualHoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "t", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            if (b != this.r) {
                this.g("ActualTextStyle", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "b2", {
        get: function () {
            return this.bw;
        },
        set: function (a) {
            var b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.g("TextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Input.prototype.be = function () {
        if (this.b != null) {
            this.b.lz(this);
        }
    };
    Input.prototype.bi = function () {
        if (this.b != null) {
            this.b.l0(this);
        }
    };
    Input.prototype.bf = function () {
        var _this = this;
        this.x = true;
        this.ba = this.view.m();
        if (this.change != null) {
            this.change(this, ((function () {
                var $ret = new InputChangeEventArgs();
                $ret.value = _this.ba;
                return $ret;
            })()));
        }
        this.x = false;
    };
    Input.prototype.bg = function () {
        var _this = this;
        this.x = true;
        this.ba = this.view.m();
        if (this.changing != null) {
            this.changing(this, ((function () {
                var $ret = new InputChangeEventArgs();
                $ret.value = _this.ba;
                return $ret;
            })()));
        }
        this.x = false;
    };
    Input.prototype.bk = function () {
        this.ad = true;
    };
    Input.prototype.bl = function () {
        this.ad = false;
    };
    Object.defineProperty(Input.prototype, "v", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.g("TextStyle", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "a8", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.g("Type", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "a2", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.g("Placeholder", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "b1", {
        get: function () {
            return this.bv;
        },
        set: function (a) {
            var b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.g("HoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "ay", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.g("Id", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "aa", {
        get: function () {
            return this.w;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            this.w = true;
            if (b != this.af) {
                this.g("TabIndex", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "av", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.g("TabIndex", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "as", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.g("AriaLabel", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "ad", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.g("IsHover", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "ba", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.g("Value", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "ab", {
        get: function () {
            return !stringIsNullOrEmpty(this.ba);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Input.prototype, "disabled", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (b != this.y) {
                this.g("IsDisabled", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Input.prototype.bp = function () {
    };
    Input.prototype.onDetachedFromUI = function () {
        this.view.w();
    };
    Input.prototype.onAttachedToUI = function () {
        this.view.u();
    };
    Input.prototype.ae = function () {
        return this.view.d();
    };
    Input.prototype.provideContainer = function (a) {
        this.view.v(a);
    };
    Input.$t = markType(Input, 'Input', InputGroupItem.$);
    Input.b0 = BrushUtil.g(221, 0, 0, 0);
    Input.bz = BrushUtil.g(221, 0, 0, 0);
    Input.u = null;
    Input.ah = 0;
    return Input;
}(InputGroupItem));
export { Input };
//# sourceMappingURL=InputGroupView_combined.js.map
