import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Button } from "./Button";
import { ButtonGroupOrientation } from "./ButtonGroupOrientation";
import { ButtonGroupDisplayStyle } from "./ButtonGroupDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ButtonGroupButtonCollection } from "./ButtonGroupButtonCollection";
import { ButtonGroupSelectionChangedEventArgs } from "./ButtonGroupSelectionChangedEventArgs";
/**
 * @hidden
 */
export declare class ButtonGroupView extends Base {
    static $t: Type;
    constructor();
    a: ButtonGroup;
    s(): void;
    d(): boolean;
    private g;
    private b;
    private f;
    readonly l: any;
    readonly y: Path;
    readonly e: boolean;
    q(a: DomRenderer): void;
    private m;
    w(a: string): void;
    v(): void;
    private n;
    t(): void;
    private c;
    private h;
    private i;
    private j;
    private k;
    p(): void;
    r(): void;
    x(a: FontInfo): void;
    u(a: Button): void;
    o(a: any): void;
}
/**
 * @hidden
 */
export declare class ButtonGroup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private n;
    o: ButtonGroupDisplayStyle;
    private e;
    g: BaseControlTheme;
    private c1;
    appendContentChild(a: any): void;
    private c0;
    private c3;
    private i;
    k: ControlDisplayDensity;
    private h;
    j: ControlDisplayDensity;
    private a;
    d: number[];
    private t;
    private db;
    private c;
    private b;
    private _view;
    view: ButtonGroupView;
    destroy(): void;
    protected c7(a: string, b: any, c: any): void;
    protected c9(a: string, b: any, c: any): void;
    private di;
    private dd;
    private dc;
    private z;
    private dh;
    private dg;
    private df;
    private static f;
    private aw;
    private gw;
    private gy;
    private gx;
    private gz;
    private av;
    private g3;
    private g0;
    private g4;
    private g7;
    private g1;
    private g2;
    private g5;
    private g6;
    private static au;
    private static gk;
    private static gm;
    private static gl;
    private static gn;
    private static at;
    private static gr;
    private static go;
    private static gs;
    private static gv;
    private static gp;
    private static gq;
    private static gt;
    private static gu;
    private static ao;
    private static fk;
    private static fm;
    private static fl;
    private static fn;
    private static an;
    private static fr;
    private static fo;
    private static fs;
    private static fv;
    private static fp;
    private static fq;
    private static ft;
    private static fu;
    private aq;
    private fw;
    private fy;
    private fx;
    private fz;
    private ap;
    private f3;
    private f0;
    private f4;
    private f7;
    private f1;
    private f2;
    private f5;
    private f6;
    private static as;
    private static f8;
    private static ga;
    private static f9;
    private static gb;
    private static ar;
    private static gf;
    private static gc;
    private static gg;
    private static gj;
    private static gd;
    private static ge;
    private static gh;
    private static gi;
    private static am;
    private static e8;
    private static fa;
    private static e9;
    private static fb;
    private static al;
    private static ff;
    private static fc;
    private static fg;
    private static fj;
    private static fd;
    private static fe;
    private static fh;
    private static fi;
    private de;
    private ac;
    ak: number;
    private dj;
    ew: Brush;
    private dl;
    ey: Brush;
    private dr;
    e3: Brush;
    private dn;
    e0: Brush;
    private dk;
    ex: Brush;
    private dm;
    ez: Brush;
    private ab;
    aj: number;
    private ds;
    e4: Brush;
    private dv;
    e7: Brush;
    private dp;
    e1: Brush;
    private dq;
    e2: Brush;
    private dt;
    e5: Brush;
    private du;
    e6: Brush;
    private ag;
    a0: number;
    private d4;
    hk: Brush;
    private d6;
    hm: Brush;
    private eb;
    hr: Brush;
    private d8;
    ho: Brush;
    private d9;
    hp: Brush;
    private d5;
    hl: Brush;
    private d7;
    hn: Brush;
    private af;
    az: number;
    private ea;
    hq: Brush;
    private es;
    h4: Brush;
    private ev;
    h7: Brush;
    private et;
    h5: Brush;
    private eu;
    h6: Brush;
    private ai;
    a2: number;
    private ec;
    hs: Brush;
    private ee;
    hu: Brush;
    private ej;
    hz: Brush;
    private eg;
    hw: Brush;
    private eh;
    hx: Brush;
    private ed;
    ht: Brush;
    private ef;
    hv: Brush;
    private ah;
    a1: number;
    private ei;
    hy: Brush;
    private eo;
    h0: Brush;
    private er;
    h3: Brush;
    static readonly cr: string;
    private ep;
    h1: Brush;
    private eq;
    h2: Brush;
    private ae;
    ay: number;
    private dw;
    g8: Brush;
    private dy;
    ha: Brush;
    private d3;
    hf: Brush;
    private d0;
    hc: Brush;
    private d1;
    hd: Brush;
    private dx;
    g9: Brush;
    private dz;
    hb: Brush;
    private ad;
    ax: number;
    private d2;
    he: Brush;
    private ek;
    hg: Brush;
    private en;
    hj: Brush;
    private el;
    hh: Brush;
    private em;
    hi: Brush;
    private p;
    q: ButtonGroupOrientation;
    private static a3;
    private a4;
    b1: string;
    private v;
    private u;
    disabled: boolean;
    private w;
    y: boolean;
    c8(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    protected aa(): boolean;
    provideContainer(a: DomRenderer): void;
    private l;
    readonly buttons: ButtonGroupButtonCollection;
    selectionChanged: (sender: any, args: ButtonGroupSelectionChangedEventArgs) => void;
}
