import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Ripple } from "./Ripple";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { CheckboxLabelPosition } from "./CheckboxLabelPosition";
import { CheckboxChangeEventArgs } from "./CheckboxChangeEventArgs";
/**
 * @hidden
 */
export declare class CheckboxView extends Base {
    static $t: Type;
    constructor();
    c: Checkbox;
    ad(): void;
    i(): boolean;
    private l;
    private f;
    private j;
    ab(a: DomRenderer): void;
    private t;
    ag(): void;
    ae(): void;
    private u;
    private x;
    private w;
    private h;
    private v;
    y(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    private z;
    private g;
    private q;
    private m;
    private p;
    readonly r: any;
    readonly e: Ripple;
    private n;
    readonly s: any;
    private d;
    private o;
    aa(): void;
    ac(): void;
    af(): void;
    ah(a: Brush, b: Brush): void;
    k(): number;
}
/**
 * @hidden
 */
export declare class Checkbox extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    view: CheckboxView;
    private b;
    d: BaseControlTheme;
    destroy(): void;
    protected ci(a: string, b: any, c: any): void;
    private co;
    protected ck(a: string, b: any, c: any): void;
    private m;
    private cn;
    private cq;
    aa: boolean;
    private c0;
    dq: Brush;
    private cv;
    c5: Brush;
    private cx;
    c7: Brush;
    private cz;
    dp: Brush;
    private cu;
    c4: Brush;
    private c1;
    dr: Brush;
    private cy;
    c8: Brush;
    private static dk;
    private static dh;
    private static ar;
    private static dg;
    private static as;
    private static di;
    private static at;
    private static dj;
    private static df;
    private static dc;
    private static ao;
    private static db;
    private static ap;
    private static dd;
    private static aq;
    private static de;
    private static c;
    private dn;
    private da;
    private am;
    private c9;
    private an;
    private dl;
    private au;
    private dm;
    private cr;
    private cw;
    c6: Brush;
    private ct;
    c3: Brush;
    private ae;
    ak: number;
    private ab;
    ah: number;
    private af;
    al: number;
    private ag;
    av: number;
    private ad;
    aj: number;
    private ac;
    ai: number;
    private cs;
    c2: Brush;
    private static a1;
    private a7;
    bv: string;
    private static a0;
    private a6;
    bt: string;
    private a8;
    labelId: string;
    private a2;
    a3: any;
    private a9;
    b4: string;
    private ax;
    private n;
    readonly u: boolean;
    az: number;
    private aw;
    ay: number;
    private q;
    focused: boolean;
    private a5;
    bj: string;
    private a4;
    bi: string;
    change: (sender: any, args: CheckboxChangeEventArgs) => void;
    private f;
    g: CheckboxLabelPosition;
    private k;
    s: boolean;
    private o;
    checked: boolean;
    private r;
    indeterminate: boolean;
    private p;
    disabled: boolean;
    private l;
    t: boolean;
    cj(): void;
    private readonly a;
    private ce;
    toggle(): void;
    private cp;
    private i;
    private j;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    onContentReady(): void;
    protected z(): boolean;
    provideContainer(a: DomRenderer): void;
}
