/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let IconView = /*@__PURE__*/ (() => {
    class IconView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.f = new List$1(Delegate_$type, 0);
            this.k = null;
            this.c = true;
            this.h = null;
            this.i = null;
        }
        r() {
        }
        d() {
            return true;
        }
        get j() {
            return this.h;
        }
        get w() {
            return null;
        }
        get e() {
            return true;
        }
        p(a) {
            if (a == null) {
                for (let b of fromEnum(this.f)) {
                    b();
                }
                this.f.clear();
            }
            this.g = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            this.g.rootWrapper.setStyleProperty("display", "flex");
            this.g.rootWrapper.setStyleProperty("flex-direction", "row");
            this.g.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.g.rootWrapper.setStyleProperty("align-items", "center");
            this.t();
            let c = this.g.createElementNS("svg", "http://www.w3.org/2000/svg");
            c.setStyleProperty("position", "absolute");
            c.setStyleProperty("top", "0");
            c.setStyleProperty("left", "0");
            c.setStyleProperty("right", "0");
            c.setStyleProperty("bottom", "0");
            c.setAttribute("viewBox", "0 0 24 24");
            this.h = c;
            let d = this.g.createElementNS("path", "http://www.w3.org/2000/svg");
            d.setAttribute("d", "");
            this.h.append(d);
            if (this.k != null) {
                d.setAttribute("d", this.k);
            }
            this.i = d;
            this.g.append(this.h);
            this.a.a6();
        }
        u(a) {
            if (this.k != a) {
                this.k = a;
                if (this.i != null) {
                    this.i.setAttribute("d", this.k);
                }
            }
        }
        t() {
            this.g.rootWrapper.setStyleProperty("width", "1.5rem");
            this.g.rootWrapper.setStyleProperty("height", "1.5rem");
        }
        l(a) {
        }
        s() {
            if (this.d()) {
            }
        }
        m(a) {
            this.a.a3();
        }
        n(a) {
            this.a.a4();
        }
        o() {
            this.c = true;
            this.f.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.m)));
            this.f.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.n)));
        }
        q() {
            this.c = false;
            for (let a of fromEnum(this.f)) {
                a();
            }
            this.f.clear();
        }
        v(a) {
            if (a != null) {
                this.g.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
    }
    IconView.$t = /*@__PURE__*/ markType(IconView, 'IconView');
    return IconView;
})();
/**
 * @hidden
 */
export let Icon = /*@__PURE__*/ (() => {
    class Icon extends Base {
        constructor() {
            super();
            this._view = null;
            this.bb = Icon.br;
            this.bf = Icon.bv;
            this.bc = Icon.bs;
            this.bd = Icon.bt;
            this.be = Icon.bu;
            this.l = Icon.r;
            this.m = Icon.s;
            this.bg = Icon.br;
            this.bl = Icon.bv;
            this.aa = null;
            this.bh = Icon.bs;
            this.bi = Icon.bt;
            this.bk = Icon.bu;
            this.n = Icon.r;
            this.o = Icon.s;
            this.b = null;
            this.bj = null;
            this.z = "ig-icon-" + Icon.x++;
            this.v = 0;
            this.d = false;
            this.y = null;
            this.f = false;
            this.e = false;
            this.propertyChanged = null;
            let a = new IconView();
            a.a = this;
            this.view = a;
            this.view.r();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        a5(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.a7(a, b, c);
        }
        a7(a, b, c) {
            switch (a) {
                case "Fill":
                case "Stroke":
                case "StrokeThickness":
                case "HoverFill":
                case "HoverStroke":
                case "HoverStrokeThickness":
                    this.ba();
                    break;
                case "ActualFill":
                case "ActualStroke":
                case "ActualHoverFill":
                case "ActualHoverStroke":
                case "ActualStrokeThickness":
                case "ActualHoverStrokeThickness":
                case "SVGPath":
                    this.a9();
                    break;
            }
        }
        ba() {
            this.bm = this.bw != null ? this.bw : Icon.br;
            this.bn = this.bx != null ? this.bx : Icon.bs;
            this.bp = this.b0 != null ? this.b0 : Icon.bu;
            this.bo = this.by != null ? this.by : Icon.bt;
            this.q = !isNaN_(this.u) ? this.u : Icon.s;
            this.p = !isNaN_(this.t) ? this.t : Icon.r;
            this.bq = this.b1 != null ? this.b1 : Icon.bv;
        }
        get h() {
            return this.svgPath != null && !this.view.e;
        }
        a9() {
            let a = this.view.j;
            if (this.h) {
                let b = this.view.w;
                if (this.j) {
                    b._fill = this.bn;
                    b._stroke = this.bo;
                    b.ac = this.p;
                }
                else {
                    b._fill = this.bm;
                    b._stroke = this.bp;
                    b.ac = this.q;
                }
            }
            else {
                if (this.svgPath != null) {
                    this.view.u(this.svgPath);
                }
                let c = this.view.j;
                if (this.j) {
                    if (this.bn != null) {
                        NativeUI.o(c, this.bn);
                    }
                    if (this.bo != null) {
                        NativeUI.v(c, this.bo);
                    }
                    if (!isNaN_(this.p)) {
                        NativeUI.y(c, this.p);
                    }
                }
                else {
                    if (this.bm != null) {
                        NativeUI.o(c, this.bm);
                    }
                    if (this.bp != null) {
                        NativeUI.v(c, this.bp);
                    }
                    if (!isNaN_(this.q)) {
                        NativeUI.y(c, this.q);
                    }
                }
            }
            if (this.c != null) {
                this.view.v(this.c);
            }
            if (this.bq != null) {
                NativeUI.n(this.view.j, this.bq);
            }
        }
        get bm() {
            return this.bb;
        }
        set bm(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.a5("ActualFill", b, a);
            }
        }
        get bq() {
            return this.bf;
        }
        set bq(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.a5("ActualTextColor", b, a);
            }
        }
        get bn() {
            return this.bc;
        }
        set bn(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.a5("ActualHoverFill", b, a);
            }
        }
        get bo() {
            return this.bd;
        }
        set bo(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.a5("ActualHoverStroke", b, a);
            }
        }
        get bp() {
            return this.be;
        }
        set bp(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.a5("ActualStroke", b, a);
            }
        }
        get p() {
            return this.l;
        }
        set p(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.a5("ActualHoverStrokeThickness", b, a);
            }
        }
        get q() {
            return this.m;
        }
        set q(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.a5("ActualStrokeThickness", b, a);
            }
        }
        get bw() {
            return this.bg;
        }
        set bw(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.a5("Fill", b, a);
            }
        }
        get b1() {
            return this.bl;
        }
        set b1(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.a5("TextColor", b, a);
            }
        }
        get svgPath() {
            return this.aa;
        }
        set svgPath(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.a5("SVGPath", b, a);
            }
        }
        get bx() {
            return this.bh;
        }
        set bx(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.a5("HoverFill", b, a);
            }
        }
        get by() {
            return this.bi;
        }
        set by(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.a5("HoverStroke", b, a);
            }
        }
        get b0() {
            return this.bk;
        }
        set b0(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.a5("Stroke", b, a);
            }
        }
        get t() {
            return this.n;
        }
        set t(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.a5("HoverStrokeThickness", b, a);
            }
        }
        get u() {
            return this.o;
        }
        set u(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.a5("StrokeThickness", b, a);
            }
        }
        a3() {
            this.j = true;
        }
        a4() {
            this.j = false;
        }
        get c() {
            return this.b;
        }
        set c(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.a5("TextStyle", b, a);
            }
        }
        get bz() {
            return this.bj;
        }
        set bz(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.a5("HoverTextColor", b, a);
            }
        }
        get ap() {
            return this.z;
        }
        set ap(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.a5("Id", b, a);
            }
        }
        get g() {
            return this.d;
        }
        get w() {
            return this.v;
        }
        set w(a) {
            let b = this.v;
            this.v = a;
            this.d = true;
            if (b != this.v) {
                this.a5("TabIndex", b, a);
            }
        }
        get ai() {
            return this.y;
        }
        set ai(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.a5("AriaLabel", b, a);
            }
        }
        get j() {
            return this.f;
        }
        set j(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.a5("IsHover", b, a);
            }
        }
        get disabled() {
            return this.e;
        }
        set disabled(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.a5("IsDisabled", b, a);
            }
        }
        a6() {
        }
        onDetachedFromUI() {
            this.view.q();
        }
        onAttachedToUI() {
            this.view.o();
        }
        k() {
            return this.view.d();
        }
        provideContainer(a) {
            this.view.p(a);
        }
    }
    Icon.$t = /*@__PURE__*/ markType(Icon, 'Icon', Base.$, [INotifyPropertyChanged_$type]);
    Icon.br = null;
    Icon.bv = null;
    Icon.bu = null;
    Icon.bs = null;
    Icon.bt = null;
    Icon.s = 0;
    Icon.r = 0;
    Icon.x = 0;
    return Icon;
})();
//# sourceMappingURL=IconView_combined.js.map
