/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, delegateCombine, typeCast, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ScaleTransform } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-react-core";
import { TransformGroup } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { PrefixShiftType_$type } from "./PrefixShiftType";
import { LabelShiftType_$type } from "./LabelShiftType";
import { InputShiftType_$type } from "./InputShiftType";
import { InputGroupDisplayType_$type } from "./InputGroupDisplayType";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ObservableCollection$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
/**
 * @hidden
 */
export let InputGroupView = /*@__PURE__*/ (() => {
    class InputGroupView extends Base {
        constructor() {
            super();
            this.d = null;
            this.l = null;
            this.e = null;
            this.i = new List$1(Delegate_$type, 0);
            this.y = null;
            this.f = true;
            this.n = null;
            this.o = null;
            this.p = null;
            this.s = null;
            this.r = null;
            this.q = null;
            this.m = null;
        }
        af() {
        }
        g() {
            return true;
        }
        get v() {
            return this.n;
        }
        get al() {
            return null;
        }
        get h() {
            return true;
        }
        ad(a) {
            if (a == null) {
                for (let b of fromEnum(this.i)) {
                    b();
                }
                this.i.clear();
            }
            this.l = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            a.rootWrapper.setStyleProperty("box-sizing", "border-box");
            a.rootWrapper.setStyleProperty("border-width", "0px");
            a.rootWrapper.setStyleProperty("border-style", "solid");
            let c = this.l.createElement("div");
            c.setStyleProperty("position", "absolute");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            c.setStyleProperty("border-style", "solid");
            c.setStyleProperty("box-sizing", "border-box");
            c.setStyleProperty("left", "0px");
            c.setStyleProperty("top", "0px");
            this.l.append(c);
            this.m = c;
            let d = this.l.createElement("div");
            d.addClass("ig-input-content");
            d.setStyleProperty("position", "relative");
            d.setStyleProperty("display", "flex");
            d.setStyleProperty("flex-direction", "row");
            d.setStyleProperty("flex-wrap", "no-wrap");
            d.setStyleProperty("flex-flow", "row nowrap");
            d.setStyleProperty("align-items", "center");
            d.setStyleProperty("padding-top", "1.125rem");
            this.p = d;
            this.i.add(d.listen("click", runOn(this, this.z)));
            this.l.append(d);
            this.l.getPortal(d, "ChildContent", (e) => {
                let comp_ = e.componentRef;
                this.s = comp_;
                this.p.setStyleProperty("flex-direction", "row");
            }, true);
            let e = this.l.createElement("div");
            e.setStyleProperty("position", "absolute");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("background-color", "rgba(0, 0, 0, 0.54)");
            e.setStyleProperty("height", "1px");
            e.setStyleProperty("pointer-events", "none");
            e.setStyleProperty("left", "0px");
            e.setStyleProperty("bottom", "1px");
            e.setStyleProperty("overflow", "visible");
            let f = this.l.createElement("span");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "2px");
            f.setStyleProperty("display", "block");
            f.setStyleProperty("pointer-events", "none");
            NativeUI.z(f, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 0.5;
                $ret.m = 1;
                return $ret;
            })()));
            f.setStyleProperty("opacity", "0");
            this.r = f;
            e.append(this.r);
            this.q = e;
            this.l.append(e);
            this.d.l3();
        }
        get u() {
            return this.l.rootWrapper;
        }
        get t() {
            return this.m;
        }
        get w() {
            return this.q;
        }
        get x() {
            return this.r;
        }
        aj(a) {
            if (this.y != a) {
                this.y = a;
                if (this.o != null) {
                    this.o.setAttribute("d", this.y);
                }
            }
        }
        ai() {
            switch (this.d.g) {
                case 1:
                    this.p.setStyleProperty("padding-top", "1.125rem");
                    break;
                case 2:
                    this.p.setStyleProperty("padding-top", ".94737rem");
                    break;
                case 3:
                    this.p.setStyleProperty("padding-top", ".81818rem");
                    break;
            }
        }
        z(a) {
        }
        ag() {
            if (this.g()) {
            }
        }
        j() {
            let a = this.l.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        ac() {
            this.f = true;
        }
        ae() {
            this.f = false;
            for (let a of fromEnum(this.i)) {
                a();
            }
            this.i.clear();
        }
        ak(a) {
            if (a != null) {
                this.l.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        k(a) {
            return a.view.h();
        }
        ab() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.t, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.w, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.r, 0, null, a);
        }
        ah(a) {
        }
        aa(a) {
            this.p.append(a);
        }
    }
    InputGroupView.$t = /*@__PURE__*/ markType(InputGroupView, 'InputGroupView');
    return InputGroupView;
})();
/**
 * @hidden
 */
export let PrefixView = /*@__PURE__*/ (() => {
    class PrefixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-prefix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.aj();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.j == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.ag();
        }
        j(a) {
            this.a.ah();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    PrefixView.$t = /*@__PURE__*/ markType(PrefixView, 'PrefixView');
    return PrefixView;
})();
/**
 * @hidden
 */
export let LabelView = /*@__PURE__*/ (() => {
    class LabelView extends Base {
        constructor() {
            super();
            this.b = null;
            this.i = null;
            this.c = null;
            this.g = new List$1(Delegate_$type, 0);
            this.m = null;
            this.d = true;
            this.j = null;
            this.k = null;
        }
        y() {
        }
        e() {
            return true;
        }
        get l() {
            return this.j;
        }
        get af() {
            return null;
        }
        get f() {
            return true;
        }
        q() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.i;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.i.rootWrapper, 0, null, a);
        }
        t(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.g.clear();
            }
            this.i = a;
            this.i.rootWrapper.setStyleProperty("display", "inline-block");
            this.i.rootWrapper.setStyleProperty("position", "relative");
            let c = this.i.createElement("label");
            c.setAttribute("type", this.b.b0);
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("white-space", "nowrap");
            c.setStyleProperty("text-overflow", "ellipsis");
            c.setStyleProperty("line-height", "1");
            c.setStyleProperty("overflow", "hidden");
            c.setStyleProperty("height", "1.125rem");
            c.setStyleProperty("backface-visibility", "hidden");
            NativeUI.n(this.i.rootWrapper, this.b.ct);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("font-family", "'Segoe UI', Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.j = c;
            this.i.append(this.j);
            this.b.cc();
        }
        ab() {
            this.b.bd = "block";
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.b.r == 0 ? (this.h() * 0.5) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.i.rootWrapper, a);
            this.j.setStyleProperty("height", "1.125rem");
            this.i.rootWrapper.setStyleProperty("position", "absolute");
            this.i.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        ac() {
            switch (this.b.o) {
                case 1:
                    this.i.rootWrapper.setStyleProperty("margin-top", "0px");
                    break;
                case 2:
                    this.i.rootWrapper.setStyleProperty("margin-top", "-.125rem");
                    break;
                case 3:
                    this.i.rootWrapper.setStyleProperty("margin-top", "-.25rem");
                    break;
            }
        }
        aa() {
            this.j.setText(this.b.text != null ? this.b.text : "");
        }
        ad(a) {
            if (this.m != a) {
                this.m = a;
                if (this.k != null) {
                    this.k.setAttribute("d", this.m);
                }
            }
        }
        v() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("display", this.b.bd);
                this.j.setStyleProperty("display", this.b.bd);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        r() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("align-items", this.b.a7);
                this.j.setStyleProperty("align-items", this.b.a7);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        w() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("flex-direction", this.b.bf);
                this.j.setStyleProperty("flex-direction", this.b.bf);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        x() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("flex-grow", this.b.bh);
                this.j.setStyleProperty("flex-grow", this.b.bh);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        n(a) {
        }
        z() {
            if (this.e()) {
            }
        }
        h() {
            let a = this.i.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        o(a) {
            this.b.b9();
        }
        p(a) {
            this.b.ca();
        }
        s() {
            this.d = true;
            this.g.add(this.i.rootWrapper.listen("mouseenter", runOn(this, this.o)));
            this.g.add(this.i.rootWrapper.listen("mouseleave", runOn(this, this.p)));
        }
        u() {
            this.d = false;
            for (let a of fromEnum(this.g)) {
                a();
            }
            this.g.clear();
        }
        ae(a) {
            if (a != null) {
                this.i.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
    }
    LabelView.$t = /*@__PURE__*/ markType(LabelView, 'LabelView');
    return LabelView;
})();
/**
 * @hidden
 */
export let InputView = /*@__PURE__*/ (() => {
    class InputView extends Base {
        constructor() {
            super();
            this.a = null;
            this.h = null;
            this.b = null;
            this.f = new List$1(Delegate_$type, 0);
            this.l = null;
            this.c = true;
            this.i = null;
            this.j = null;
        }
        x() {
        }
        d() {
            return true;
        }
        get k() {
            return this.i;
        }
        get ag() {
            return null;
        }
        get e() {
            return true;
        }
        v(a) {
            if (a == null) {
                for (let b of fromEnum(this.f)) {
                    b();
                }
                this.f.clear();
            }
            this.h = a;
            this.h.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.h.createElement("input");
            c.setAttribute("type", this.a.a8);
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("box-sizing", "border-box");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("border", "none");
            c.setStyleProperty("height", "2rem");
            c.setStyleProperty("line-height", "0");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("min-width", "0");
            c.setStyleProperty("overflow", "visible");
            c.setStyleProperty("background", "transparent");
            c.setStyleProperty("background-position-x", "initial");
            c.setStyleProperty("background-position-y", "initial");
            c.setStyleProperty("background-size", "initial");
            c.setStyleProperty("background-repeat-x", "initial");
            c.setStyleProperty("background-repeat-y", "initial");
            c.setStyleProperty("background-attachment", "initial");
            c.setStyleProperty("background-origin", "initial");
            c.setStyleProperty("background-color", "transparent");
            NativeUI.n(c, this.a.by);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("border-top", "0.1875rem solid transparent");
            c.setStyleProperty("padding-bottom", "0.1875rem");
            c.setStyleProperty("font-family", "'Segoe UI', Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.f.add(c.listen("change", runOn(this, this.r)));
            this.f.add(c.listen("input", runOn(this, this.s)));
            this.f.add(c.listen("focus", runOn(this, this.t)));
            this.f.add(c.listen("blur", runOn(this, this.q)));
            this.f.add(c.listen("mouseenter", runOn(this, this.o)));
            this.f.add(c.listen("mouseleave", runOn(this, this.p)));
            this.i = c;
            this.h.append(this.i);
            this.a.bp();
        }
        aa() {
            this.i.setAttribute("type", this.a.a8);
        }
        z() {
            this.i.setAttribute("placeholder", this.a.a2);
        }
        ad() {
            switch (this.a.k) {
                case 1:
                    this.i.setStyleProperty("height", "2rem");
                    this.i.setStyleProperty("font-size", "1rem");
                    break;
                case 2:
                    this.i.setStyleProperty("height", "1.68421rem");
                    this.i.setStyleProperty("font-size", "1rem");
                    break;
                case 3:
                    this.i.setStyleProperty("height", "1.45455rem");
                    this.i.setStyleProperty("font-size", ".95455rem");
                    break;
            }
        }
        ac() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.p == 2 ? (this.g() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.h.rootWrapper, a);
            this.h.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        g() {
            let a = this.h.rootWrapper.getStyleProperty("height");
            let b = parseFloat(stringReplace(a, "px", ""));
            return b;
        }
        ab(a) {
            this.i.setProperty("value", a);
        }
        q(a) {
            this.a.be();
        }
        t(a) {
            this.a.bi();
        }
        r(a) {
            this.a.bf();
        }
        s(a) {
            this.a.bg();
        }
        ae(a) {
            if (this.l != a) {
                this.l = a;
                if (this.j != null) {
                    this.j.setAttribute("d", this.l);
                }
            }
        }
        m() {
            return this.i.getProperty("value");
        }
        n(a) {
        }
        y() {
            if (this.d()) {
            }
        }
        o(a) {
            this.a.bk();
        }
        p(a) {
            this.a.bl();
        }
        u() {
            this.c = true;
            this.f.add(this.i.listen("change", runOn(this, this.r)));
            this.f.add(this.i.listen("input", runOn(this, this.s)));
            this.f.add(this.i.listen("focus", runOn(this, this.t)));
            this.f.add(this.i.listen("blur", runOn(this, this.q)));
            this.f.add(this.i.listen("mouseenter", runOn(this, this.o)));
            this.f.add(this.i.listen("mouseleave", runOn(this, this.p)));
        }
        w() {
            this.c = false;
            for (let a of fromEnum(this.f)) {
                a();
            }
            this.f.clear();
        }
        af(a) {
            if (a != null) {
                this.h.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
    }
    InputView.$t = /*@__PURE__*/ markType(InputView, 'InputView');
    return InputView;
})();
/**
 * @hidden
 */
export let InputGroupItem = /*@__PURE__*/ (() => {
    class InputGroupItem extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = null;
            this.propertyChanged = null;
        }
        get e() {
            return this.c;
        }
        set e(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.g("Name", b, a);
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g("InputGroup", b, a);
            }
        }
        g(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.h(a, b, c);
        }
        h(a, b, c) {
        }
    }
    InputGroupItem.$t = /*@__PURE__*/ markType(InputGroupItem, 'InputGroupItem', Base.$, [INotifyPropertyChanged_$type]);
    return InputGroupItem;
})();
/**
 * @hidden
 */
export let Prefix = /*@__PURE__*/ (() => {
    class Prefix extends InputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.i = 0;
            this.t = "ig-prefix-" + Prefix.r++;
            this.s = null;
            this.m = false;
            this.l = false;
            this.n = false;
            let a = new PrefixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ShiftType", enumGetBox(PrefixShiftType_$type, b), enumGetBox(PrefixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.af();
                    break;
                case "ShiftType":
                    this.ai();
                    break;
            }
        }
        ai() {
            this.view.q();
        }
        af() {
            this.view.q();
        }
        am() {
        }
        al() {
        }
        ag() {
            this.p = true;
        }
        ah() {
            this.p = false;
        }
        get w() {
            return this.t;
        }
        set w(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("Id", b, a);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.g("AriaLabel", b, a);
            }
        }
        get p() {
            return this.m;
        }
        set p(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.l;
        }
        set disabled(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.g("IsDisabled", b, a);
            }
        }
        aj() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        q() {
            return this.view.d();
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    Prefix.$t = /*@__PURE__*/ markType(Prefix, 'Prefix', InputGroupItem.$);
    Prefix.r = 0;
    return Prefix;
})();
/**
 * @hidden
 */
export let InputGroup = /*@__PURE__*/ (() => {
    class InputGroup extends Base {
        constructor() {
            super();
            this.i = 0;
            this.f = 1;
            this.e = 1;
            this.b = 0;
            this._view = null;
            this.p = null;
            this.n = null;
            this.db = ThemeResolver.b(InputGroup.c, InputGroup.fq, InputGroup.dx);
            this.e1 = ThemeResolver.b(InputGroup.c, InputGroup.f1, InputGroup.d8);
            this.mq = ThemeResolver.d(InputGroup.c, InputGroup.mz, InputGroup.mt);
            this.s6 = ThemeResolver.f(InputGroup.c, InputGroup.tf, InputGroup.s9);
            this.oz = ThemeResolver.e(InputGroup.c, InputGroup.qx, InputGroup.ph);
            this.qk = ThemeResolver.e(InputGroup.c, InputGroup.re, InputGroup.py);
            this.ql = ThemeResolver.e(InputGroup.c, InputGroup.rf, InputGroup.pz);
            this.g7 = ThemeResolver.b(InputGroup.c, InputGroup.gt, InputGroup.e0);
            this.g6 = ThemeResolver.b(InputGroup.c, InputGroup.gs, InputGroup.ez);
            this.e5 = ThemeResolver.b(InputGroup.c, InputGroup.f5, InputGroup.ec);
            this.r8 = ThemeResolver.e(InputGroup.c, InputGroup.ry, InputGroup.qi);
            this.r9 = ThemeResolver.e(InputGroup.c, InputGroup.rz, InputGroup.qj);
            this.qn = ThemeResolver.e(InputGroup.c, InputGroup.rh, InputGroup.p1);
            this.qm = ThemeResolver.e(InputGroup.c, InputGroup.rg, InputGroup.p0);
            this.g4 = ThemeResolver.b(InputGroup.c, InputGroup.gq, InputGroup.ex);
            this.e4 = ThemeResolver.b(InputGroup.c, InputGroup.f4, InputGroup.eb);
            this.e2 = ThemeResolver.b(InputGroup.c, InputGroup.f2, InputGroup.d9);
            this.e3 = ThemeResolver.b(InputGroup.c, InputGroup.f3, InputGroup.ea);
            this.g5 = ThemeResolver.b(InputGroup.c, InputGroup.gr, InputGroup.ey);
            this.oy = ThemeResolver.e(InputGroup.c, InputGroup.qw, InputGroup.pg);
            this.e6 = ThemeResolver.b(InputGroup.c, InputGroup.f6, InputGroup.ed);
            this.e7 = ThemeResolver.b(InputGroup.c, InputGroup.f7, InputGroup.ee);
            this.mw = ThemeResolver.d(InputGroup.c, InputGroup.m0, InputGroup.mu);
            this.tc = ThemeResolver.f(InputGroup.c, InputGroup.tg, InputGroup.ta);
            this.qp = ThemeResolver.e(InputGroup.c, InputGroup.rj, InputGroup.p3);
            this.qq = ThemeResolver.e(InputGroup.c, InputGroup.rk, InputGroup.p4);
            this.qr = ThemeResolver.e(InputGroup.c, InputGroup.rl, InputGroup.p5);
            this.ff = ThemeResolver.b(InputGroup.c, InputGroup.gf, InputGroup.em);
            this.fe = ThemeResolver.b(InputGroup.c, InputGroup.ge, InputGroup.el);
            this.fb = ThemeResolver.b(InputGroup.c, InputGroup.gb, InputGroup.ei);
            this.qu = ThemeResolver.e(InputGroup.c, InputGroup.ro, InputGroup.p8);
            this.qv = ThemeResolver.e(InputGroup.c, InputGroup.rp, InputGroup.p9);
            this.qt = ThemeResolver.e(InputGroup.c, InputGroup.rn, InputGroup.p7);
            this.qs = ThemeResolver.e(InputGroup.c, InputGroup.rm, InputGroup.p6);
            this.fc = ThemeResolver.b(InputGroup.c, InputGroup.gc, InputGroup.ej);
            this.fa = ThemeResolver.b(InputGroup.c, InputGroup.ga, InputGroup.eh);
            this.e8 = ThemeResolver.b(InputGroup.c, InputGroup.f8, InputGroup.ef);
            this.e9 = ThemeResolver.b(InputGroup.c, InputGroup.f9, InputGroup.eg);
            this.fd = ThemeResolver.b(InputGroup.c, InputGroup.gd, InputGroup.ek);
            this.qo = ThemeResolver.e(InputGroup.c, InputGroup.ri, InputGroup.p2);
            this.dc = ThemeResolver.b(InputGroup.c, InputGroup.fr, InputGroup.dy);
            this.dd = ThemeResolver.b(InputGroup.c, InputGroup.fs, InputGroup.dz);
            this.mp = ThemeResolver.d(InputGroup.c, InputGroup.my, InputGroup.ms);
            this.s5 = ThemeResolver.f(InputGroup.c, InputGroup.te, InputGroup.s8);
            this.o9 = ThemeResolver.e(InputGroup.c, InputGroup.q7, InputGroup.pr);
            this.pa = ThemeResolver.e(InputGroup.c, InputGroup.q8, InputGroup.ps);
            this.pb = ThemeResolver.e(InputGroup.c, InputGroup.q9, InputGroup.pt);
            this.dl = ThemeResolver.b(InputGroup.c, InputGroup.f0, InputGroup.d7);
            this.dk = ThemeResolver.b(InputGroup.c, InputGroup.fz, InputGroup.d6);
            this.dh = ThemeResolver.b(InputGroup.c, InputGroup.fw, InputGroup.d3);
            this.pe = ThemeResolver.e(InputGroup.c, InputGroup.rc, InputGroup.pw);
            this.pf = ThemeResolver.e(InputGroup.c, InputGroup.rd, InputGroup.px);
            this.pd = ThemeResolver.e(InputGroup.c, InputGroup.rb, InputGroup.pv);
            this.pc = ThemeResolver.e(InputGroup.c, InputGroup.ra, InputGroup.pu);
            this.di = ThemeResolver.b(InputGroup.c, InputGroup.fx, InputGroup.d4);
            this.dg = ThemeResolver.b(InputGroup.c, InputGroup.fv, InputGroup.d2);
            this.de = ThemeResolver.b(InputGroup.c, InputGroup.ft, InputGroup.d0);
            this.df = ThemeResolver.b(InputGroup.c, InputGroup.fu, InputGroup.d1);
            this.dj = ThemeResolver.b(InputGroup.c, InputGroup.fy, InputGroup.d5);
            this.o8 = ThemeResolver.e(InputGroup.c, InputGroup.q6, InputGroup.pq);
            this.c1 = ThemeResolver.b(InputGroup.c, InputGroup.fg, InputGroup.dm);
            this.c2 = ThemeResolver.b(InputGroup.c, InputGroup.fh, InputGroup.dn);
            this.mo = ThemeResolver.d(InputGroup.c, InputGroup.mx, InputGroup.mr);
            this.s4 = ThemeResolver.f(InputGroup.c, InputGroup.td, InputGroup.s7);
            this.o1 = ThemeResolver.e(InputGroup.c, InputGroup.qz, InputGroup.pj);
            this.o2 = ThemeResolver.e(InputGroup.c, InputGroup.q0, InputGroup.pk);
            this.o3 = ThemeResolver.e(InputGroup.c, InputGroup.q1, InputGroup.pl);
            this.da = ThemeResolver.b(InputGroup.c, InputGroup.fp, InputGroup.dw);
            this.c9 = ThemeResolver.b(InputGroup.c, InputGroup.fo, InputGroup.dv);
            this.c6 = ThemeResolver.b(InputGroup.c, InputGroup.fl, InputGroup.ds);
            this.o6 = ThemeResolver.e(InputGroup.c, InputGroup.q4, InputGroup.po);
            this.o7 = ThemeResolver.e(InputGroup.c, InputGroup.q5, InputGroup.pp);
            this.o5 = ThemeResolver.e(InputGroup.c, InputGroup.q3, InputGroup.pn);
            this.o4 = ThemeResolver.e(InputGroup.c, InputGroup.q2, InputGroup.pm);
            this.c7 = ThemeResolver.b(InputGroup.c, InputGroup.fm, InputGroup.dt);
            this.c5 = ThemeResolver.b(InputGroup.c, InputGroup.fk, InputGroup.dr);
            this.c3 = ThemeResolver.b(InputGroup.c, InputGroup.fi, InputGroup.dp);
            this.c4 = ThemeResolver.b(InputGroup.c, InputGroup.fj, InputGroup.dq);
            this.c8 = ThemeResolver.b(InputGroup.c, InputGroup.fn, InputGroup.du);
            this.o0 = ThemeResolver.e(InputGroup.c, InputGroup.qy, InputGroup.pi);
            this.gu = ThemeResolver.b(InputGroup.c, InputGroup.gg, InputGroup.en);
            this.gv = ThemeResolver.b(InputGroup.c, InputGroup.gh, InputGroup.eo);
            this.m2 = ThemeResolver.d(InputGroup.c, InputGroup.m1, InputGroup.mv);
            this.ti = ThemeResolver.f(InputGroup.c, InputGroup.th, InputGroup.tb);
            this.r1 = ThemeResolver.e(InputGroup.c, InputGroup.rr, InputGroup.qb);
            this.r2 = ThemeResolver.e(InputGroup.c, InputGroup.rs, InputGroup.qc);
            this.r3 = ThemeResolver.e(InputGroup.c, InputGroup.rt, InputGroup.qd);
            this.g3 = ThemeResolver.b(InputGroup.c, InputGroup.gp, InputGroup.ew);
            this.g2 = ThemeResolver.b(InputGroup.c, InputGroup.go, InputGroup.ev);
            this.gz = ThemeResolver.b(InputGroup.c, InputGroup.gl, InputGroup.es);
            this.r6 = ThemeResolver.e(InputGroup.c, InputGroup.rw, InputGroup.qg);
            this.r7 = ThemeResolver.e(InputGroup.c, InputGroup.rx, InputGroup.qh);
            this.r5 = ThemeResolver.e(InputGroup.c, InputGroup.rv, InputGroup.qf);
            this.r4 = ThemeResolver.e(InputGroup.c, InputGroup.ru, InputGroup.qe);
            this.g0 = ThemeResolver.b(InputGroup.c, InputGroup.gm, InputGroup.et);
            this.gy = ThemeResolver.b(InputGroup.c, InputGroup.gk, InputGroup.er);
            this.gw = ThemeResolver.b(InputGroup.c, InputGroup.gi, InputGroup.ep);
            this.gx = ThemeResolver.b(InputGroup.c, InputGroup.gj, InputGroup.eq);
            this.g1 = ThemeResolver.b(InputGroup.c, InputGroup.gn, InputGroup.eu);
            this.r0 = ThemeResolver.e(InputGroup.c, InputGroup.rq, InputGroup.qa);
            this.m6 = ThemeResolver.e(InputGroup.c, InputGroup.qx, InputGroup.ph);
            this.m7 = ThemeResolver.e(InputGroup.c, InputGroup.re, InputGroup.py);
            this.ai = ThemeResolver.b(InputGroup.c, InputGroup.fq, InputGroup.dx);
            this.aj = ThemeResolver.b(InputGroup.c, InputGroup.f1, InputGroup.d8);
            this.md = ThemeResolver.d(InputGroup.c, InputGroup.mz, InputGroup.mt);
            this.st = ThemeResolver.f(InputGroup.c, InputGroup.tf, InputGroup.s9);
            this.ar = ThemeResolver.b(InputGroup.c, InputGroup.gt, InputGroup.e0);
            this.aq = ThemeResolver.b(InputGroup.c, InputGroup.gs, InputGroup.ez);
            this.an = ThemeResolver.b(InputGroup.c, InputGroup.f5, InputGroup.ec);
            this.na = ThemeResolver.e(InputGroup.c, InputGroup.ry, InputGroup.qi);
            this.nb = ThemeResolver.e(InputGroup.c, InputGroup.rz, InputGroup.qj);
            this.m9 = ThemeResolver.e(InputGroup.c, InputGroup.rh, InputGroup.p1);
            this.m8 = ThemeResolver.e(InputGroup.c, InputGroup.rg, InputGroup.p0);
            this.ao = ThemeResolver.b(InputGroup.c, InputGroup.gq, InputGroup.ex);
            this.am = ThemeResolver.b(InputGroup.c, InputGroup.f4, InputGroup.eb);
            this.ak = ThemeResolver.b(InputGroup.c, InputGroup.f2, InputGroup.d9);
            this.al = ThemeResolver.b(InputGroup.c, InputGroup.f3, InputGroup.ea);
            this.ap = ThemeResolver.b(InputGroup.c, InputGroup.gr, InputGroup.ey);
            this.m5 = ThemeResolver.e(InputGroup.c, InputGroup.qw, InputGroup.pg);
            this.a2 = NaN;
            this.bd = NaN;
            this.nd = null;
            this.mg = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.sw = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b5 = NaN;
            this.b4 = NaN;
            this.bh = NaN;
            this.n9 = null;
            this.oa = null;
            this.nu = null;
            this.nt = null;
            this.b2 = NaN;
            this.bg = NaN;
            this.be = NaN;
            this.bf = NaN;
            this.b3 = NaN;
            this.nc = null;
            this.bi = NaN;
            this.bj = NaN;
            this.nx = null;
            this.nw = null;
            this.mh = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.sx = new Thickness(1, NaN, NaN, NaN, NaN);
            this.br = NaN;
            this.bq = NaN;
            this.bn = NaN;
            this.n0 = null;
            this.n1 = null;
            this.nz = null;
            this.ny = null;
            this.bo = NaN;
            this.bm = NaN;
            this.bk = NaN;
            this.bl = NaN;
            this.bp = NaN;
            this.nv = null;
            this.a3 = NaN;
            this.a4 = NaN;
            this.nn = null;
            this.nm = null;
            this.mf = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.sv = new Thickness(1, NaN, NaN, NaN, NaN);
            this.bc = NaN;
            this.bb = NaN;
            this.a8 = NaN;
            this.nq = null;
            this.nr = null;
            this.np = null;
            this.no = null;
            this.a9 = NaN;
            this.a7 = NaN;
            this.a5 = NaN;
            this.a6 = NaN;
            this.ba = NaN;
            this.nl = null;
            this.as = NaN;
            this.at = NaN;
            this.ng = null;
            this.nf = null;
            this.me = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.su = new Thickness(1, NaN, NaN, NaN, NaN);
            this.a1 = NaN;
            this.a0 = NaN;
            this.ax = NaN;
            this.nj = null;
            this.nk = null;
            this.ni = null;
            this.nh = null;
            this.ay = NaN;
            this.aw = NaN;
            this.au = NaN;
            this.av = NaN;
            this.az = NaN;
            this.ne = null;
            this.bs = NaN;
            this.bt = NaN;
            this.n4 = null;
            this.n3 = null;
            this.mi = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.sy = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b1 = NaN;
            this.b0 = NaN;
            this.bx = NaN;
            this.n7 = null;
            this.n8 = null;
            this.n6 = null;
            this.n5 = null;
            this.by = NaN;
            this.bw = NaN;
            this.bu = NaN;
            this.bv = NaN;
            this.bz = NaN;
            this.n2 = null;
            this.w = false;
            this.s = false;
            this.y = false;
            this.u = false;
            this.x = false;
            this.t = false;
            this.q = false;
            this.ns = null;
            this.h2 = "ig-inputgroup-" + InputGroup.h1++;
            this.v = false;
            this.propertyChanged = null;
            this.k = new InputGroupInputCollection();
            this.o = null;
            this.aa = false;
            this.r = false;
            this.z = false;
            let a = new InputGroupView();
            a.d = this;
            this.view = a;
            this.view.af();
            let b = this.k;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.ln));
            let c = this.k;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.lo));
        }
        lo(a, b) {
            this.l8();
        }
        appendContentChild(a) {
            this.view.aa(a);
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.l2("Type", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        }
        get h() {
            return this.f;
        }
        set h(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.l2("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get g() {
            return this.e;
        }
        set g(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.l2("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        lt(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Label.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        lu(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Prefix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        ls(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Input.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        ln(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    let d = c;
                    if (d != null) {
                        d.b = null;
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    let f = e;
                    if (f != null) {
                        f.b = this;
                    }
                }
            }
            this.mb();
            this.ma();
            this.mc();
            this.l8();
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.l2("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        l2(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.l5(a, b, c);
        }
        l5(a, b, c) {
            switch (a) {
                case "BaseTheme":
                    this.l7(this.d);
                    this.l9();
                    this.lt((d) => d.l = this.d == 0 ? 2 : this.d);
                    break;
                case "ActualBorderColor":
                case "ActualBackgroundColor":
                case "ActualBorderWidth":
                case "ActualFocusBorderColor":
                case "ActualFocusBorderWidth":
                case "ActualCornerRadius":
                case "ActualContentPadding":
                case "ActualUnderlineOpacity":
                case "ActualUnderlineRippleOpacity":
                case "ActualUnderlineRippleWidth":
                case "ActualUnderlineRippleColor":
                case "ActualUnderlineColor":
                case "ActualHoverUnderlineColor":
                case "ActualUnderlineWidth":
                case "ActualHoverUnderlineWidth":
                case "ActualHoverUnderlineOpacity":
                case "ActualFocusUnderlineColor":
                case "ActualFocusUnderlineOpacity":
                case "ActualFocusUnderlineRippleOpacity":
                case "IsHovered":
                    this.z = true;
                    this.aa = true;
                    this.r = true;
                    this.l8();
                    break;
                case "BorderColor":
                case "BackgroundColor":
                case "BorderWidth":
                case "FocusBorderColor":
                case "FocusBorderWidth":
                case "CornerRadius":
                case "ContentPadding":
                case "UnderlineOpacity":
                case "UnderlineRippleOpacity":
                case "UnderlineRippleWidth":
                case "UnderlineRippleColor":
                case "UnderlineColor":
                case "HoverUnderlineColor":
                case "UnderlineWidth":
                case "HoverUnderlineWidth":
                case "HoverUnderlineOpacity":
                case "FocusUnderlineColor":
                case "FocusUnderlineOpacity":
                case "FocusUnderlineRippleOpacity":
                case "LineTypeBorderColor":
                case "LineTypeBackgroundColor":
                case "LineTypeBorderWidth":
                case "LineTypeFocusBorderColor":
                case "LineTypeFocusBorderWidth":
                case "LineTypeCornerRadius":
                case "LineTypeContentPadding":
                case "LineTypeUnderlineOpacity":
                case "LineTypeUnderlineRippleOpacity":
                case "LineTypeUnderlineRippleWidth":
                case "LineTypeUnderlineRippleColor":
                case "LineTypeUnderlineColor":
                case "LineTypeHoverUnderlineColor":
                case "LineTypeUnderlineWidth":
                case "LineTypeHoverUnderlineWidth":
                case "LineTypeHoverUnderlineOpacity":
                case "LineTypeFocusUnderlineColor":
                case "LineTypeFocusUnderlineOpacity":
                case "LineTypeFocusUnderlineRippleOpacity":
                case "BoxTypeBorderColor":
                case "BoxTypeBackgroundColor":
                case "BoxTypeBorderWidth":
                case "BoxTypeFocusBorderColor":
                case "BoxTypeFocusBorderWidth":
                case "BoxTypeCornerRadius":
                case "BoxTypeContentPadding":
                case "BoxTypeUnderlineOpacity":
                case "BoxTypeUnderlineRippleOpacity":
                case "BoxTypeUnderlineRippleWidth":
                case "BoxTypeUnderlineRippleColor":
                case "BoxTypeUnderlineColor":
                case "BoxTypeHoverUnderlineColor":
                case "BoxTypeUnderlineWidth":
                case "BoxTypeHoverUnderlineWidth":
                case "BoxTypeHoverUnderlineOpacity":
                case "BoxTypeFocusUnderlineColor":
                case "BoxTypeFocusUnderlineOpacity":
                case "BoxTypeFocusUnderlineRippleOpacity":
                case "BorderTypeBorderColor":
                case "BorderTypeBackgroundColor":
                case "BorderTypeBorderWidth":
                case "BorderTypeFocusBorderColor":
                case "BorderTypeFocusBorderWidth":
                case "BorderTypeCornerRadius":
                case "BorderTypeContentPadding":
                case "BorderTypeUnderlineOpacity":
                case "BorderTypeUnderlineRippleOpacity":
                case "BorderTypeUnderlineRippleWidth":
                case "BorderTypeUnderlineRippleColor":
                case "BorderTypeUnderlineColor":
                case "BorderTypeHoverUnderlineColor":
                case "BorderTypeUnderlineWidth":
                case "BorderTypeHoverUnderlineWidth":
                case "BorderTypeHoverUnderlineOpacity":
                case "BorderTypeFocusUnderlineColor":
                case "BorderTypeFocusUnderlineOpacity":
                case "BorderTypeFocusUnderlineRippleOpacity":
                case "Type":
                    this.l9();
                    break;
                case "ActualDensity":
                    this.view.ai();
                    this.l9();
                    break;
                case "Density":
                    this.g = this.h == 0 ? 1 : this.h;
                    break;
                case "IsFocused":
                    this.l1();
                    this.l8();
                    break;
                case "IsExpanded":
                    this.s = true;
                    this.ab = this.ae;
                    break;
                case "ActualIsExpanded":
                    this.lv();
                    break;
            }
        }
        mm(a, b) {
            return new CornerRadius(1, !isNaN_(a.topLeft) ? a.topLeft : b.topLeft, !isNaN_(a.topRight) ? a.topRight : b.topRight, !isNaN_(a.bottomRight) ? a.bottomRight : b.bottomRight, !isNaN_(a.bottomLeft) ? a.bottomLeft : b.bottomLeft);
        }
        s2(a, b) {
            return new Thickness(1, !isNaN_(a.left) ? a.left : b.left, !isNaN_(a.top) ? a.top : b.top, !isNaN_(a.right) ? a.right : b.right, !isNaN_(a.bottom) ? a.bottom : b.bottom);
        }
        mb() {
            this.lt((a) => {
                a.p = this.g;
                a.l = this.d == 0 ? 2 : this.d;
                switch (this.j) {
                    case 0:
                        a.r = 0;
                        break;
                    case 1:
                        a.r = 1;
                        break;
                    case 2:
                    case 3:
                        a.r = 2;
                        break;
                }
            });
        }
        mc() {
            this.lu((a) => {
                switch (this.j) {
                    case 0:
                        a.j = 0;
                        break;
                    case 1:
                        a.j = 1;
                        break;
                    case 2:
                    case 3:
                        a.j = 2;
                        break;
                }
            });
        }
        ma() {
            this.ls((a) => {
                a.l = this.g;
                switch (this.j) {
                    case 0:
                        a.p = 0;
                        break;
                    case 1:
                        a.p = 1;
                        break;
                    case 2:
                    case 3:
                        a.p = 2;
                        break;
                }
            });
        }
        l9() {
            this.mb();
            this.ma();
            this.mc();
            switch (this.j) {
                case 0:
                    this.oc = this.oj != null ? this.oj : this.se != null ? this.se : this.qp;
                    this.ob = this.oi != null ? this.oi : this.sd != null ? this.sd : this.qo;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.hd) ? this.hd : this.e6;
                    this.od = this.sa != null ? this.sa : this.sf != null ? this.sf : this.qq;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.he) ? this.he : this.e7;
                    this.mj = this.mm(this.mn, this.mm(this.m3, this.mw));
                    this.sz = this.s2(this.s3, this.s2(this.tj, this.tc));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.hj) ? this.hj : this.fc;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.hk) ? this.hk : this.fd;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.hl) ? this.hl : this.fe;
                    this.oh = this.ss != null ? this.ss : this.sj != null ? this.sj : this.qv;
                    this.og = this.sr != null ? this.sr : this.si != null ? this.si : this.qu;
                    this.of = this.sc != null ? this.sc : this.sh != null ? this.sh : this.qt;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.hm) ? this.hm : this.ff;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hi) ? this.hi : this.fb;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.hh) ? this.hh : this.fa;
                    this.oe = this.sb != null ? this.sb : this.sg != null ? this.sg : this.qs;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.hf) ? this.hf : this.e8;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.hg) ? this.hg : this.e9;
                    break;
                case 1:
                    this.oc = this.oj != null ? this.oj : this.os != null ? this.os : this.o9;
                    this.ob = this.oi != null ? this.oi : this.or != null ? this.or : this.o8;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.cr) ? this.cr : this.dc;
                    this.od = this.sa != null ? this.sa : this.ot != null ? this.ot : this.pa;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.cs) ? this.cs : this.dd;
                    this.mj = this.mm(this.mn, this.mm(this.ml, this.mp));
                    this.sz = this.s2(this.s3, this.s2(this.s1, this.s5));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.cx) ? this.cx : this.di;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.cy) ? this.cy : this.dj;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.cz) ? this.cz : this.dk;
                    this.oh = this.ss != null ? this.ss : this.ox != null ? this.ox : this.pf;
                    this.og = this.sr != null ? this.sr : this.ow != null ? this.ow : this.pe;
                    this.of = this.sc != null ? this.sc : this.ov != null ? this.ov : this.pd;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.c0) ? this.c0 : this.dl;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cw) ? this.cw : this.dh;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.cv) ? this.cv : this.dg;
                    this.oe = this.sb != null ? this.sb : this.ou != null ? this.ou : this.pc;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.ct) ? this.ct : this.de;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.cu) ? this.cu : this.df;
                    break;
                case 2:
                    this.oc = this.oj != null ? this.oj : this.ol != null ? this.ol : this.o1;
                    this.ob = this.oi != null ? this.oi : this.ok != null ? this.ok : this.o0;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.cg) ? this.cg : this.c1;
                    this.od = this.sa != null ? this.sa : this.om != null ? this.om : this.o2;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.ch) ? this.ch : this.c2;
                    this.mj = this.mm(this.mn, this.mm(this.mk, this.mo));
                    this.sz = this.s2(this.s3, this.s2(this.s0, this.s4));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.cm) ? this.cm : this.c7;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.cn) ? this.cn : this.c8;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.co) ? this.co : this.c9;
                    this.oh = this.ss != null ? this.ss : this.oq != null ? this.oq : this.o7;
                    this.og = this.sr != null ? this.sr : this.op != null ? this.op : this.o6;
                    this.of = this.sc != null ? this.sc : this.oo != null ? this.oo : this.o5;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.cp) ? this.cp : this.da;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cl) ? this.cl : this.c6;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.ck) ? this.ck : this.c5;
                    this.oe = this.sb != null ? this.sb : this.on != null ? this.on : this.o4;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.ci) ? this.ci : this.c3;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.cj) ? this.cj : this.c4;
                    break;
                case 3:
                    this.oc = this.oj != null ? this.oj : this.sl != null ? this.sl : this.r1;
                    this.ob = this.oi != null ? this.oi : this.sk != null ? this.sk : this.r0;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.hn) ? this.hn : this.gu;
                    this.od = this.sa != null ? this.sa : this.sm != null ? this.sm : this.r2;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.ho) ? this.ho : this.gv;
                    this.mj = this.mm(this.mn, this.mm(this.m4, this.m2));
                    this.sz = this.s2(this.s3, this.s2(this.tk, this.ti));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.ht) ? this.ht : this.g0;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.hu) ? this.hu : this.g1;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.hv) ? this.hv : this.g2;
                    this.oh = this.ss != null ? this.ss : this.sq != null ? this.sq : this.r7;
                    this.og = this.sr != null ? this.sr : this.sp != null ? this.sp : this.r6;
                    this.of = this.sc != null ? this.sc : this.so != null ? this.so : this.r5;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.hw) ? this.hw : this.g3;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hs) ? this.hs : this.gz;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.hr) ? this.hr : this.gy;
                    this.oe = this.sb != null ? this.sb : this.sn != null ? this.sn : this.r4;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.hp) ? this.hp : this.gw;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.hq) ? this.hq : this.gx;
                    break;
            }
        }
        l8() {
            this.lt((a) => {
            });
            this.ls((a) => {
            });
            let a = this.view.u;
            let b = this.view.t;
            let c = this.view.w;
            let d = this.view.x;
            let e = this.o != null && this.o.playState == 1;
            let f = this.p != null && this.p.playState == 1;
            let g = this.n != null && this.n.playState == 1;
            NativeUI.l(a, this.mj);
            NativeUI.l(b, this.mj);
            NativeUI.j(a, this.ob);
            NativeUI.u(a, this.sz);
            if (this.af) {
                if (!g) {
                    NativeUI.k(b, this.od);
                    NativeUI.m(b, new Thickness(0, this.b7));
                }
                if (!f) {
                    NativeUI.j(c, this.oe);
                }
            }
            else {
                if (!f) {
                    if (this.ag) {
                        NativeUI.j(c, this.of);
                        NativeUI.t(c, this.ca);
                        NativeUI.q(c, this.cb);
                    }
                    else {
                        NativeUI.j(c, this.og);
                        NativeUI.t(c, this.cc);
                        NativeUI.q(c, this.cf);
                    }
                }
                if (!g) {
                    NativeUI.k(b, this.oc);
                    NativeUI.m(b, new Thickness(0, this.b6));
                }
                if (!f) {
                    NativeUI.j(a, this.ob);
                }
            }
            if (!e) {
                NativeUI.j(d, this.oh);
                NativeUI.q(d, this.ce);
                NativeUI.t(d, this.cd);
            }
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        onChildrenMutated() {
            this.ls((a) => a.view.ac());
            this.lt((a) => a.view.ab());
            this.lu((a) => a.view.q());
        }
        lr() {
            this.view.ab();
            let a = false;
            if (this.p == null) {
                this.p = KeyFrameAnimationFactory.f.c(this.view.c(this.a).m(new AnimationKeyFrameProperty(2, this.oc)).m(new AnimationKeyFrameProperty(2, this.od)));
            }
            if (this.n == null) {
                this.n = KeyFrameAnimationFactory.f.c(this.view.a(this.a).m(new AnimationKeyFrameProperty(3, this.oc), new AnimationKeyFrameProperty(4, this.j == 2 || this.j == 3 ? new Thickness(0, this.b6) : new Thickness(0, 0))).m(new AnimationKeyFrameProperty(3, this.od), new AnimationKeyFrameProperty(4, this.j == 2 || this.j == 3 ? new Thickness(0, this.b7) : new Thickness(0, 0))));
            }
            if (this.o == null) {
                this.o = KeyFrameAnimationFactory.f.c(this.view.b(this.a).m(new AnimationKeyFrameProperty(2, this.od), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.5;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(2, this.od), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 1)));
            }
        }
        get ac() {
            let a = false;
            this.ls((b) => {
                if (b.ab) {
                    a = true;
                }
            });
            return a;
        }
        lz(a) {
            this.ab = this.s ? this.ae : this.ac ? true : false;
            this.af = false;
        }
        l7(a) {
            this.db = ThemeResolver.b(a, InputGroup.fq, InputGroup.dx);
            this.e1 = ThemeResolver.b(a, InputGroup.f1, InputGroup.d8);
            this.mq = ThemeResolver.d(a, InputGroup.mz, InputGroup.mt);
            this.s6 = ThemeResolver.f(a, InputGroup.tf, InputGroup.s9);
            this.oz = ThemeResolver.e(a, InputGroup.qx, InputGroup.ph);
            this.qk = ThemeResolver.e(a, InputGroup.re, InputGroup.py);
            this.ql = ThemeResolver.e(a, InputGroup.rf, InputGroup.pz);
            this.g7 = ThemeResolver.b(a, InputGroup.gt, InputGroup.e0);
            this.g6 = ThemeResolver.b(a, InputGroup.gs, InputGroup.ez);
            this.e5 = ThemeResolver.b(a, InputGroup.f5, InputGroup.ec);
            this.r8 = ThemeResolver.e(a, InputGroup.ry, InputGroup.qi);
            this.r9 = ThemeResolver.e(a, InputGroup.rz, InputGroup.qj);
            this.qn = ThemeResolver.e(a, InputGroup.rh, InputGroup.p1);
            this.qm = ThemeResolver.e(a, InputGroup.rg, InputGroup.p0);
            this.g4 = ThemeResolver.b(a, InputGroup.gq, InputGroup.ex);
            this.e4 = ThemeResolver.b(a, InputGroup.f4, InputGroup.eb);
            this.e2 = ThemeResolver.b(a, InputGroup.f2, InputGroup.d9);
            this.e3 = ThemeResolver.b(a, InputGroup.f3, InputGroup.ea);
            this.g5 = ThemeResolver.b(a, InputGroup.gr, InputGroup.ey);
            this.oy = ThemeResolver.e(a, InputGroup.qw, InputGroup.pg);
            this.e6 = ThemeResolver.b(a, InputGroup.f6, InputGroup.ed);
            this.e7 = ThemeResolver.b(a, InputGroup.f7, InputGroup.ee);
            this.mw = ThemeResolver.d(a, InputGroup.m0, InputGroup.mu);
            this.tc = ThemeResolver.f(a, InputGroup.tg, InputGroup.ta);
            this.qp = ThemeResolver.e(a, InputGroup.rj, InputGroup.p3);
            this.qq = ThemeResolver.e(a, InputGroup.rk, InputGroup.p4);
            this.qr = ThemeResolver.e(a, InputGroup.rl, InputGroup.p5);
            this.ff = ThemeResolver.b(a, InputGroup.gf, InputGroup.em);
            this.fe = ThemeResolver.b(a, InputGroup.ge, InputGroup.el);
            this.fb = ThemeResolver.b(a, InputGroup.gb, InputGroup.ei);
            this.qu = ThemeResolver.e(a, InputGroup.ro, InputGroup.p8);
            this.qv = ThemeResolver.e(a, InputGroup.rp, InputGroup.p9);
            this.qt = ThemeResolver.e(a, InputGroup.rn, InputGroup.p7);
            this.qs = ThemeResolver.e(a, InputGroup.rm, InputGroup.p6);
            this.fc = ThemeResolver.b(a, InputGroup.gc, InputGroup.ej);
            this.fa = ThemeResolver.b(a, InputGroup.ga, InputGroup.eh);
            this.e8 = ThemeResolver.b(a, InputGroup.f8, InputGroup.ef);
            this.e9 = ThemeResolver.b(a, InputGroup.f9, InputGroup.eg);
            this.fd = ThemeResolver.b(a, InputGroup.gd, InputGroup.ek);
            this.qo = ThemeResolver.e(a, InputGroup.ri, InputGroup.p2);
            this.dc = ThemeResolver.b(a, InputGroup.fr, InputGroup.dy);
            this.dd = ThemeResolver.b(a, InputGroup.fs, InputGroup.dz);
            this.mp = ThemeResolver.d(a, InputGroup.my, InputGroup.ms);
            this.s5 = ThemeResolver.f(a, InputGroup.te, InputGroup.s8);
            this.o9 = ThemeResolver.e(a, InputGroup.q7, InputGroup.pr);
            this.pa = ThemeResolver.e(a, InputGroup.q8, InputGroup.ps);
            this.pb = ThemeResolver.e(a, InputGroup.q9, InputGroup.pt);
            this.dl = ThemeResolver.b(a, InputGroup.f0, InputGroup.d7);
            this.dk = ThemeResolver.b(a, InputGroup.fz, InputGroup.d6);
            this.dh = ThemeResolver.b(a, InputGroup.fw, InputGroup.d3);
            this.pe = ThemeResolver.e(a, InputGroup.rc, InputGroup.pw);
            this.pf = ThemeResolver.e(a, InputGroup.rd, InputGroup.px);
            this.pd = ThemeResolver.e(a, InputGroup.rb, InputGroup.pv);
            this.pc = ThemeResolver.e(a, InputGroup.ra, InputGroup.pu);
            this.di = ThemeResolver.b(a, InputGroup.fx, InputGroup.d4);
            this.dg = ThemeResolver.b(a, InputGroup.fv, InputGroup.d2);
            this.de = ThemeResolver.b(a, InputGroup.ft, InputGroup.d0);
            this.df = ThemeResolver.b(a, InputGroup.fu, InputGroup.d1);
            this.dj = ThemeResolver.b(a, InputGroup.fy, InputGroup.d5);
            this.o8 = ThemeResolver.e(a, InputGroup.q6, InputGroup.pq);
            this.c1 = ThemeResolver.b(a, InputGroup.fg, InputGroup.dm);
            this.c2 = ThemeResolver.b(a, InputGroup.fh, InputGroup.dn);
            this.mo = ThemeResolver.d(a, InputGroup.mx, InputGroup.mr);
            this.s4 = ThemeResolver.f(a, InputGroup.td, InputGroup.s7);
            this.o1 = ThemeResolver.e(a, InputGroup.qz, InputGroup.pj);
            this.o2 = ThemeResolver.e(a, InputGroup.q0, InputGroup.pk);
            this.o3 = ThemeResolver.e(a, InputGroup.q1, InputGroup.pl);
            this.da = ThemeResolver.b(a, InputGroup.fp, InputGroup.dw);
            this.c9 = ThemeResolver.b(a, InputGroup.fo, InputGroup.dv);
            this.c6 = ThemeResolver.b(a, InputGroup.fl, InputGroup.ds);
            this.o6 = ThemeResolver.e(a, InputGroup.q4, InputGroup.po);
            this.o7 = ThemeResolver.e(a, InputGroup.q5, InputGroup.pp);
            this.o5 = ThemeResolver.e(a, InputGroup.q3, InputGroup.pn);
            this.o4 = ThemeResolver.e(a, InputGroup.q2, InputGroup.pm);
            this.c7 = ThemeResolver.b(a, InputGroup.fm, InputGroup.dt);
            this.c5 = ThemeResolver.b(a, InputGroup.fk, InputGroup.dr);
            this.c3 = ThemeResolver.b(a, InputGroup.fi, InputGroup.dp);
            this.c4 = ThemeResolver.b(a, InputGroup.fj, InputGroup.dq);
            this.c8 = ThemeResolver.b(a, InputGroup.fn, InputGroup.du);
            this.o0 = ThemeResolver.e(a, InputGroup.qy, InputGroup.pi);
            this.gu = ThemeResolver.b(a, InputGroup.gg, InputGroup.en);
            this.gv = ThemeResolver.b(a, InputGroup.gh, InputGroup.eo);
            this.m2 = ThemeResolver.d(a, InputGroup.m1, InputGroup.mv);
            this.ti = ThemeResolver.f(a, InputGroup.th, InputGroup.tb);
            this.r1 = ThemeResolver.e(a, InputGroup.rr, InputGroup.qb);
            this.r2 = ThemeResolver.e(a, InputGroup.rs, InputGroup.qc);
            this.r3 = ThemeResolver.e(a, InputGroup.rt, InputGroup.qd);
            this.g3 = ThemeResolver.b(a, InputGroup.gp, InputGroup.ew);
            this.g2 = ThemeResolver.b(a, InputGroup.go, InputGroup.ev);
            this.gz = ThemeResolver.b(a, InputGroup.gl, InputGroup.es);
            this.r6 = ThemeResolver.e(a, InputGroup.rw, InputGroup.qg);
            this.r7 = ThemeResolver.e(a, InputGroup.rx, InputGroup.qh);
            this.r5 = ThemeResolver.e(a, InputGroup.rv, InputGroup.qf);
            this.r4 = ThemeResolver.e(a, InputGroup.ru, InputGroup.qe);
            this.g0 = ThemeResolver.b(a, InputGroup.gm, InputGroup.et);
            this.gy = ThemeResolver.b(a, InputGroup.gk, InputGroup.er);
            this.gw = ThemeResolver.b(a, InputGroup.gi, InputGroup.ep);
            this.gx = ThemeResolver.b(a, InputGroup.gj, InputGroup.eq);
            this.g1 = ThemeResolver.b(a, InputGroup.gn, InputGroup.eu);
            this.r0 = ThemeResolver.e(a, InputGroup.rq, InputGroup.qa);
        }
        lv() {
            this.lr();
            if (this.ab) {
                this.lt((a) => a.am = true);
            }
            else {
                this.lt((a) => a.am = false);
            }
        }
        l1() {
            this.lr();
            if (this.af) {
                let a = 1;
                this.lt((b) => b.ak = true);
                this.l4(a);
            }
            else {
                let b = -1;
                this.lt((c) => c.ak = false);
                this.l4(b);
            }
        }
        l0(a) {
            this.ab = this.s ? this.ae : true;
            this.af = true;
        }
        l4(a) {
            if ((a > 0 && this.p.playbackRate < 0) || (a < 0 && this.p.playbackRate > 0)) {
                this.p.reverse();
                this.p.finished.f((b) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                    if (this.aa) {
                        this.p = null;
                        this.aa = false;
                    }
                });
                this.n.reverse();
                this.n.finished.f((b) => {
                    if (this.n != null) {
                        this.n.commitStyles();
                    }
                    if (this.r) {
                        this.n = null;
                        this.r = false;
                    }
                });
                this.o.reverse();
                this.o.finished.f((b) => {
                    if (this.o != null) {
                        this.o.commitStyles();
                    }
                    if (this.z) {
                        this.o = null;
                        this.z = false;
                    }
                });
            }
            else {
                this.p.play();
                this.p.finished.f((b) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                    if (this.aa) {
                        this.p = null;
                        this.aa = false;
                    }
                });
                this.n.play();
                this.n.finished.f((b) => {
                    if (this.n != null) {
                        this.n.commitStyles();
                    }
                    if (this.r) {
                        this.n = null;
                        this.r = false;
                    }
                });
                this.o.play();
                this.o.finished.f((b) => {
                    if (this.o != null) {
                        this.o.commitStyles();
                    }
                    if (this.z) {
                        this.o = null;
                        this.z = false;
                    }
                });
            }
        }
        get oc() {
            return this.m6;
        }
        set oc(a) {
            let b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.l2("ActualBorderColor", b, a);
            }
        }
        get od() {
            return this.m7;
        }
        set od(a) {
            let b = this.m7;
            this.m7 = a;
            if (b != this.m7) {
                this.l2("ActualFocusBorderColor", b, a);
            }
        }
        get b6() {
            return this.ai;
        }
        set b6(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.l2("ActualBorderWidth", b, a);
            }
        }
        get b7() {
            return this.aj;
        }
        set b7(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.l2("ActualFocusBorderWidth", b, a);
            }
        }
        get mj() {
            return this.md;
        }
        set mj(a) {
            let b = this.md;
            this.md = a;
            if (b != this.md) {
                this.l2("ActualCornerRadius", b, a);
            }
        }
        get sz() {
            return this.st;
        }
        set sz(a) {
            let b = this.st;
            this.st = a;
            if (b != this.st) {
                this.l2("ActualContentPadding", b, a);
            }
        }
        get cf() {
            return this.ar;
        }
        set cf(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.l2("ActualUnderlineWidth", b, a);
            }
        }
        get ce() {
            return this.aq;
        }
        set ce(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.l2("ActualUnderlineRippleWidth", b, a);
            }
        }
        get cb() {
            return this.an;
        }
        set cb(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.l2("ActualHoverUnderlineWidth", b, a);
            }
        }
        get og() {
            return this.na;
        }
        set og(a) {
            let b = this.na;
            this.na = a;
            if (b != this.na) {
                this.l2("ActualUnderlineColor", b, a);
            }
        }
        get oh() {
            return this.nb;
        }
        set oh(a) {
            let b = this.nb;
            this.nb = a;
            if (b != this.nb) {
                this.l2("ActualUnderlineRippleColor", b, a);
            }
        }
        get of() {
            return this.m9;
        }
        set of(a) {
            let b = this.m9;
            this.m9 = a;
            if (b != this.m9) {
                this.l2("ActualHoverUnderlineColor", b, a);
            }
        }
        get oe() {
            return this.m8;
        }
        set oe(a) {
            let b = this.m8;
            this.nt = a;
            if (b != this.m8) {
                this.l2("ActualFocusUnderlineColor", b, a);
            }
        }
        get cc() {
            return this.ao;
        }
        set cc(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.l2("ActualUnderlineOpacity", b, a);
            }
        }
        get ca() {
            return this.am;
        }
        set ca(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.l2("ActualHoverUnderlineOpacity", b, a);
            }
        }
        get b8() {
            return this.ak;
        }
        set b8(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.l2("ActualFocusUnderlineOpacity", b, a);
            }
        }
        get b9() {
            return this.al;
        }
        set b9(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.l2("ActualFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cd() {
            return this.ap;
        }
        set cd(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.l2("ActualUnderlineRippleOpacity", b, a);
            }
        }
        get ob() {
            return this.m5;
        }
        set ob(a) {
            let b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.l2("ActualBackgroundColor", b, a);
            }
        }
        get cq() {
            return this.a2;
        }
        set cq(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.l2("BorderWidth", b, a);
            }
        }
        get g8() {
            return this.bd;
        }
        set g8(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.l2("FocusBorderWidth", b, a);
            }
        }
        get oj() {
            return this.nd;
        }
        set oj(a) {
            let b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.l2("BorderColor", b, a);
            }
        }
        get mn() {
            return this.mg;
        }
        set mn(a) {
            let b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.l2("CornerRadius", b, a);
            }
        }
        get s3() {
            return this.sw;
        }
        set s3(a) {
            let b = this.sw;
            this.sw = a;
            if (b != this.sw) {
                this.l2("ContentPadding", b, a);
            }
        }
        get h0() {
            return this.b5;
        }
        set h0(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.l2("UnderlineWidth", b, a);
            }
        }
        get hz() {
            return this.b4;
        }
        set hz(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.l2("UnderlineRippleWidth", b, a);
            }
        }
        get hc() {
            return this.bh;
        }
        set hc(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.l2("HoverUnderlineWidth", b, a);
            }
        }
        get sr() {
            return this.n9;
        }
        set sr(a) {
            let b = this.n9;
            this.n9 = a;
            if (b != this.n9) {
                this.l2("UnderlineColor", b, a);
            }
        }
        get ss() {
            return this.oa;
        }
        set ss(a) {
            let b = this.oa;
            this.oa = a;
            if (b != this.oa) {
                this.l2("UnderlineRippleColor", b, a);
            }
        }
        get sc() {
            return this.nu;
        }
        set sc(a) {
            let b = this.nu;
            this.nu = a;
            if (b != this.nu) {
                this.l2("HoverUnderlineColor", b, a);
            }
        }
        get sb() {
            return this.nt;
        }
        set sb(a) {
            let b = this.nt;
            this.nt = a;
            if (b != this.nt) {
                this.l2("FocusUnderlineColor", b, a);
            }
        }
        get hx() {
            return this.b2;
        }
        set hx(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.l2("UnderlineOpacity", b, a);
            }
        }
        get hb() {
            return this.bg;
        }
        set hb(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.l2("HoverUnderlineOpacity", b, a);
            }
        }
        get g9() {
            return this.be;
        }
        set g9(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.l2("FocusUnderlineOpacity", b, a);
            }
        }
        get ha() {
            return this.bf;
        }
        set ha(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.l2("FocusUnderlineRippleOpacity", b, a);
            }
        }
        get hy() {
            return this.b3;
        }
        set hy(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.l2("UnderlineRippleOpacity", b, a);
            }
        }
        get oi() {
            return this.nc;
        }
        set oi(a) {
            let b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.l2("BackgroundColor", b, a);
            }
        }
        get hd() {
            return this.bi;
        }
        set hd(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.l2("LineTypeBorderWidth", b, a);
            }
        }
        get he() {
            return this.bj;
        }
        set he(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.l2("LineTypeFocusBorderWidth", b, a);
            }
        }
        get sf() {
            return this.nx;
        }
        set sf(a) {
            let b = this.nx;
            this.nx = a;
            if (b != this.nx) {
                this.l2("LineTypeFocusBorderColor", b, a);
            }
        }
        get se() {
            return this.nw;
        }
        set se(a) {
            let b = this.nw;
            this.nw = a;
            if (b != this.nw) {
                this.l2("LineTypeBorderColor", b, a);
            }
        }
        get m3() {
            return this.mh;
        }
        set m3(a) {
            let b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.l2("LineTypeCornerRadius", b, a);
            }
        }
        get tj() {
            return this.sx;
        }
        set tj(a) {
            let b = this.sx;
            this.sx = a;
            if (b != this.sx) {
                this.l2("LineTypeContentPadding", b, a);
            }
        }
        get hm() {
            return this.br;
        }
        set hm(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.l2("LineTypeUnderlineWidth", b, a);
            }
        }
        get hl() {
            return this.bq;
        }
        set hl(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.l2("LineTypeUnderlineRippleWidth", b, a);
            }
        }
        get hi() {
            return this.bn;
        }
        set hi(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.l2("LineTypeHoverUnderlineWidth", b, a);
            }
        }
        get si() {
            return this.n0;
        }
        set si(a) {
            let b = this.n0;
            this.n0 = a;
            if (b != this.n0) {
                this.l2("LineTypeUnderlineColor", b, a);
            }
        }
        get sj() {
            return this.n1;
        }
        set sj(a) {
            let b = this.n1;
            this.n1 = a;
            if (b != this.n1) {
                this.l2("LineTypeUnderlineRippleColor", b, a);
            }
        }
        get sh() {
            return this.nz;
        }
        set sh(a) {
            let b = this.nz;
            this.nu = a;
            if (b != this.nz) {
                this.l2("LineTypeHoverUnderlineColor", b, a);
            }
        }
        get sg() {
            return this.ny;
        }
        set sg(a) {
            let b = this.ny;
            this.ny = a;
            if (b != this.ny) {
                this.l2("LineTypeFocusUnderlineColor", b, a);
            }
        }
        get hj() {
            return this.bo;
        }
        set hj(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.l2("LineTypeUnderlineOpacity", b, a);
            }
        }
        get hh() {
            return this.bm;
        }
        set hh(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.l2("LineTypeHoverUnderlineOpacity", b, a);
            }
        }
        get hf() {
            return this.bk;
        }
        set hf(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.l2("LineTypeFocusUnderlineOpacity", b, a);
            }
        }
        get hg() {
            return this.bl;
        }
        set hg(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.l2("LineTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get hk() {
            return this.bp;
        }
        set hk(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.l2("LineTypeUnderlineRippleOpacity", b, a);
            }
        }
        get sd() {
            return this.nv;
        }
        set sd(a) {
            let b = this.nv;
            this.nv = a;
            if (b != this.nv) {
                this.l2("LineTypeBackgroundColor", b, a);
            }
        }
        get cr() {
            return this.a3;
        }
        set cr(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.l2("BoxTypeBorderWidth", b, a);
            }
        }
        get cs() {
            return this.a4;
        }
        set cs(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.l2("BoxTypeFocusBorderWidth", b, a);
            }
        }
        get ot() {
            return this.nn;
        }
        set ot(a) {
            let b = this.nn;
            this.nn = a;
            if (b != this.nn) {
                this.l2("BoxTypeFocusBorderColor", b, a);
            }
        }
        get os() {
            return this.nm;
        }
        set os(a) {
            let b = this.nm;
            this.nm = a;
            if (b != this.nm) {
                this.l2("BoxTypeBorderColor", b, a);
            }
        }
        get ml() {
            return this.mf;
        }
        set ml(a) {
            let b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.l2("BoxTypeCornerRadius", b, a);
            }
        }
        get s1() {
            return this.sv;
        }
        set s1(a) {
            let b = this.sv;
            this.sv = a;
            if (b != this.sv) {
                this.l2("BoxTypeContentPadding", b, a);
            }
        }
        get c0() {
            return this.bc;
        }
        set c0(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.l2("BoxTypeUnderlineWidth", b, a);
            }
        }
        get cz() {
            return this.bb;
        }
        set cz(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.l2("BoxTypeUnderlineRippleWidth", b, a);
            }
        }
        get cw() {
            return this.a8;
        }
        set cw(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.l2("BoxTypeHoverUnderlineWidth", b, a);
            }
        }
        get ow() {
            return this.nq;
        }
        set ow(a) {
            let b = this.nq;
            this.nq = a;
            if (b != this.nq) {
                this.l2("BoxTypeUnderlineColor", b, a);
            }
        }
        get ox() {
            return this.nr;
        }
        set ox(a) {
            let b = this.nr;
            this.nr = a;
            if (b != this.nr) {
                this.l2("BoxTypeUnderlineRippleColor", b, a);
            }
        }
        get ov() {
            return this.np;
        }
        set ov(a) {
            let b = this.np;
            this.nu = a;
            if (b != this.np) {
                this.l2("BoxTypeHoverUnderlineColor", b, a);
            }
        }
        get ou() {
            return this.no;
        }
        set ou(a) {
            let b = this.no;
            this.no = a;
            if (b != this.no) {
                this.l2("BoxTypeFocusUnderlineColor", b, a);
            }
        }
        get cx() {
            return this.a9;
        }
        set cx(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.l2("BoxTypeUnderlineOpacity", b, a);
            }
        }
        get cv() {
            return this.a7;
        }
        set cv(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.l2("BoxTypeHoverUnderlineOpacity", b, a);
            }
        }
        get ct() {
            return this.a5;
        }
        set ct(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.l2("BoxTypeFocusUnderlineOpacity", b, a);
            }
        }
        get cu() {
            return this.a6;
        }
        set cu(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.l2("BoxTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cy() {
            return this.ba;
        }
        set cy(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.l2("BoxTypeUnderlineRippleOpacity", b, a);
            }
        }
        get or() {
            return this.nl;
        }
        set or(a) {
            let b = this.nl;
            this.nl = a;
            if (b != this.nl) {
                this.l2("BoxTypeBackgroundColor", b, a);
            }
        }
        get cg() {
            return this.as;
        }
        set cg(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.l2("BorderTypeBorderWidth", b, a);
            }
        }
        get ch() {
            return this.at;
        }
        set ch(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.l2("BorderTypeFocusBorderWidth", b, a);
            }
        }
        get om() {
            return this.ng;
        }
        set om(a) {
            let b = this.ng;
            this.ng = a;
            if (b != this.ng) {
                this.l2("BorderTypeFocusBorderColor", b, a);
            }
        }
        get ol() {
            return this.nf;
        }
        set ol(a) {
            let b = this.nf;
            this.nf = a;
            if (b != this.nf) {
                this.l2("BorderTypeBorderColor", b, a);
            }
        }
        get mk() {
            return this.me;
        }
        set mk(a) {
            let b = this.me;
            this.me = a;
            if (b != this.me) {
                this.l2("BorderTypeCornerRadius", b, a);
            }
        }
        get s0() {
            return this.su;
        }
        set s0(a) {
            let b = this.su;
            this.su = a;
            if (b != this.su) {
                this.l2("BorderTypeContentPadding", b, a);
            }
        }
        get cp() {
            return this.a1;
        }
        set cp(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.l2("BorderTypeUnderlineWidth", b, a);
            }
        }
        get co() {
            return this.a0;
        }
        set co(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.l2("BorderTypeUnderlineRippleWidth", b, a);
            }
        }
        get cl() {
            return this.ax;
        }
        set cl(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.l2("BorderTypeHoverUnderlineWidth", b, a);
            }
        }
        get op() {
            return this.nj;
        }
        set op(a) {
            let b = this.nj;
            this.nj = a;
            if (b != this.nj) {
                this.l2("BorderTypeUnderlineColor", b, a);
            }
        }
        get oq() {
            return this.nk;
        }
        set oq(a) {
            let b = this.nk;
            this.nk = a;
            if (b != this.nk) {
                this.l2("BorderTypeUnderlineRippleColor", b, a);
            }
        }
        get oo() {
            return this.ni;
        }
        set oo(a) {
            let b = this.ni;
            this.nu = a;
            if (b != this.ni) {
                this.l2("BorderTypeHoverUnderlineColor", b, a);
            }
        }
        get on() {
            return this.nh;
        }
        set on(a) {
            let b = this.nh;
            this.nh = a;
            if (b != this.nh) {
                this.l2("BorderTypeFocusUnderlineColor", b, a);
            }
        }
        get cm() {
            return this.ay;
        }
        set cm(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.l2("BorderTypeUnderlineOpacity", b, a);
            }
        }
        get ck() {
            return this.aw;
        }
        set ck(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.l2("BorderTypeHoverUnderlineOpacity", b, a);
            }
        }
        get ci() {
            return this.au;
        }
        set ci(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.l2("BorderTypeFocusUnderlineOpacity", b, a);
            }
        }
        get cj() {
            return this.av;
        }
        set cj(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.l2("BorderTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cn() {
            return this.az;
        }
        set cn(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.l2("BorderTypeUnderlineRippleOpacity", b, a);
            }
        }
        get ok() {
            return this.ne;
        }
        set ok(a) {
            let b = this.ne;
            this.ne = a;
            if (b != this.ne) {
                this.l2("BorderTypeBackgroundColor", b, a);
            }
        }
        get hn() {
            return this.bs;
        }
        set hn(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.l2("SearchTypeBorderWidth", b, a);
            }
        }
        get ho() {
            return this.bt;
        }
        set ho(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.l2("SearchTypeFocusBorderWidth", b, a);
            }
        }
        get sm() {
            return this.n4;
        }
        set sm(a) {
            let b = this.n4;
            this.n4 = a;
            if (b != this.n4) {
                this.l2("SearchTypeFocusBorderColor", b, a);
            }
        }
        get sl() {
            return this.n3;
        }
        set sl(a) {
            let b = this.n3;
            this.n3 = a;
            if (b != this.n3) {
                this.l2("SearchTypeBorderColor", b, a);
            }
        }
        get m4() {
            return this.mi;
        }
        set m4(a) {
            let b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.l2("SearchTypeCornerRadius", b, a);
            }
        }
        get tk() {
            return this.sy;
        }
        set tk(a) {
            let b = this.sy;
            this.sy = a;
            if (b != this.sy) {
                this.l2("SearchTypeContentPadding", b, a);
            }
        }
        get hw() {
            return this.b1;
        }
        set hw(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.l2("SearchTypeUnderlineWidth", b, a);
            }
        }
        get hv() {
            return this.b0;
        }
        set hv(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.l2("SearchTypeUnderlineRippleWidth", b, a);
            }
        }
        get hs() {
            return this.bx;
        }
        set hs(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.l2("SearchTypeHoverUnderlineWidth", b, a);
            }
        }
        get sp() {
            return this.n7;
        }
        set sp(a) {
            let b = this.n7;
            this.n7 = a;
            if (b != this.n7) {
                this.l2("SearchTypeUnderlineColor", b, a);
            }
        }
        get sq() {
            return this.n8;
        }
        set sq(a) {
            let b = this.n8;
            this.n8 = a;
            if (b != this.n8) {
                this.l2("SearchTypeUnderlineRippleColor", b, a);
            }
        }
        get so() {
            return this.n6;
        }
        set so(a) {
            let b = this.n6;
            this.nu = a;
            if (b != this.n6) {
                this.l2("SearchTypeHoverUnderlineColor", b, a);
            }
        }
        get sn() {
            return this.n5;
        }
        set sn(a) {
            let b = this.n5;
            this.n5 = a;
            if (b != this.n5) {
                this.l2("SearchTypeFocusUnderlineColor", b, a);
            }
        }
        get ht() {
            return this.by;
        }
        set ht(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.l2("SearchTypeUnderlineOpacity", b, a);
            }
        }
        get hr() {
            return this.bw;
        }
        set hr(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.l2("SearchTypeHoverUnderlineOpacity", b, a);
            }
        }
        get hp() {
            return this.bu;
        }
        set hp(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.l2("SearchTypeFocusUnderlineOpacity", b, a);
            }
        }
        get hq() {
            return this.bv;
        }
        set hq(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.l2("SearchTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get hu() {
            return this.bz;
        }
        set hu(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.l2("SearchTypeUnderlineRippleOpacity", b, a);
            }
        }
        get sk() {
            return this.n2;
        }
        set sk(a) {
            let b = this.n2;
            this.n2 = a;
            if (b != this.n2) {
                this.l2("SearchTypeBackgroundColor", b, a);
            }
        }
        get ae() {
            return this.w;
        }
        set ae(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.l2("IsExpanded", b, a);
            }
        }
        get ag() {
            return this.y;
        }
        set ag(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.l2("IsHovered", b, a);
            }
        }
        get af() {
            return this.x;
        }
        set af(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.l2("IsFocused", b, a);
            }
        }
        get ab() {
            return this.q;
        }
        set ab(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.l2("ActualIsExpanded", b, a);
            }
        }
        get sa() {
            return this.ns;
        }
        set sa(a) {
            let b = this.ns;
            this.ns = a;
            if (b != this.ns) {
                this.l2("FocusBorderColor", b, a);
            }
        }
        get j7() {
            return this.h2;
        }
        set j7(a) {
            let b = this.h2;
            this.h2 = a;
            if (b != this.h2) {
                this.l2("Id", b, a);
            }
        }
        get disabled() {
            return this.v;
        }
        set disabled(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.l2("IsDisabled", b, a);
            }
        }
        l3() {
        }
        onDetachedFromUI() {
            this.view.ae();
        }
        onAttachedToUI() {
            this.view.ac();
        }
        ah() {
            return this.view.g();
        }
        provideContainer(a) {
            this.view.ad(a);
        }
        get inputs() {
            return this.k;
        }
    }
    InputGroup.$t = /*@__PURE__*/ markType(InputGroup, 'InputGroup', Base.$, [INotifyPropertyChanged_$type]);
    InputGroup.c = 2;
    InputGroup.fq = 0;
    InputGroup.f1 = 0;
    InputGroup.mz = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tf = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.qx = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.re = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rf = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gt = 1;
    InputGroup.gs = 2;
    InputGroup.f5 = 2;
    InputGroup.ry = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rz = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rh = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rg = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gq = 1;
    InputGroup.f4 = 1;
    InputGroup.f2 = 1;
    InputGroup.f3 = 1;
    InputGroup.gr = 0;
    InputGroup.qw = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.f6 = 0;
    InputGroup.f7 = 0;
    InputGroup.m0 = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tg = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.rj = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rk = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rl = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gf = 1;
    InputGroup.ge = 2;
    InputGroup.gb = 2;
    InputGroup.ro = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rp = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rn = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rm = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gc = 1;
    InputGroup.ga = 1;
    InputGroup.f8 = 1;
    InputGroup.f9 = 1;
    InputGroup.gd = 0;
    InputGroup.ri = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.fr = 0;
    InputGroup.fs = 0;
    InputGroup.my = /*@__PURE__*/ new CornerRadius(1, 4, 4, 0, 0);
    InputGroup.te = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.q7 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.q8 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.q9 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.f0 = 1;
    InputGroup.fz = 2;
    InputGroup.fw = 2;
    InputGroup.rc = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rd = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rb = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.ra = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.fx = 1;
    InputGroup.fv = 1;
    InputGroup.ft = 1;
    InputGroup.fu = 1;
    InputGroup.fy = 0;
    InputGroup.q6 = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    InputGroup.fg = 1;
    InputGroup.fh = 2;
    InputGroup.mx = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.td = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.qz = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.q0 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.q1 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.fp = 1;
    InputGroup.fo = 2;
    InputGroup.fl = 2;
    InputGroup.q4 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.q5 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.q3 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.q2 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.fm = 0;
    InputGroup.fk = 0;
    InputGroup.fi = 0;
    InputGroup.fj = 0;
    InputGroup.fn = 0;
    InputGroup.qy = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.gg = 1;
    InputGroup.gh = 2;
    InputGroup.m1 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.th = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.rr = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rs = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rt = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gp = 1;
    InputGroup.go = 2;
    InputGroup.gl = 2;
    InputGroup.rw = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rx = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rv = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.ru = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gm = 0;
    InputGroup.gk = 0;
    InputGroup.gi = 0;
    InputGroup.gj = 0;
    InputGroup.gn = 0;
    InputGroup.rq = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.dx = 0;
    InputGroup.d8 = 0;
    InputGroup.mt = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.s9 = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.ph = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.py = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.pz = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.e0 = 1;
    InputGroup.ez = 2;
    InputGroup.ec = 2;
    InputGroup.qi = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qj = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p1 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p0 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ex = 1;
    InputGroup.eb = 1;
    InputGroup.d9 = 1;
    InputGroup.ea = 1;
    InputGroup.ey = 0;
    InputGroup.pg = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.ed = 0;
    InputGroup.ee = 0;
    InputGroup.mu = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.ta = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.p3 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p4 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p5 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.em = 1;
    InputGroup.el = 2;
    InputGroup.ei = 2;
    InputGroup.p8 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p9 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p7 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p6 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ej = 1;
    InputGroup.eh = 1;
    InputGroup.ef = 1;
    InputGroup.eg = 1;
    InputGroup.ek = 0;
    InputGroup.p2 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.dy = 0;
    InputGroup.dz = 0;
    InputGroup.ms = /*@__PURE__*/ new CornerRadius(1, 4, 4, 0, 0);
    InputGroup.s8 = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.pr = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.ps = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.pt = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.d7 = 1;
    InputGroup.d6 = 2;
    InputGroup.d3 = 2;
    InputGroup.pw = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.px = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.pv = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pu = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.d4 = 1;
    InputGroup.d2 = 1;
    InputGroup.d0 = 1;
    InputGroup.d1 = 1;
    InputGroup.d5 = 0;
    InputGroup.pq = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    InputGroup.dm = 1;
    InputGroup.dn = 2;
    InputGroup.mr = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.s7 = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.pj = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pk = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.pl = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.dw = 1;
    InputGroup.dv = 2;
    InputGroup.ds = 2;
    InputGroup.po = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pp = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.pn = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pm = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.dt = 0;
    InputGroup.dr = 0;
    InputGroup.dp = 0;
    InputGroup.dq = 0;
    InputGroup.du = 0;
    InputGroup.pi = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.en = 1;
    InputGroup.eo = 2;
    InputGroup.mv = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.tb = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.qb = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qc = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.qd = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ew = 1;
    InputGroup.ev = 2;
    InputGroup.es = 2;
    InputGroup.qg = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qh = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.qf = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qe = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.et = 0;
    InputGroup.er = 0;
    InputGroup.ep = 0;
    InputGroup.eq = 0;
    InputGroup.eu = 0;
    InputGroup.qa = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.h1 = 0;
    return InputGroup;
})();
/**
 * @hidden
 */
export let InputGroupInputCollection = /*@__PURE__*/ (() => {
    class InputGroupInputCollection extends ObservableCollection$1 {
        constructor() {
            super(InputGroupItem.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    InputGroupInputCollection.$t = /*@__PURE__*/ markType(InputGroupInputCollection, 'InputGroupInputCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(InputGroupItem.$));
    return InputGroupInputCollection;
})();
/**
 * @hidden
 */
export let Label = /*@__PURE__*/ (() => {
    class Label extends InputGroupItem {
        constructor() {
            super();
            this.j = 0;
            this._view = null;
            this.z = null;
            this.y = null;
            this.n = 0;
            this.m = 1;
            this.cl = ThemeResolver.e(Label.k, Label.c4, Label.cx);
            this.ci = ThemeResolver.e(Label.k, Label.c1, Label.cu);
            this.cj = ThemeResolver.e(Label.k, Label.c2, Label.cv);
            this.ck = ThemeResolver.e(Label.k, Label.c3, Label.cw);
            this.t = null;
            this.cp = Label.c5;
            this.cm = Label.cy;
            this.cn = Label.cz;
            this.q = 0;
            this.ae = false;
            this.ac = false;
            this.u = null;
            this.a0 = "text";
            this.co = null;
            this.ay = "ig-label-" + Label.ar++;
            this.au = "inline-block";
            this.av = "inline-block";
            this.aw = null;
            this.as = "center";
            this.ap = 0;
            this.aa = false;
            this.ax = null;
            this.at = null;
            this.az = null;
            this.ad = false;
            this.ah = false;
            this.ab = false;
            this.ag = false;
            this.af = false;
            let a = new LabelView();
            a.b = this;
            this.view = a;
            this.view.y();
        }
        get l() {
            return this.j;
        }
        set l(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get i() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        b4() {
            this.view.q();
            let a = false;
            if (this.z == null) {
                let b = new TransformGroup();
                b.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.r == 0 ? (this.view.h() * 0.5) : 0;
                    return $ret;
                })()));
                b.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })()));
                let c = -(this.view.h() * 1.3);
                if (this.o == 2) {
                    c = -(this.view.h() * 1.05);
                }
                if (this.o == 3) {
                    c = -(this.view.h() * 1.01);
                }
                let d = new TransformGroup();
                d.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.r == 2 ? c : -(this.view.h() * 0.5);
                    return $ret;
                })()));
                d.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.75;
                    $ret.m = 0.75;
                    return $ret;
                })()));
                this.z = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(14, b), new AnimationKeyFrameProperty(2, BrushUtil.g(0, 255, 255, 255))).m(new AnimationKeyFrameProperty(14, d), new AnimationKeyFrameProperty(2, BrushUtil.g(this.r == 2 ? 255 : 0, 255, 255, 255))));
            }
            if (this.y == null) {
                this.y = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(7, this.ct)).m(new AnimationKeyFrameProperty(7, this.cq)));
            }
        }
        cd(a, b) {
            if ((b > 0 && a.playbackRate < 0) || (b < 0 && a.playbackRate > 0)) {
                a.reverse();
                a.finished.f((c) => {
                    a.commitStyles();
                    if (a == this.z && this.ag) {
                        this.z = null;
                    }
                    if (a == this.y && this.af) {
                        this.y = null;
                    }
                });
            }
            else {
                a.play();
                a.finished.f((c) => {
                    a.commitStyles();
                    if (a == this.z && this.ag) {
                        this.z = null;
                    }
                    if (a == this.y && this.af) {
                        this.y = null;
                    }
                });
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "BaseTheme":
                    this.cf(this.l);
                    this.ch();
                    break;
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                case "HighlightTextColor":
                case "HoverHighlightTextColor":
                    this.ch();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                case "ActualHighlightTextColor":
                case "ActualHoverHighlightTextColor":
                    if (this.z != null) {
                        if (this.z.playState == 3) {
                            this.z = null;
                        }
                        else {
                            this.ag = true;
                        }
                    }
                    if (this.y != null) {
                        if (this.y.playState == 3) {
                            this.y = null;
                        }
                        else {
                            this.af = true;
                        }
                    }
                    this.cg();
                    break;
                case "Text":
                    this.view.aa();
                    break;
                case "Density":
                    this.o = this.p == 0 ? 1 : this.p;
                    break;
                case "ActualDensity":
                    this.view.ac();
                    this.view.ab();
                    break;
                case "InputGroup":
                    this.view.ab();
                    break;
                case "IsHighlighted":
                    this.b7();
                    break;
                case "IsShifted":
                    this.b8();
                    break;
                case "ShiftType":
                    if (this.z != null) {
                        if (this.z.playState == 3) {
                            this.z = null;
                        }
                        else {
                            this.ag = true;
                        }
                    }
                    this.cb();
                    break;
                case "Display":
                    this.view.v();
                    break;
                case "FlexDirection":
                    this.view.w();
                    break;
                case "FlexGrow":
                    this.view.x();
                    break;
                case "AlignItems":
                    this.view.r();
                    break;
            }
        }
        cb() {
            this.view.ab();
        }
        b8() {
            this.b4();
            let a = 1;
            let b = this.am;
            if (!b) {
                a = -1;
            }
            this.cd(this.z, a);
        }
        b7() {
            this.b4();
            let a = 1;
            let b = this.ak;
            if (!b) {
                a = -1;
            }
            this.cd(this.y, a);
        }
        ch() {
            this.ct = this.c9 != null ? this.c9 : Label.c5;
            this.cs = this.c8 != null ? this.c8 : Label.c5;
            this.cq = this.c6 != null ? this.c6 : Label.cy;
        }
        cg() {
            if (this.v != null) {
                this.view.ae(this.v);
            }
            NativeUI.n(this.view.i.rootWrapper, this.ct);
        }
        cf(a) {
            Label.c5 = ThemeResolver.e(a, Label.c4, Label.cx);
            Label.cy = ThemeResolver.e(a, Label.c1, Label.cu);
            Label.c0 = ThemeResolver.e(a, Label.c3, Label.cw);
            Label.cz = ThemeResolver.e(a, Label.c2, Label.cv);
        }
        get p() {
            return this.n;
        }
        set p(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get o() {
            return this.m;
        }
        set o(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get ct() {
            return this.cl;
        }
        set ct(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.g("ActualTextColor", b, a);
            }
        }
        get cq() {
            return this.ci;
        }
        set cq(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.g("ActualHighlightTextColor", b, a);
            }
        }
        get cr() {
            return this.cj;
        }
        set cr(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.g("ActualHoverHighlightTextColor", b, a);
            }
        }
        get cs() {
            return this.ck;
        }
        set cs(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get v() {
            return this.t;
        }
        set v(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get c9() {
            return this.cp;
        }
        set c9(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.g("TextColor", b, a);
            }
        }
        get c6() {
            return this.cm;
        }
        set c6(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.g("HighlightTextColor", b, a);
            }
        }
        get c7() {
            return this.cn;
        }
        set c7(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.g("HoverHighlightTextColor", b, a);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.g("ShiftType", enumGetBox(LabelShiftType_$type, b), enumGetBox(LabelShiftType_$type, a));
            }
        }
        get am() {
            return this.ae;
        }
        set am(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.g("IsShifted", b, a);
            }
        }
        get ak() {
            return this.ac;
        }
        set ak(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.g("IsHighlighted", b, a);
            }
        }
        b9() {
            this.al = true;
        }
        ca() {
            this.al = false;
        }
        get x() {
            return this.u;
        }
        set x(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("TextStyle", b, a);
            }
        }
        get b0() {
            return this.a0;
        }
        set b0(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.g("Type", b, a);
            }
        }
        get c8() {
            return this.co;
        }
        set c8(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.g("HoverTextColor", b, a);
            }
        }
        get bo() {
            return this.ay;
        }
        set bo(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.g("Id", b, a);
            }
        }
        get bd() {
            return this.au;
        }
        set bd(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.g("Display", b, a);
            }
        }
        get bf() {
            return this.av;
        }
        set bf(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.g("FlexDirection", b, a);
            }
        }
        get bh() {
            return this.aw;
        }
        set bh(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.g("FlexGrow", b, a);
            }
        }
        get a7() {
            return this.as;
        }
        set a7(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.g("AlignItems", b, a);
            }
        }
        get ai() {
            return this.aa;
        }
        get aq() {
            return this.ap;
        }
        set aq(a) {
            let b = this.ap;
            this.ap = a;
            this.aa = true;
            if (b != this.ap) {
                this.g("TabIndex", b, a);
            }
        }
        get bj() {
            return this.ax;
        }
        set bj(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.g("TabIndex", b, a);
            }
        }
        get a9() {
            return this.at;
        }
        set a9(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.g("AriaLabel", b, a);
            }
        }
        get text() {
            return this.az;
        }
        set text(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.g("Text", b, a);
            }
        }
        get al() {
            return this.ad;
        }
        set al(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.g("IsHover", b, a);
            }
        }
        get ao() {
            return this.ah;
        }
        set ao(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.g("Value", b, a);
            }
        }
        get disabled() {
            return this.ab;
        }
        set disabled(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.g("IsDisabled", b, a);
            }
        }
        cc() {
            this.view.aa();
        }
        onDetachedFromUI() {
            this.view.u();
        }
        onAttachedToUI() {
            this.view.s();
        }
        an() {
            return this.view.e();
        }
        provideContainer(a) {
            this.view.t(a);
        }
    }
    Label.$t = /*@__PURE__*/ markType(Label, 'Label', InputGroupItem.$);
    Label.c4 = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Label.c1 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    Label.c3 = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Label.c2 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    Label.cx = /*@__PURE__*/ BrushUtil.g(255, 24, 29, 31);
    Label.cu = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Label.cw = /*@__PURE__*/ BrushUtil.g(255, 24, 29, 31);
    Label.cv = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Label.k = 2;
    Label.c5 = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.c4, Label.cx);
    Label.cy = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.c1, Label.cu);
    Label.c0 = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.c3, Label.cw);
    Label.cz = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.c2, Label.cv);
    Label.w = null;
    Label.ar = 0;
    return Label;
})();
/**
 * @hidden
 */
export let Input = /*@__PURE__*/ (() => {
    class Input extends InputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.o = 0;
            this.j = 1;
            this.i = 1;
            this.bu = Input.b0;
            this.bt = Input.bz;
            this.r = null;
            this.bw = Input.b0;
            this.s = null;
            this.am = "text";
            this.al = "text";
            this.bv = null;
            this.ak = "ig-input-" + Input.ah++;
            this.af = 0;
            this.w = false;
            this.aj = null;
            this.ai = null;
            this.z = false;
            this.an = null;
            this.y = false;
            this.x = false;
            this.change = null;
            this.changing = null;
            let a = new InputView();
            a.a = this;
            this.view = a;
            this.view.x();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.g("ShiftType", enumGetBox(InputShiftType_$type, b), enumGetBox(InputShiftType_$type, a));
            }
        }
        get l() {
            return this.j;
        }
        set l(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                    this.bs();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                    this.br();
                    break;
                case "Value":
                    if (!this.x) {
                        this.view.ab(this.ba);
                    }
                    break;
                case "Density":
                    this.k = this.l == 0 ? 1 : this.l;
                    break;
                case "ActualDensity":
                    this.view.ad();
                    this.view.ac();
                    break;
                case "InputGroup":
                    this.bj();
                    break;
                case "ShiftType":
                    this.bn();
                    break;
                case "Type":
                    this.bo();
                    break;
                case "Placeholder":
                    this.bm();
                    break;
            }
        }
        bm() {
            this.view.z();
        }
        bo() {
            this.view.aa();
        }
        bn() {
            this.view.ac();
        }
        bj() {
            this.view.ac();
        }
        bs() {
            this.by = this.b2 != null ? this.b2 : Input.b0;
            this.bx = this.b1 != null ? this.b1 : Input.b0;
        }
        br() {
            if (this.t != null) {
                this.view.af(this.t);
            }
            NativeUI.n(this.view.k, this.by);
        }
        get by() {
            return this.bu;
        }
        set by(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.g("ActualTextColor", b, a);
            }
        }
        get bx() {
            return this.bt;
        }
        set bx(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get t() {
            return this.r;
        }
        set t(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get b2() {
            return this.bw;
        }
        set b2(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.g("TextColor", b, a);
            }
        }
        be() {
            if (this.b != null) {
                this.b.lz(this);
            }
        }
        bi() {
            if (this.b != null) {
                this.b.l0(this);
            }
        }
        bf() {
            this.x = true;
            this.ba = this.view.m();
            if (this.change != null) {
                this.change(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.ba;
                    return $ret;
                })()));
            }
            this.x = false;
        }
        bg() {
            this.x = true;
            this.ba = this.view.m();
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.ba;
                    return $ret;
                })()));
            }
            this.x = false;
        }
        bk() {
            this.ad = true;
        }
        bl() {
            this.ad = false;
        }
        get v() {
            return this.s;
        }
        set v(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.g("TextStyle", b, a);
            }
        }
        get a8() {
            return this.am;
        }
        set a8(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.g("Type", b, a);
            }
        }
        get a2() {
            return this.al;
        }
        set a2(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.g("Placeholder", b, a);
            }
        }
        get b1() {
            return this.bv;
        }
        set b1(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.g("HoverTextColor", b, a);
            }
        }
        get ay() {
            return this.ak;
        }
        set ay(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.g("Id", b, a);
            }
        }
        get aa() {
            return this.w;
        }
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.af;
            this.af = a;
            this.w = true;
            if (b != this.af) {
                this.g("TabIndex", b, a);
            }
        }
        get av() {
            return this.aj;
        }
        set av(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.g("TabIndex", b, a);
            }
        }
        get as() {
            return this.ai;
        }
        set as(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.g("AriaLabel", b, a);
            }
        }
        get ad() {
            return this.z;
        }
        set ad(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.g("IsHover", b, a);
            }
        }
        get ba() {
            return this.an;
        }
        set ba(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.g("Value", b, a);
            }
        }
        get ab() {
            return !stringIsNullOrEmpty(this.ba);
        }
        get disabled() {
            return this.y;
        }
        set disabled(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.g("IsDisabled", b, a);
            }
        }
        bp() {
        }
        onDetachedFromUI() {
            this.view.w();
        }
        onAttachedToUI() {
            this.view.u();
        }
        ae() {
            return this.view.d();
        }
        provideContainer(a) {
            this.view.v(a);
        }
    }
    Input.$t = /*@__PURE__*/ markType(Input, 'Input', InputGroupItem.$);
    Input.b0 = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Input.bz = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Input.u = null;
    Input.ah = 0;
    return Input;
})();
//# sourceMappingURL=InputGroupView_combined.js.map
